name = "The Liar Princess and the Blind Prince Don't Starve"
description = "Guide a blind prince as a princess with a dark secret. Based on the game of the same name."
author = "Sir Jackenstire"
version = "1.9.1"
forumthread = "http://forums.kleientertainment.com"
dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true
api_version = 6
icon_atlas = "modicon.xml"
icon = "modicon.tex"



local alpha = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
local KEY_A = 97
local keyslist = {}
for i = 1,#alpha do keyslist[i] = {description = alpha[i],data = i + KEY_A - 1} end

configuration_options =
{

    {
        name = "WOLF_TOGGLE_KEY",
        label = "Wolf Toggle Button",
        hover = "The key that enables Princess to shift into Wolf and back",
        options = keyslist,
        default = 109, --M
    },

    {
        name = "PRINCE_CALL_KEY",
        label = "Prince Calling Button",
        hover = "A key for calling Prince without mousing over to him",
        options = keyslist,
        default = 99, --C
    },

    {
        name = "ENABLE_MUSIC",
        label = "Liar Princess Music",
        hover = "Choose whether you want the Liar Princess music to play or not",
        options =	{
						{description = "Yes", data = "yes"},
						{description = "No", data = "no"},
					},

		default = "yes",
    },

}

--CURRENT ISSUES
--Prince is unaffected by fog. Should this stay this way?
--Prince's cloak's sprite gets all funny during Prince's shadow hand teleporting animation.
--The main theme doesn't immediately change after configuring music settings. It does play the correct music after reloading the game, however.
--Vanilla Don't Starve crashes when exiting a save while Prince is talking. The game is still saved before the crash.
--Prince reverts to a limbo state when he shouldn't if telelocated a far distance, when players use a wormhole without him, or when left in an indoor room in Hamlet saves. Prince will return to normal when in render distance or when the save is reloaded.
--Prince will leave behind Chester if he goes to a cave with an eye bone, and will spawn a new Chester in the cave.


--!!TO FIX/ADD!!--
--Fix a crash related to Prince's armor breaking, maybe?
--Add controller support?
--Smallbirds will no longer imprint onto Princess upon hatching, but will instead imprint onto Prince as long as he's nearby. (they won't follow Prince in or out of caves for now)

--FIXED AND CHANGED IN UPDATE 1.9.0:
-- Entities near Prince will now remain active even if the player is far away from Prince.
-- Prince is now susceptible to hound, crocodog, depths worm and vampire bat attacks, effectively doubling the frequency and potency of these monster waves.
-- Made Prince lose sanity when Princess jumps through wormholes with him.
-- Prince's attack power is now 1/5 weaker than the player's default attack power. (he deals 60% damage)
-- Made Prince starve slightly faster with a smaller stomach.
-- Prince's digging speed is slightly slower now.
-- Prince should now prioritize eating food with positive hunger values when he has food in his inventory and is starving.
-- Wolf's attacks will no longer damage each sprite of the Pugalisk. She can still swipe Pugalisk twice in a row, though.
-- Fixed a problem where Prince would still attempt to attack with a worn out weapon.
-- Prince should more consistently realize when he's in the dark after mounting/dismounting boats.
-- Fixed Prince not being able to wake up and run away if he's being attacked in his sleep.
-- Stopped Prince's follower component from warping him back to the player when he's telelocated while following.
-- Prince will now teleport to the player's location if he lands on water when he's supposed to dismount on dry land.
-- Fixed an issue where Prince would lose his currently held tool if a pretty parasol rots in his inventory.
-- Moose and Bearger should disarm Prince more properly now.
-- Fixed a problem with equippable items interacting weirdly with Wolf when she picks them up. They should now be dropped on the floor consistently.
-- Fixed an issue where Wolf could get stunlocked too easily.
-- Fixed an issue where Wolf would be able to examine things that shouldn't be examined.
-- Prince will now follow Princess to another world if Princess dies and resurrects in another world.
-- Princess should no longer immediately die when resurrecting in a separate world from the world she died in.
-- Princess should no longer die immediately when changing forms after being resurrected.
-- Princess should no longer transform into Wolf during the day when the next night is a full moon.
-- Wolf should no longer get electrocuted when attacking while wet in Reign of Giants saves.
-- Fixed a crash when the Roc (BFB) spawns.
-- Adjusted some dialogue.

--FIXED AND CHANGED IN UPDATE 1.8.91:
--Made Prince chop trees slightly faster (should be as fast as the player now).
--Fixed a crash when entering a volcano.
--Fixed a crash when Prince summons the Quacken.
--Fixed an error where Prince wouldn't turn on an available light after dismounting or mounting a boat.

--FIXED AND CHANGED IN UPDATE 1.8.9:
--Made Prince's garland sanity boost weaker (it's still stronger than the default garland boost)
--Prince will no longer swap a worn life-giving amulet when in combat.

--FIXED AND CHANGED IN UPDATE 1.8.8:
--Fixed an issue where world hopping in the tropics would regenerate caves and world hopping outside of the tropics would regenerate the volcano.
--Revised some dialogue.

--FIXED AND CHANGED IN UPDATE 1.8.7:
--Added missing dialogue and revised some older dialogue.

--FIXED AND CHANGED IN UPDATE 1.8.6:
--Made Wolf react to lightning
--!!!Princess's pugalisk skull dialogue needs to be changed! DONE
--!!!Dead spider typo! DONE
--!!!FIX PRINCE NOT FEEDING HIMSELF WHEN ISOLATED INDOORS/OUTDOORS! DONE
--FIX SHADOW CREATURES NOT SPAWNING FOR PRINCE! DONE
--Fix garlands and pretty parasols crashing when given to Prince! DONE



--FIXED AND CHANGED IN UPDATE 1.8.5:
--Prince will no longer accept items when he's dead.
--Prince can no longer be healed with healing items when he's dead.


--FIXED AND CHANGED IN UPDATE 1.8.4:
--Prince will now wear the most effective waterproof clothing in his inventory if he has multiple.
--Made Prince chop, mine, dig and hack faster.
--Prince will now keep his bush hat or snurtle shell on, no matter the weather.
--Added missing dialogue and changed other lines for Princess.


--FIXED AND CHANGED IN UPDATE 1.8.3:
--Fixed a problem where Princess would still gain sanity feeding Prince stale food.
--Made Princess's sanity loss more consistent when feeding Prince spoiled food.
--Made Prince snap out of his fishing state if Princess calls him to follow.
--Made Prince stop fishing if he hasn't caught a fish within a minute or longer.
--Prince won't accept equippables while fishing.


--FIXED AND CHANGED IN UPDATE 1.8.2:
--Fixed a crash with AoE attacks from other creatures in Shipwrecked/Hamlet enabled saves.
--Fixed a problem where Prince would still be referred to as "wet" even when he is dry in Shipwrecked/Hamlet saves.


--FIXED AND CHANGED IN UPDATE 1.8.1:
--Made Wolf and Prince affected by Queen Womant's music attack.
--Prince's hiding now works as intended.
--Fixed a Shipwrecked/Hamlet crash involving Prince's armor breaking.
--Fixed an error where Prince wouldn't have his stats affected when he's fed while his container is open.


--FIXED AND CHANGED IN UPDATE 1.8.0:
--Wolf's health is now more consistent when loading the game in Wolf form.
--Fixed unintentional dialogue when failing to give Prince an item.
--Stopped Princess from negatively commenting about fresh monster meat foods.
--Fixed a bug where Prince would idle talk instead of helping out with work in Shipwrecked and Hamlet worlds.
--Made Princess lose sanity from giving Prince very harmful food.
--Princess no longer gains sanity from feeding Prince food that isn't fresh.
--Made Prince lose his fishing rod for good when his fishing rod is taken by a fish.
--Prince's inventory will not close when the player feeds him.
--Made poison work on Prince the same way it works on players. (it lasts longer on him)
--Adjusted Wolf's interaction controls.
--Wolf can now stack items on the floor.
--Wolf's health regen is now 3 HP every 10 seconds.
--Prince will stay hiding even when talking.
--Prince will now drop items when sneezing, just like the player.
--Adjusted some of Prince's brain code.
--The BFB is now scared of Wolf.
--Made the daytime sailing music loop more properly.