GLOBAL.LIARPRINCESS = {
    WOLF_TOGGLE_KEY = GetModConfigData("WOLF_TOGGLE_KEY"),
    PRINCE_CALL_KEY = GetModConfigData("PRINCE_CALL_KEY"),
}

local require = GLOBAL.require
local assert = GLOBAL.assert
require "stategraph"

--The separate PrefabFiles is because Prince's swimming horror code (prince_shadowcreature_sea) crashes saves without the SW or H DLC.
if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
PrefabFiles = {
    --This is the name of our prefab file in scripts/prefabs
    --"wolfie",
    "princess",
    "prince",
    "princecloak",
    "prince_shadowcreature",
    "prince_shadowcreature_sea",
}
else
PrefabFiles = {
	--This is the name of our prefab file in scripts/prefabs
	--"wolfie",
	"princess",
	"prince",
    "princecloak",
    "prince_shadowcreature",
}
end

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/princess.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/princess.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/princess.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/princess.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/princess.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/princess.xml" ),

    Asset( "IMAGE", "bigportraits/princess.tex" ),
    Asset( "ATLAS", "bigportraits/princess.xml" ),

	Asset( "IMAGE", "minimap/princess_icon.tex" ),
	Asset( "ATLAS", "minimap/princess_icon.xml" ),

        Asset( "ANIM", "anim/princess.zip" ),
        --Asset( "ANIM", "anim/prince.zip" ),
        Asset( "ANIM", "anim/princecloak.zip" ),
        

                                                --Asset("SOUNDPACKAGE", "sound/princess.fev"),	
	                                           --Asset("SOUND", "sound/princess.fsb"),

    Asset( "IMAGE", "minimap/prince_icon.tex" ),
    Asset( "ATLAS", "minimap/prince_icon.xml" ),



    --Asset( "ANIM", "anim/wolf.zip" ),
    --Asset( "ANIM", "anim/wolf_drowning.zip" ),

        Asset("SOUNDPACKAGE", "sound/music_mod.fev"),
        Asset("SOUND", "sound/TheLiarPrincessandtheBlindPrince.fsb"),

}

AddMinimapAtlas("minimap/princess_icon.xml")

AddMinimapAtlas("minimap/prince_icon.xml")

GLOBAL.STRINGS.CHARACTER_TITLES.princess = "The Inseparable"
GLOBAL.STRINGS.CHARACTER_NAMES.princess = "The Liar Princess"  -- Note! This line is especially important as some parts of the game require
                                            -- the character to have a valid name.
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.princess = "*A princess with a dark secret and a fear of fire...\n*A defenseless, blind prince afraid of monsters...\n*The two share a bond; in life and in death"
GLOBAL.STRINGS.CHARACTER_QUOTES.princess = "\"The moonlight concert, our secret...\""

GLOBAL.STRINGS.CHARACTERS.PRINCESS = {}
GLOBAL.STRINGS.CHARACTERS.PRINCESS.DESCRIBE = {}

-- Possible genders here are MALE, FEMALE, or ROBOT
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "PRINCESS")


--Play Liar Princess and Great Hero music if allowed!
if (GetModConfigData("ENABLE_MUSIC") == "yes" and GetModConfigData("ENABLE_MUSIC") ~= "no") then


    RemapSoundEvent( "dontstarve/music/music_FE", "music_mod/music/music_FE" )

    RemapSoundEvent( "dontstarve/music/music_danger", "music_mod/music/music_danger" )
    RemapSoundEvent( "dontstarve/music/music_danger_winter", "music_mod/music/music_danger" )


    RemapSoundEvent( "dontstarve/music/music_danger_cave", "music_mod/music/music_danger_cave" )
    RemapSoundEvent( "dontstarve/music/music_danger_ruins", "music_mod/music/music_danger_ruins" )

    RemapSoundEvent( "dontstarve/music/music_dawn_stinger", "music_mod/music/music_dawn_stinger" )
    RemapSoundEvent( "dontstarve/music/music_dusk_stinger", "music_mod/music/music_dusk_stinger" )
    --For befriending pigs and the like!
    RemapSoundEvent( "dontstarve/common/makeFriend", "music_mod/music/makefriend" )

    RemapSoundEvent( "dontstarve/music/musing_dusk_stinger crazy", "music_mod/music/musing_dusk_stinger" )

    RemapSoundEvent( "dontstarve/music/music_epicfight", "music_mod/music/music_epicfight" )
    RemapSoundEvent( "dontstarve/music/music_epicfight_winter", "music_mod/music/music_epicfight" )


    RemapSoundEvent( "dontstarve/music/music_epicfight_cave", "music_mod/music/music_epicfight_cave" )
    RemapSoundEvent( "dontstarve/music/music_epicfight_ruins", "music_mod/music/music_epicfight_ruins" )
--RemapSoundEvent( "dontstarve/music/music_hoedown", "music_mod/music/music_hoedown" )
--RemapSoundEvent( "dontstarve/music/music_test_parm", "music_mod/music/music_test_parm" )

    RemapSoundEvent( "dontstarve/music/music_work", "music_mod/music/music_work" )
    RemapSoundEvent( "dontstarve/music/music_work_winter", "music_mod/music/music_work_winter" )

    RemapSoundEvent( "dontstarve/music/music_work crazy", "music_mod/music/music_work crazy" )
    RemapSoundEvent( "dontstarve/music/music_work_cave", "music_mod/music/music_work_cave" )
    RemapSoundEvent( "dontstarve/music/music_work_ruins", "music_mod/music/music_work_ruins" )

    RemapSoundEvent( "dontstarve/sanity/gonecrazy_stinger", "music_mod/music/gonecrazy_stinger" )

    if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then
        RemapSoundEvent( "dontstarve_DLC001/music/music_work_spring", "music_mod/music/music_work_spring" )
        RemapSoundEvent( "dontstarve_DLC001/music/music_work_summer", "music_mod/music/music_work_summer" )

        RemapSoundEvent( "dontstarve_DLC001/music/music_danger_spring", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC001/music/music_danger_summer", "music_mod/music/music_danger" )

        RemapSoundEvent( "dontstarve_DLC001/music/music_epicfight_spring", "music_mod/music/music_epicfight" )
        RemapSoundEvent( "dontstarve_DLC001/music/music_epicfight_summer", "music_mod/music/music_epicfight" )
    end

    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then
        RemapSoundEvent( "dontstarve_DLC002/music/music_FE", "music_mod/music/music_FE" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_work_season_1", "music_mod/music/music_work_season_1" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_work_season_2", "music_mod/music/music_work_season_2" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_work_season_3", "music_mod/music/music_work_season_3" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_work_season_4", "music_mod/music/music_work_season_4" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_dawn_stinger", "music_mod/music/music_dawn_stinger" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_dusk_stinger", "music_mod/music/music_dusk_stinger" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_sailing_day", "music_mod/music/music_sailing_day" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_sailing_night", "music_mod/music/music_sailing_night" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_volcano_active", "music_mod/music/music_volcano_active" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_volcano_dormant", "music_mod/music/music_volcano_dormant" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_danger_season_1", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_danger_season_2", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_danger_season_3", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_danger_season_4", "music_mod/music/music_danger" )

        RemapSoundEvent( "dontstarve_DLC002/music/music_epicfight_season_1", "music_mod/music/music_epicfight" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_epicfight_season_2", "music_mod/music/music_epicfight" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_epicfight_season_3", "music_mod/music/music_epicfight" )
        RemapSoundEvent( "dontstarve_DLC002/music/music_epicfight_season_4", "music_mod/music/music_epicfight" )
    end

    if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        RemapSoundEvent( "dontstarve_DLC003/music/theme", "music_mod/music/music_FE" )

        RemapSoundEvent( "dontstarve_DLC003/music/working_1", "music_mod/music/working_1" )
        RemapSoundEvent( "dontstarve_DLC003/music/working_2", "music_mod/music/working_2" )
        RemapSoundEvent( "dontstarve_DLC003/music/working_3", "music_mod/music/working_3" )

        RemapSoundEvent( "dontstarve_DLC003/music/deeprainforest_enter_1", "music_mod/music/deeprainforest_enter" )
        RemapSoundEvent( "dontstarve_DLC003/music/deeprainforest_enter_2", "music_mod/music/deeprainforest_enter" )
        RemapSoundEvent( "dontstarve_DLC003/music/deeprainforest_enter_3", "music_mod/music/deeprainforest_enter" )

        RemapSoundEvent( "dontstarve_DLC003/music/ruins_enter", "music_mod/music/ruins_enter" )
        RemapSoundEvent( "dontstarve_DLC003/music/ruins_enter_2", "music_mod/music/ruins_enter" )
        RemapSoundEvent( "dontstarve_DLC003/music/ruins_enter_3", "music_mod/music/ruins_enter" )

        RemapSoundEvent( "dontstarve_DLC003/music/dawn_stinger_1_temperate", "music_mod/music/music_dawn_stinger" )
        RemapSoundEvent( "dontstarve_DLC003/music/dawn_stinger_2_humid", "music_mod/music/music_dawn_stinger" )
        RemapSoundEvent( "dontstarve_DLC003/music/dawn_stinger_3_lush", "music_mod/music/music_dawn_stinger" )

        RemapSoundEvent( "dontstarve_DLC003/music/dusk_stinger_1_temperate", "music_mod/music/music_dusk_stinger" )
        RemapSoundEvent( "dontstarve_DLC003/music/dusk_stinger_2_humid", "music_mod/music/music_dusk_stinger" )
        RemapSoundEvent( "dontstarve_DLC003/music/dusk_stinger_3_lush", "music_mod/music/music_dusk_stinger" )

        RemapSoundEvent( "dontstarve_DLC003/music/fight_1", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC003/music/fight_2", "music_mod/music/music_danger" )
        RemapSoundEvent( "dontstarve_DLC003/music/fight_3", "music_mod/music/music_danger" )

        RemapSoundEvent( "dontstarve_DLC003/music/fight_4", "music_mod/music/fight_4" )
        RemapSoundEvent( "dontstarve_DLC003/music/fight_epic_1", "music_mod/music/music_epicfight" )
        RemapSoundEvent( "dontstarve_DLC003/music/fight_epic_4", "music_mod/music/fight_epic_4" )
        RemapSoundEvent( "dontstarve_DLC003/music/aporkalypse", "music_mod/music/aporkalypse" )

        RemapSoundEvent( "dontstarve_DLC003/music/iron_lord", "music_mod/music/makefriend" )
        RemapSoundEvent( "dontstarve_DLC003/music/iron_lord_suit", "music_mod/music/fight_epic_4" )
    end

end


--Space for new action!
local require = GLOBAL.require
GLOBAL.FA_ModUtil={}
FA_ModUtil=GLOBAL.FA_ModUtil

FA_ModUtil.AddAction=AddAction

require "fa_actions"
require "fa_strings"
require "fa_update"
require "fa_periodicthreats"

local next = GLOBAL.next
local easing = require "easing"

local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local ActionHandler=GLOBAL.ActionHandler

local save=GLOBAL.SaveIndex
local EntityScript = GLOBAL.EntityScript

AddAction(ACTIONS.HOLDHAND)

local function WolfToggle()
    if not GLOBAL.IsPaused() then --Try to prevent action when game is paused or when not in a game file!
        local player = GLOBAL.GetPlayer()
        if GLOBAL.GetPlayer() and player.prefab == "princess" and not player:HasTag("ironlord") then --Prevent menu bugs, make sure other characters don't use this, and prevent Princess from doing this when she uses the Living Artifact!
            if not (GLOBAL.GetClock():IsNight() and GLOBAL.GetClock():GetMoonPhase() == "full") then --Prevents Wolf from turning into a princess during the full moon!
                if player.IsWolf then
                    player:PushEvent("transform_to_princess")
                else
                    player:PushEvent("transform_to_wolf")
                end
            end
        end
    end
end

local function PrinceCall()
    if not GLOBAL.IsPaused() then --Try to prevent action when game is paused or when not in a game file!
        local player = GLOBAL.GetPlayer()
        if GLOBAL.GetPlayer() and player.prefab == "princess" and not player:HasTag("ironlord") and not player:HasTag("wolf") and not player:HasTag("teleporting") and player.is_teleporting ~= true then --Prevent menu bugs, make sure other characters don't use this, and prevent Princess from doing this when she uses the Living Artifact!
            local x,y,z = player.Transform:GetWorldPosition() 
            local ents = TheSim:FindEntities(x,y,z, 20, {"blindprince"})
            for k,v in pairs(ents) do 
                if player.components.leader and v.components.follower and not v.components.follower.leader then
            
                    player.components.leader:AddFollower(v)

                        if v.sg:HasStateTag("asleep") then

                            v.sg:GoToState("wakeup")

                            if player.prefab == "princess" then

                                local wakingprincess = {"Wake up, Prince.", "Are you OK, Prince?"}
                                player.components.talker:Say(wakingprincess[math.random(1, #wakingprincess)])

                            end

                        else

                        if player.prefab == "princess" and player:HasTag("liarprincess") then

                            local happyprincess = {"I'm over here, Prince!", "Here I am, Prince!", "Hello, Prince!", "This way, Prince."}
                            player.components.talker:Say(happyprincess[math.random(1, #happyprincess)])

                            v:DoTaskInTime(0.5, function()
                                if v.components.follower and v.components.follower.leader then
                                    local happyprince = {"I'm coming, Princess!", "There you are, Princess.", "Hello, Princess.", "You're back!"}
                                    v.components.talker:Say(happyprince[math.random(1, #happyprince)])
                                end
                            end)
                        elseif player.prefab ~= "princess" then
                            v:DoTaskInTime(0.5, function()
                                if v.components.follower and v.components.follower.leader then
                                    local confusedprince = {"Why are you helping me?", "Who are you?", "I don't recognize your voice.", "What do you want with me?"}
                                    v.components.talker:Say(confusedprince[math.random(1, #confusedprince)])
                                end
                            end)
                        end

                    end

                else

                v.components.follower:StopFollowing()

                    if v.sg:HasStateTag("asleep") then

                        v.sg:GoToState("wakeup")

                        if player.prefab == "princess" then

                            local wakingprincess = {"Wake up, Prince.", "Are you OK, Prince?"}
                            player.components.talker:Say(wakingprincess[math.random(1, #wakingprincess)])

                        end

                    else

                        if player.prefab == "princess" then

                            local leavingprincess = {"Wait right here, OK Prince?", "I'll be back, Prince.", "Stay here, Prince.", "I won't be long, Prince."}
                            player.components.talker:Say(leavingprincess[math.random(1, #leavingprincess)])

                            v:DoTaskInTime(1, function()
                                local waitingprince = {"I'll wait for you, Princess.", "Be careful, Princess.", "Take care, Princess.", "Be safe, Princess."}
                                v.components.talker:Say(waitingprince[math.random(1, #waitingprince)])
                            end)
                        elseif player.prefab ~= "princess" then
                            v:DoTaskInTime(1, function()
                                local waitingprince = {"I'll be here.", "Goodbye, then."}
                                v.components.talker:Say(waitingprince[math.random(1, #waitingprince)])
                            end)
                        end

                    end

                end

            end
        end
    end
end

GLOBAL.TheInput:AddKeyUpHandler(GLOBAL.LIARPRINCESS.WOLF_TOGGLE_KEY, WolfToggle)
GLOBAL.TheInput:AddKeyUpHandler(GLOBAL.LIARPRINCESS.PRINCE_CALL_KEY, PrinceCall)

AddModCharacter("princess")
--AddModCharacter("prince")


GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.PRINCE = "That poor kid can't see."
GLOBAL.STRINGS.CHARACTERS.WILLOW.DESCRIBE.PRINCE = "What happened to you?"
GLOBAL.STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.PRINCE = "Little man is blind."
GLOBAL.STRINGS.CHARACTERS.WENDY.DESCRIBE.PRINCE = "He is still not blind to the horrors of the world."
GLOBAL.STRINGS.CHARACTERS.WX78.DESCRIBE.PRINCE = "HE IS BLIND AND FEEBLE. I FIND THAT FUNNY"
GLOBAL.STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.PRINCE = "Poor child, what has happened to you?"
GLOBAL.STRINGS.CHARACTERS.WOODIE.DESCRIBE.PRINCE = "Lost your eyesight, eh?"
GLOBAL.STRINGS.CHARACTERS.WAXWELL.DESCRIBE.PRINCE = "Whatever happened to you must've been quite gruesome."

GLOBAL.STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.PRINCE = "A prince without his shieldmaiden."
GLOBAL.STRINGS.CHARACTERS.WEBBER.DESCRIBE.PRINCE = "Don't be afraid, we're not going to hurt you!"
GLOBAL.STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.PRINCE = "I can only surmise that a monster has rendered him blind."

GLOBAL.STRINGS.CHARACTERS.WALANI.DESCRIBE.PRINCE = "Poor little dude."
GLOBAL.STRINGS.CHARACTERS.WARLY.DESCRIBE.PRINCE = "What has happened to you, mon amie?"
GLOBAL.STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.PRINCE = "Apologies, but I ain't takin' ye as me shipmate!"

GLOBAL.STRINGS.CHARACTERS.WILBA.DESCRIBE.PRINCE = "'TIS A BLINDED, REGAL UNPIG"
GLOBAL.STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.PRINCE = "Blind friend?"
GLOBAL.STRINGS.CHARACTERS.WHEELER.DESCRIBE.PRINCE = "Yikes, the little guy's lost his eyes."


GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.PRINCECLOAK = "It's prince-sized."
GLOBAL.STRINGS.CHARACTERS.WILLOW.DESCRIBE.PRINCECLOAK = "This is supposed to look royal?"
GLOBAL.STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.PRINCECLOAK = "Is fancy cloak."
GLOBAL.STRINGS.CHARACTERS.WENDY.DESCRIBE.PRINCECLOAK = "A small comfort."
GLOBAL.STRINGS.CHARACTERS.WX78.DESCRIBE.PRINCECLOAK = "WHO CARES?"
GLOBAL.STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.PRINCECLOAK = "An adornment that denotes royalty."
GLOBAL.STRINGS.CHARACTERS.WOODIE.DESCRIBE.PRINCECLOAK = "It's not my style."
GLOBAL.STRINGS.CHARACTERS.WAXWELL.DESCRIBE.PRINCECLOAK = "It's only vaguely regal."

GLOBAL.STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.PRINCECLOAK = "A robe fit for a prince."
GLOBAL.STRINGS.CHARACTERS.WEBBER.DESCRIBE.PRINCECLOAK = "Does it look good on me?"
GLOBAL.STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.PRINCECLOAK = "This cloak's material dates back to a time long, long ago. Fascinating!"

GLOBAL.STRINGS.CHARACTERS.WALANI.DESCRIBE.PRINCECLOAK = "I guess I can chill out in this."
GLOBAL.STRINGS.CHARACTERS.WARLY.DESCRIBE.PRINCECLOAK = "Who could this belong to?"
GLOBAL.STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.PRINCECLOAK = "'Tis worthless to me."

GLOBAL.STRINGS.CHARACTERS.WILBA.DESCRIBE.PPRINCECLOAK = "'TIS A CLOAK OF UNPIG ROYALTY"
GLOBAL.STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.PRINCECLOAK = "Fancy. Cozy."
GLOBAL.STRINGS.CHARACTERS.WHEELER.DESCRIBE.PRINCECLOAK = "It flutters when I run."










--This is to handle entities that persist near Prince or not!
AddPrefabPostInitAny(function(inst)

    if inst
    and (inst.components.health or inst.components.pickable or 
    --(
    inst.components.inventoryitem 
    --and inst.components.inventoryitem.owner ~= nil) 
    or inst.components.combat or inst.Physics)
    and inst ~= GLOBAL.GetPlayer() 
    and inst.prefab ~= "prince" 
    and not inst:HasTag("ground") 
    and not inst:HasTag("minimap")
    and not inst:HasTag("player")
    and not inst.components.prince_anti_persister 
    and not inst.components.prince_persister then
        inst:AddComponent("prince_anti_persister")
    end

end)


--Make Prince's hounded configurations match the player's world configuration!
function save:SetSavePrinceHoundedData()
    local hounded_data = {}
    local hounded = GLOBAL.GetWorld().components.hounded

    local princehounded = FindEntity(inst, 10000, function(ent)
        return ent.prefab == "prince" and (ent:HasComponent("prince_hounded_sw_h") or ent:HasComponent("prince_hounded_rog") or ent:HasComponent("prince_hounded"))
    end)
    if princehounded then
        hounded_data = princehounded:OnSave()
    end

    if self.data~= nil and self.data.slots ~= nil and 
        self.data.slots[self.current_slot] ~= nil and hounded_data ~= nil then
        
        self.data.slots[self.current_slot].hounded_data = hounded_data
    end
end

function save:LoadSavedPrinceHoundedData()
    local hounded = GLOBAL.GetWorld().components.hounded
    local hounded_data = self.data.slots[self.current_slot].hounded_data

    local princehounded = FindEntity(inst, 10000, function(ent)
        return ent.prefab == "prince" and (ent:HasComponent("prince_hounded_sw_h") or ent:HasComponent("prince_hounded_rog") or ent:HasComponent("prince_hounded"))
    end)
    if princehounded and hounded_data and next(hounded_data) then
        princehounded:OnLoad(hounded_data)
    end

    self.data.slots[self.current_slot].hounded_data = nil
    self:Save(function () print("LoadSavedPrinceHoundedData CB") end)
end





--Ensure Prince follows Princess through the Wooden Thing!
function save:CompleteLevel(cb)
    local is_survival = self.data.slots[self.current_slot].current_mode == "survival"
    local is_shipwrecked = self.data.slots[self.current_slot].current_mode == "shipwrecked"

    local playerdata = {}
    local player = GLOBAL.GetPlayer()
    if player then
        player:OnProgress()

        -- bottom out the player's stats so they don't start the next level and die
        local minhealth = 0.2
        if player.components.health:GetPercent() < minhealth then
            player.components.health:SetPercent(minhealth)
        end
        local minsanity = 0.3
        if  player.components.sanity:GetPercent() < minsanity then
            player.components.sanity:SetPercent(minsanity)
        end
        local minhunger = 0.4
        if  player.components.hunger:GetPercent() < minhunger then
            player.components.hunger:SetPercent(minhunger)
        end


        playerdata = player:GetSaveRecord().data
     end   

    local function onerased()
        if is_survival then
            self:EraseCaves(cb)
        elseif is_shipwrecked then
            self:EraseVolcano(cb)
        else
            self:Save(cb)
        end
    end

    self.data.slots[self.current_slot].continue_pending = true
    self.data.slots[self.current_slot].direction = nil
    self.data.slots[self.current_slot].cave_num = nil
    if player.prefab ~= "princess" then
        self.data.slots[self.current_slot].followers = nil
    end
    self.data.slots[self.current_slot].clock_data = nil

    local current_mode = self.data.slots[self.current_slot].current_mode
    local data = self:GetModeData(self.current_slot, current_mode)

    data.day = 1
    data.world = data.world and (data.world + 1) or 2
    data.playerdata = playerdata
    local file = data.file 
    data.file = nil
    GLOBAL.EraseFiles( onerased, { file } )        
end




--Prince should persist, even when separated indoors/outdoors!
if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

function EntityScript:GetPersistData()
    local references = nil
    local data = nil
    for k,v in pairs(self.components) do
        if v.OnSave then
            local t, refs = v:OnSave()
            if type(t) == "table" then
                if t and next(t) and not data then
                    data = {}
                end
                if t and data then
                    data[k] = t
                end
            end
            
            if refs then
                if not references then
                    references = {}
                end
                for k,v in pairs(refs) do
                    
                    table.insert(references, v)
                end
            end
        end
    end
    
    if self.OnSave then
        if not data then
            data = {}
        end

        local refs = self.OnSave(self, data)

        if refs then
            if not references then
                references = {}
            end
            for k,v in pairs(refs) do
                
                table.insert(references, v)
            end
        end
        
    end

    --KEEP PRINCE ACTIVE WHEN ISOLATED INDOORS!
    if self:HasTag("INTERIOR_LIMBO") and self.prefab ~= "prince"
    and not (self.components.inventoryitem and self.components.inventoryitem.owner and self.components.inventoryitem.owner:HasTag("blindprince")) then
        if not data then
            data = {}
        end
        --print("THIS IS IN INTERIOR LIMBO", self.prefab)
        data.interior_limbo = true
        data.interior_id = self.interior

        if self.dissablephysics then
            data.dissablephysics = true
        end
    end

    if self.RuntimeComponents then
        if not data then data = {} end
        data.RuntimeComponents = {}
        for k,v in pairs(self.RuntimeComponents) do
            if v then
                table.insert(data.RuntimeComponents, v)
            end
        end
    end
    
    
    if self.origspawnedFrom then
        if not data then data = {} end
        data.origspawnedFrom = self.origspawnedFrom
    end

    if (data and next(data)) or references then
        return data, references
    end
end

function EntityScript:SetPersistData(data, newents)
    if data and data.citypossession then
        if not self.components.citypossession then
            self:AddComponent("citypossession")
        end
        self.components.citypossession:SetCity( data.citypossession.cityID )
    end

    if data and data.RuntimeComponents then
        for k,v in pairs(data.RuntimeComponents) do
            self:AddComponentAtRuntime(v)
        end
    end 

    if self.OnPreLoad then
        self:OnPreLoad(data, newents)
    end
    
    if data then
        for k,v in pairs(data) do
            local cmp = self.components[k]
            if cmp and cmp.OnLoad then
                cmp:OnLoad(v, newents)
            end
        end
    end

    if self.OnLoad then
        self:OnLoad(data, newents)
    end

    --KEEP PRINCE ACTIVE WHEN ISOLATED INDOORS!
    if data and data.interior_limbo and self.prefab ~= "prince"
    and not (self.components.inventoryitem and self.components.inventoryitem.owner and self.components.inventoryitem.owner:HasTag("blindprince")) then      
        --print("this thing should be in limbo",self.prefab)
        self:AddTag("INTERIOR_LIMBO")
        self:RemoveFromScene()      
        self.interior = data.interior_id or GLOBAL.GetInteriorSpawner():getPropInterior(self)
                       
        if self.SoundEmitter then
            self.SoundEmitter:OverrideVolumeMultiplier(0)
        end
    end
    if data and data.dissablephysics then        
        self.dissablephysics = data.dissablephysics
    end    

    if data and data.origspawnedFrom then
        self.origspawnedFrom = data.origspawnedFrom
    else
        self.origspawnedFrom = { source = "*already existed*", line = -1 }
    end
end


--Making an entire separate limbo space for Prince to hang out in so he can stay active. Will change this once I find out exactly how "limbo" is coded!
AddComponentPostInit("interiorspawner", function(self)


    function self:SetPropToInteriorLimbo(prop,interior,ignoredisplacement)
    if not prop.persists then
        prop:Remove()
    else
        if interior then
            table.insert(interior.object_list, prop)
        end

        if (prop.prefab == "prince")
        or (prop.components.inventoryitem and prop.components.inventoryitem.owner and prop.components.inventoryitem.owner:HasTag("blindprince")) then    

        prop:ReturnToScene()
        print("Come back to us, Prince!")

        return

        elseif (prop.prefab ~= "prince")
        and not (prop.components.inventoryitem and prop.components.inventoryitem.owner and prop.components.inventoryitem.owner:HasTag("blindprince")) then  

            prop:AddTag("INTERIOR_LIMBO")
            prop.interior = interior.unique_name

            if prop.components.playerprox and prop.components.playerprox.onfar then 
                prop.components.playerprox.onfar(prop)          
            end

            if prop.SoundEmitter then
                prop.SoundEmitter:OverrideVolumeMultiplier(0)
            end
        
            if prop.Physics and not prop.Physics:IsActive() then
                prop.dissablephysics = true         
            end
            if prop.removefrominteriorscene then
                prop.removefrominteriorscene(prop)
            end
            prop:RemoveFromScene(true)
        end
    end
end


end)


end



----------


local update = GLOBAL.Update

--AddGlobalClassPostConstruct("EntityScript", "Update", function(self)

--FOR PRINCE'S CLOTHES TO NOT WEAR OUT WHEN TRAVELLING WORLDS.
-- This is for advancing the sim long periods of time (to skip nights, come back from caves, etc).
function LongUpdate(dt, ignore_player)
    ExecutingLongUpdate = true

    for k, v in pairs(StaticComponentLongUpdates) do
        v(dt)
    end

    local player = GetPlayer()

    if player ~= nil and ignore_player then
        if player.components.beard ~= nil then
            player.components.beard.pause = true
        end

        if player.components.beaverness ~= nil then
            player.components.beaverness.ignoremoon = true
        end
    end

    for i, ent in pairs(Ents) do
        local should_ignore = false

        if ignore_player then
            if ent.components.inventoryitem then
                if GetGrandLeaderOrOwner(ent) == player then
                    should_ignore = true
                end
            end

            if player == ent then
                should_ignore = true
            end
        end

        if v.components.inventoryitem then
                    local grand_owner = v.components.inventoryitem:GetGrandOwner()
                    if grand_owner == player or (grand_owner and grand_owner.prefab == "prince") then
                        should_ignore = true
                    end
        end

        if not should_ignore then
            ent:LongUpdate(dt)
        end
    end

    if player ~= nil and ignore_player then
        if player.components.beard ~= nil then
            player.components.beard.pause = nil
        end

        if player.components.beaverness ~= nil then
            player.components.beaverness.ignoremoon = nil
        end
    end

    ExecutingLongUpdate = false
end



















--Make smallbirds follow Prince instead of Princess!
-- AddPrefabPostInit("smallbird", function(inst)

--     local function ImprintOnPrince(inst)
--         local prince = GLOBAL.FindEntity(inst, 20, function(ent)
--             return ent:HasTag("blindprince")
--         end)
--         if prince then
--             prince.components.leader:AddFollower(inst)
--             print("Found a father!")
--             inst.ImprintTask:Cancel()
--             inst.ImprintTask = nil
--         elseif not prince then
--             print("Find a father!")
--         end
--     end

--     local function CheckIfPrincess(inst)
--     --print("smallbird - FollowPlayer")

--         local player = GLOBAL.GetPlayer()
--         if player and player.components.leader and player.prefab ~= "princess" then
--             --print("   adding follower")
--             player.components.leader:AddFollower(inst)
--         elseif player and player.components.leader and player.prefab == "princess" then
--             inst:DoTaskInTime(0.5, function()
--                 if inst.components.follower and inst.components.follower.leader then
--                     inst.components.follower:StopFollowing()
--                 end
--             end)
--             if inst.ImprintTask == nil then
--                 inst.ImprintTask = inst:DoPeriodicTask(0.25, function() ImprintOnPrince(inst) end)
--             end
--         end
    
--     inst:RemoveEventCallback("animover", CheckIfPrincess)

--     end

--     inst.ImprintTask = nil

--     --Smallbirds start in a "busy" state, so this is just a cheesy way to get the game to initiate the code to find Prince to imprint on.
--     inst:DoTaskInTime(1.25, function()
--         if inst.AnimState:IsCurrentAnimation("hatch") then
--             inst:ListenForEvent("animover", CheckIfPrincess)
--         end
--     end)

-- end)




















--THE EATING SECTION!

--Princess is unaffected by sanity loss from raw meat!
AddComponentPostInit("eater", function(self)

    --Hamlet version!
    if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        function self:Eat( food )
            if self:CanEat(food) then
                local stack_mult = self.eatwholestack and food.components.stackable ~= nil and food.components.stackable:StackSize() or 1

                if self.inst.components.health and not self.inst:HasTag("donthealfromfood") then
                    if (food.components.edible.healthvalue < 0 and self:DoFoodEffects(food) or food.components.edible.healthvalue > 0) and self.inst.components.health then
                        local delta = food.components.edible:GetHealth(self.inst) * self.healthabsorption * self.healthabsorption
                        self.inst.components.health:DoDelta(delta* stack_mult, nil, food.prefab) 
                    end
                end

                if self.inst.components.hunger then
                    local delta = food.components.edible:GetHunger(self.inst) * self.hungerabsorption
                    if delta ~= 0 then
                        self.inst.components.hunger:DoDelta(delta * stack_mult)
                    end
                end
        
                if (food.components.edible.sanityvalue < 0 and self:DoFoodEffects(food) or food.components.edible.sanityvalue > 0) and self.inst.components.sanity then
                    local delta = food.components.edible:GetSanity(self.inst) * self.sanityabsorption
                    if delta ~= 0 then
                        --If it's Princess eating non-spoiled raw meat foods, don't lose sanity!
                        if self.inst.prefab == "princess" then
                        --If it's meat, then...
                            if food.components.edible.foodtype == "MEAT" then
                                --If the meat restores sanity like jerky, then gain sanity!
                                if food.components.edible.sanityvalue > 0 then
                                    print("Tasty!")
                                    self.inst.components.sanity:DoDelta(delta * stack_mult)
                                --If it's any other meat foods, raw or cooked, only lose sanity when the meat is spoiled!
                                elseif (food.components.edible.sanityvalue < 0) and (food.components.perishable and food.components.perishable:IsSpoiled()) then
                                    print("IT'S ROTTEN!")
                                    self.inst.components.sanity:DoDelta(delta * stack_mult)
                                end
                            --If it's not a meat-based food, Princess's sanity will respond as usual.
                            elseif food.components.edible.foodtype ~= "MEAT" then
                                self.inst.components.sanity:DoDelta(delta * stack_mult)
                            end
                        elseif self.inst.prefab ~= "princess" then
                            self.inst.components.sanity:DoDelta(delta * stack_mult)
                        end
                    end
                end

                if self.inst.components.poisonable and self.inst.components.poisonable:IsPoisoned() and food.components.poisonhealer then
                    food.components.poisonhealer:Cure(self.inst)
                end

                local naughtyvalue = food.components.edible:GetNaughtiness(self.inst)
                if naughtyvalue > 0 and self.inst.components.kramped then
                    self.inst.components.kramped:OnNaughtyAction(naughtyvalue)
                end
        
                self.inst:PushEvent("oneat", {food = food})
                if self.oneatfn then
                    self.oneatfn(self.inst, food)
                end
        
                if food.components.edible then
                    food.components.edible:OnEaten(self.inst)
                end        

                if food.components.stackable and food.components.stackable.stacksize > 1 and not self.eatwholestack then
                    food.components.stackable:Get():Remove()
                else
                    food:Remove()
                end
        
                self.lasteattime = GLOBAL.GetTime()
        
                self.inst:PushEvent("oneatsomething", {food = food})
        
                return true
            end
        end

    end

    --Shipwrecked version!
    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        function self:Eat( food )
        if self:CanEat(food) then
            local stack_mult = self.eatwholestack and food.components.stackable ~= nil and food.components.stackable:StackSize() or 1

            if self.inst.components.health then
                if (food.components.edible.healthvalue < 0 and self:DoFoodEffects(food) or food.components.edible.healthvalue > 0) and self.inst.components.health then
                    local delta = food.components.edible:GetHealth(self.inst) * self.healthabsorption * self.healthabsorption
                    self.inst.components.health:DoDelta(delta* stack_mult, nil, food.prefab) 
                end
            end

            if self.inst.components.hunger then
                local delta = food.components.edible:GetHunger(self.inst) * self.hungerabsorption
                if delta ~= 0 then
                    self.inst.components.hunger:DoDelta(delta * stack_mult)
                end
            end
        
            if (food.components.edible.sanityvalue < 0 and self:DoFoodEffects(food) or food.components.edible.sanityvalue > 0) and self.inst.components.sanity then
                local delta = food.components.edible:GetSanity(self.inst) * self.sanityabsorption
                if delta ~= 0 then
                    --If it's Princess eating non-spoiled raw meat foods, don't lose sanity!
                    if self.inst.prefab == "princess" then
                        --If it's meat, then...
                        if food.components.edible.foodtype == "MEAT" then
                            --If the meat restores sanity like jerky, then gain sanity!
                            if food.components.edible.sanityvalue > 0 then
                                print("Tasty!")
                                self.inst.components.sanity:DoDelta(delta * stack_mult)
                            --If it's any other meat foods, raw or cooked, only lose sanity when the meat is spoiled!
                            elseif (food.components.edible.sanityvalue < 0) and (food.components.perishable and food.components.perishable:IsSpoiled()) then
                                print("IT'S ROTTEN!")
                                self.inst.components.sanity:DoDelta(delta * stack_mult)
                            end
                        --If it's not a meat-based food, Princess's sanity will respond as usual.
                        elseif food.components.edible.foodtype ~= "MEAT" then
                            self.inst.components.sanity:DoDelta(delta * stack_mult)
                        end
                    elseif self.inst.prefab ~= "princess" then
                        self.inst.components.sanity:DoDelta(delta * stack_mult)
                    end
                end
            end

            local naughtyvalue = food.components.edible:GetNaughtiness(self.inst)
            if naughtyvalue > 0 and self.inst.components.kramped then
                self.inst.components.kramped:OnNaughtyAction(naughtyvalue)
            end
        
            self.inst:PushEvent("oneat", {food = food})
            if self.oneatfn then
                self.oneatfn(self.inst, food)
            end
        
            if food.components.edible then
                food.components.edible:OnEaten(self.inst)
            end
        
            if food.components.stackable and food.components.stackable.stacksize > 1 and not self.eatwholestack then
                food.components.stackable:Get():Remove()
            else
                food:Remove()
            end
        
            self.lasteattime = GLOBAL.GetTime()
        
            self.inst:PushEvent("oneatsomething", {food = food})
        
            return true
            end
        end

    end

    --Reign of Giants version!
    if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        function self:Eat( food )
        if self:CanEat(food) then
            local stack_mult = self.eatwholestack and food.components.stackable ~= nil and food.components.stackable:StackSize() or 1

            if self.inst.components.health then
                if (food.components.edible.healthvalue < 0 and self:DoFoodEffects(food) or food.components.edible.healthvalue > 0) and self.inst.components.health then
                    local delta = food.components.edible:GetHealth(self.inst) * self.healthabsorption * self.healthabsorption
                    self.inst.components.health:DoDelta(delta* stack_mult, nil, food.prefab) 
                end
            end

            if self.inst.components.hunger then
                local delta = food.components.edible:GetHunger(self.inst) * self.hungerabsorption
                if delta ~= 0 then
                    self.inst.components.hunger:DoDelta(delta * stack_mult)
                end
            end
        
            if (food.components.edible.sanityvalue < 0 and self:DoFoodEffects(food) or food.components.edible.sanityvalue > 0) and self.inst.components.sanity then
                local delta = food.components.edible:GetSanity(self.inst) * self.sanityabsorption
                if delta ~= 0 then
                    if self.inst.prefab == "princess" then
                        --If it's meat, then...
                        if food.components.edible.foodtype == "MEAT" then
                            --If the meat restores sanity like jerky, then gain sanity!
                            if food.components.edible.sanityvalue > 0 then
                                print("Tasty!")
                                self.inst.components.sanity:DoDelta(delta * stack_mult)
                            --If it's any other meat foods, raw or cooked, only lose sanity when the meat is spoiled!
                            elseif (food.components.edible.sanityvalue < 0) and (food.components.perishable and food.components.perishable:IsSpoiled()) then
                                print("IT'S ROTTEN!")
                                self.inst.components.sanity:DoDelta(delta * stack_mult)
                            end
                        --If it's not a meat-based food, Princess's sanity will respond as usual.
                        elseif food.components.edible.foodtype ~= "MEAT" then
                            self.inst.components.sanity:DoDelta(delta * stack_mult)
                        end
                    elseif self.inst.prefab ~= "princess" then
                        self.inst.components.sanity:DoDelta(delta * stack_mult)
                    end
                end
            end
        
            self.inst:PushEvent("oneat", {food = food})
            if self.oneatfn then
                self.oneatfn(self.inst, food)
            end
        
            if food.components.edible then
                food.components.edible:OnEaten(self.inst)
            end
        
            if food.components.stackable and food.components.stackable.stacksize > 1 and not self.eatwholestack then
                food.components.stackable:Get():Remove()
            else
                food:Remove()
            end
        
            self.lasteattime = GLOBAL.GetTime()
        
            self.inst:PushEvent("oneatsomething", {food = food})
        
            return true
            end
        end

    end

    --Vanilla version!
    if not GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        function self:Eat( food )
            if self:CanEat(food) then
                local stack_mult = self.eatwholestack and food.components.stackable ~= nil and food.components.stackable:StackSize() or 1

                if self.inst.components.health then
                    if food.components.edible.healthvalue > 0 or not self.strongstomach then
                        self.inst.components.health:DoDelta(food.components.edible:GetHealth(self.inst), nil, food.prefab)
                    end
                end

                if self.inst.components.hunger then
                    self.inst.components.hunger:DoDelta(food.components.edible:GetHunger(self.inst))
                end
        
                if self.inst.components.sanity then
                    --Special code for Princess's sanity reactions to what she's eating!
                    if self.inst.prefab == "princess" then
                        --If it's meat, then...
                        if food.components.edible.foodtype == "MEAT" then
                            --If the meat restores sanity like jerky, then gain sanity!
                            if food.components.edible.sanityvalue > 0 then
                                print("Tasty!")
                                self.inst.components.sanity:DoDelta(food.components.edible:GetSanity(self.inst))
                            --If it's any other meat foods, raw or cooked, only lose sanity when the meat is spoiled!
                            elseif (food.components.edible.sanityvalue < 0) and (food.components.perishable and food.components.perishable:IsSpoiled()) then
                                print("IT'S ROTTEN!")
                                self.inst.components.sanity:DoDelta(food.components.edible:GetSanity(self.inst))
                            end
                        --If it's not a meat-based food, Princess's sanity will respond as usual.
                        elseif food.components.edible.foodtype ~= "MEAT" then
                            self.inst.components.sanity:DoDelta(food.components.edible:GetSanity(self.inst))
                        end
                    elseif self.inst.prefab ~= "princess" then
                        self.inst.components.sanity:DoDelta(food.components.edible:GetSanity(self.inst))
                    end
                end
        
                self.inst:PushEvent("oneat", {food = food})
                if self.oneatfn then
                    self.oneatfn(self.inst, food)
                end
        
                if food.components.edible then
                    food.components.edible:OnEaten(self.inst)
                end
        
                if food.components.stackable and food.components.stackable.stacksize > 1 and not self.eatwholestack then
                    food.components.stackable:Get():Remove()
                else
                    food:Remove()
                end
        
                self.lasteattime = GLOBAL.GetTime()
        
                self.inst:PushEvent("oneatsomething", {food = food})
        
                return true
            end
        end

    end


end)





















--ROT IN PRINCE'S CONTAINER!

--Make rotted food go to Prince's container instead of being placed at the world origin! (0,0,0)
AddComponentPostInit("perishable", function(self)

    function self:Perish()
    
        if self.updatetask then
            self.updatetask:Cancel()
            self.updatetask = nil
        end

        --This event is only present in each of the DLC content!
        if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
            self.inst:PushEvent("perished")
        end
    
        if self.perishfn then
            self.perishfn(self.inst)
        end
    
        if self.onperishreplacement then
            local goop = GLOBAL.SpawnPrefab(self.onperishreplacement)
            if goop then
                local owner = self.inst.components.inventoryitem and self.inst.components.inventoryitem.owner or nil
                local pt = GLOBAL.Vector3(self.inst.Transform:GetWorldPosition())
                local holder = owner and owner.prefab ~= "prince" and ( owner.components.inventory or owner.components.container) 
                local slot = holder and holder:GetItemSlot(self.inst)
                --Because Prince's container is confusing EVERYTHING.
                local princecontainer = owner and owner.prefab == "prince" and owner.components.container
                local princecontainerslot = princecontainer and princecontainer:GetItemSlot(self.inst)
                local princeinventory = owner and owner.prefab == "prince" and owner.components.inventory
                local princeinventoryslot = princeinventory and princeinventory:GetItemSlot(self.inst)

                --Hamlet version!
                if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                    local floating = false
                    if self.inst.components.floatable then 
                        floating = self.inst.components.floatable.onwater or false 
                    end
                    local shelf = nil

                    if self.inst.onshelf then
                        shelf = self.inst.onshelf   
                    end

                    local fromInterior = self.inst.interior

                    self.inst:Remove()

                    if princecontainer then
                        --prince:RemoveItem(self.inst)
                        princecontainer:RemoveItemBySlot(princecontainerslot)
                        princecontainer:GiveItem(goop, princecontainerslot)
                    elseif princeinventory then
                        princeinventory:RemoveItemBySlot(princeinventoryslot)
                        princeinventory:GiveItem(goop)
                    elseif holder then
                        holder:GiveItem(goop, slot)
                    else
                    goop.Transform:SetPosition(pt:Get())

                    if fromInterior then
                        GLOBAL.GetInteriorSpawner():AddPrefabToInterior(goop, fromInterior)
                    end
                
                    if floating then
                        if goop.components.floatable then 
                            goop.components.floatable:OnHitWater(true)
                        else 
                            local fx = GLOBAL.SpawnPrefab("splash_water_sink")
                            fx.Transform:SetPosition(pt:Get())
                            goop:Remove()
                            end 
                        end    

                    end

                    if shelf then
                        shelf.components.shelfer:AcceptGift( nil, goop )
                    end
                --Shipwrecked version!
                elseif GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                    local floating = false
                    if self.inst.components.floatable then 
                        floating = self.inst.components.floatable.onwater or false 
                    end

                    self.inst:Remove()

                    if princecontainer then
                        --holder.components.container:RemoveItem(self.inst)
                        princecontainer:RemoveItemBySlot(princecontainerslot)
                        princecontainer:GiveItem(goop, princecontainerslot)
                    elseif princeinventory then
                        princeinventory:RemoveItemBySlot(princeinventoryslot)
                       princeinventory:GiveItem(goop)
                    elseif holder then
                        holder:GiveItem(goop, slot)
                    else
                        goop.Transform:SetPosition(pt:Get())
                        if floating then
                            if goop.components.floatable then 
                                goop.components.floatable:OnHitWater(true)
                            else 
                                local fx = GLOBAL.SpawnPrefab("splash_water_sink")
                                fx.Transform:SetPosition(pt:Get())
                                goop:Remove()
                            end 
                        end  

                    end
                --Reign of Giants and Vanilla version!
                elseif not GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)
                or (GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
                    self.inst:Remove()

                    if princecontainer then
                        --holder.components.container:RemoveItem(self.inst)
                        princecontainer:RemoveItemBySlot(princecontainerslot)
                        princecontainer:GiveItem(goop, princecontainerslot)
                    elseif princeinventory then
                        princeinventory:RemoveItemBySlot(princeinventoryslot)
                        princeinventory:GiveItem(goop)
                    elseif holder then
                        holder:GiveItem(goop, slot)
                    else
                        goop.Transform:SetPosition(pt:Get())
                    end
                end

            
                if goop.components.stackable and self.inst.components.stackable then
                    goop.components.stackable:SetStackSize(self.inst.components.stackable.stacksize)
                end

            end
        end
    end

end)



















--HEAL WOLF WITH HEALING ITEMS AS PRINCESS!

--Make healers restore Wolf's health too!
AddComponentPostInit("healer", function(self)

    function self:Heal(target)
        if target.components.health then
            target.components.health:DoDelta(self.health,false,self.inst.prefab)

            --Add the healer's health value to Wolf's regeneration!
            if target.prefab == "princess" and target:HasTag("liarprincess") and not target:HasTag("wolf") then
                target.HealthToRegen = target.HealthToRegen + self.health
            end

            if self.inst.components.stackable and self.inst.components.stackable.stacksize > 1 then
                self.inst.components.stackable:Get():Remove()
            else
                self.inst:Remove()
            end
            return true
        end
    end

end)    



















--SLEEP HEALING!

--Make healing sleeping spaces heal Wolf's health too, as well as make Prince sleep as well if Princess goes to sleep!
AddComponentPostInit("sleepingbag", function(self)

    function self:DoSleep(doer)
        if self.onsleep then
            self.onsleep(self.inst, doer)

            --For Princess!
            if doer:HasTag("liarprincess") and doer.HealthToRegen and not doer:HasTag("wolf") then
            
                if self.inst.prefab == "tent" then
                    doer.HealthToRegen = doer.HealthToRegen + 60

                    --If Prince is following, apply sleep bonuses to Prince and make him sleep too!
                    for k,v in pairs(doer.components.leader.followers) do
                        if k:HasTag("blindprince") then

                            if doer.components.playercontroller and not doer.components.playercontroller:IsEnabled() then

                            k:DoTaskInTime(1.2, function()
                                k.components.talker:IgnoreAll() --Put here to prevent Prince from waking up to announce that he's hungry!
                                if k.components.sanity then
                                    k.components.sanity:DoDelta(GLOBAL.TUNING.SANITY_HUGE)
                                end
                                if k.components.hunger then
                                    k.components.hunger:DoDelta(-GLOBAL.TUNING.CALORIES_HUGE, false, true)
                                end
                                if k.components.health then
                                    k.components.health:DoDelta(GLOBAL.TUNING.HEALING_HUGE, false, nil, true)
                                end
                                if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                                    if k.components.temperature and k.components.temperature.current < 35 then
                                        k.components.temperature:SetTemperature(35)
                                    end     
                                    local moisture_start = nil
                                    if k.components.moisture and k.components.moisture:GetMoisture() > 0 then
                                        moisture_start = k.components.moisture.moisture
                                    end
                                else
                                    if k.components.temperature then
                                        k.components.temperature:SetTemperature(k.components.temperature.maxtemp)
                                    end
                                end
                                k.sg:GoToState("sleep")
                                k.components.follower:StopFollowing()
                            end)

                            end

                        end
                    end

                elseif self.inst.prefab == "bedroll_furry" then
                    doer.HealthToRegen = doer.HealthToRegen + 30

                    --If Prince is following, apply sleep bonuses to Prince and make him sleep too!
                    for k,v in pairs(doer.components.leader.followers) do
                        if k:HasTag("blindprince") then

                            if doer.components.playercontroller and not doer.components.playercontroller:IsEnabled() then

                            k:DoTaskInTime(1.2, function()
                                k.components.talker:IgnoreAll() --Put here to prevent Prince from waking up to announce that he's hungry!
                                if k.components.sanity then
                                    k.components.sanity:DoDelta(GLOBAL.TUNING.SANITY_HUGE)
                                end
                                if k.components.hunger then
                                    k.components.hunger:DoDelta(-GLOBAL.TUNING.CALORIES_HUGE, false, true)
                                end
                                if k.components.health then
                                    k.components.health:DoDelta(GLOBAL.TUNING.HEALING_MEDLARGE, false, nil, true)
                                end
                                if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                                    if k.components.temperature then
                                        if k.components.temperature.current < 35 then
                                            k.components.temperature:SetTemperature(35)
                                        elseif k.components.temperature.current > 35 * 1.5 then
                                            k.components.temperature:SetTemperature(k.components.temperature.current + (35 * .5))
                                        end
                                    end   
                                    local moisture_start = nil
                                    if k.components.moisture and k.components.moisture:GetMoisture() > 0 then
                                        moisture_start = k.components.moisture.moisture
                                    end
                                else
                                    if k.components.temperature then
                                        k.components.temperature:SetTemperature(k.components.temperature.maxtemp)
                                    end
                                end
                                k.sg:GoToState("sleep")
                                k.components.follower:StopFollowing()
                            end)

                            end

                        end
                    end

                elseif self.inst.prefab == "bedroll_straw" then

                    --If Prince is following, apply sleep bonuses to Prince and make him sleep too!
                    for k,v in pairs(doer.components.leader.followers) do
                        if k:HasTag("blindprince") then

                            if doer.components.playercontroller and not doer.components.playercontroller:IsEnabled() then

                            k:DoTaskInTime(1.2, function()
                                k.components.talker:IgnoreAll() --Put here to prevent Prince from waking up to announce that he's hungry!
                                if k.components.sanity then
                                    k.components.sanity:DoDelta(GLOBAL.TUNING.SANITY_HUGE)
                                end
                                if k.components.hunger then
                                    k.components.hunger:DoDelta(-GLOBAL.TUNING.CALORIES_LARGE, false, true)
                                end
                                k.sg:GoToState("sleep")
                                k.components.follower:StopFollowing()
                            end)

                            end

                        end
                    end

                elseif self.inst.prefab == "siestahut" then
                    doer.HealthToRegen = doer.HealthToRegen + 60

                    --If Prince is following, apply sleep bonuses to Prince and make him sleep too!
                    for k,v in pairs(doer.components.leader.followers) do
                        if k:HasTag("blindprince") then

                            if doer.components.playercontroller and not doer.components.playercontroller:IsEnabled() then

                            k:DoTaskInTime(1.2, function()
                                k.components.talker:IgnoreAll() --Put here to prevent Prince from waking up to announce that he's hungry!
                                if k.components.sanity then
                                    k.components.sanity:DoDelta(GLOBAL.TUNING.SANITY_HUGE)
                                end
                                if k.components.hunger then
                                    k.components.hunger:DoDelta(-GLOBAL.TUNING.CALORIES_MED, false, true)
                                end
                                if k.components.health then
                                    k.components.health:DoDelta(GLOBAL.TUNING.HEALING_HUGE, false, nil, true)
                                end
                                if k.components.temperature and k.components.temperature.current > 35 then
                                    k.components.temperature:SetTemperature(35 - 20)
                                end
                                local moisture_start = nil
                                if k.components.moisture and k.components.moisture:GetMoisture() > 0 then
                                    moisture_start = k.components.moisture.moisture
                                end
                                k.sg:GoToState("sleep")
                                k.components.follower:StopFollowing()
                            end)

                            end

                        end
                    end

                end

            end

        end 
    end

end)




















--Don't make the camera distort if Prince is insane while Princess is sane!
AddComponentPostInit("sanity", function(self)

    function self:OnUpdate(dt)
    
        if self.inst.prefab ~= "prince" then
            local speed = easing.outQuad( 1 - self:GetPercent(), 0, .2, 1) 
            self.fxtime = self.fxtime + dt*speed
    
            GLOBAL.PostProcessor:SetEffectTime(self.fxtime)
    
            local distortion_value = easing.outQuad( self:GetPercent(), 0, 1, 1) 
            --local colour_value = 1 - easing.outQuad( self:GetPercent(), 0, 1, 1) 
            --PostProcessor:SetColourCubeLerp( 1, colour_value )
            GLOBAL.PostProcessor:SetDistortionFactor(distortion_value)
            GLOBAL.PostProcessor:SetDistortionRadii( 0.5, 0.685 )
        end

        if self.inst.components.health.invincible == true or self.inst.is_teleporting == true then
            return
        end
    
        self:Recalc(dt) 
end

end)

















--Make Prince attract shadow creatures too!
AddPrefabPostInit("shadowcreature", function(inst)

    local function retargetfn(inst)
    local notags = {"FX", "NOCLICK","INLIMBO"}
    local yestags = {"player", "character", "prince"}
    local entity = FindEntity(inst, TUNING.SHADOWCREATURE_TARGET_DIST, function(guy) 
            return guy.components.sanity and guy.components.sanity:IsCrazy() and inst.components.combat:CanTarget(guy)
        end, yestags, notags)
        return entity
    end

end)
if (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)) or (GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
AddPrefabPostInit("shadowcreature_sea", function(inst)

    local function retargetfn(inst)
    local notags = {"FX", "NOCLICK","INLIMBO"}
    local yestags = {"player", "character", "prince"}
    local entity = FindEntity(inst, TUNING.SHADOWCREATURE_TARGET_DIST, function(guy) 
            return guy.components.sanity and guy.components.sanity:IsCrazy() and inst.components.combat:CanTarget(guy)
        end, yestags, notags)
        return entity
    end

end)
end



















--This is a test for Prince's inventory/container problem!
AddComponentPostInit("inventory", function(self)
    
    local _oldGiveItem = self.GiveItem
    function self:GiveItem(inst, slot, screen_src_pos, skipsound)

            if self.inst:HasTag("blindprince") then
                local prince = self.inst
                --Don't make Prince's items duplicate on accident in vanilla or Reign of Giants!
                if --self.inst.components.container and
                --and (inst.components.inventoryitem and inst.components.inventoryitem.owner and not inst.components.inventoryitem.owner ~= prince) 
                inst.components.equippable
                --and self.inst.components.trader.enabled
                and self.inst:HasTag("armingprince") then
                    return _oldGiveItem(self, inst, slot, screen_src_pos, skipsound)
                --Prevent items from duplicating into Prince's container when it's given to him.
                elseif
                --not self.inst:HasTag("armingprince") and
                self.inst.components.container and self.inst.components.container:IsOpen() then
                    return self.inst.components.container:GiveItem(inst)
                end
            elseif not self.inst:HasTag("blindprince") then
                return _oldGiveItem(self, inst, slot, screen_src_pos, skipsound)
            end
        end


--Prevent Prince from duplicating equippables in non-Shipwrecked or non-Hamlet saves!
if not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

    local _oldEquip = self.Equip
    function self:Equip(item, old_to_active)
        local player = GLOBAL.GetPlayer()
        if player.prefab == "princess" then

            if not item or not item.components.equippable or not item:IsValid() then
                return
            end

            -----
            item.prevslot = self:GetItemSlot(item) 

            if item.prevslot == nil 
                    and item.components.inventoryitem.owner
                    and item.components.inventoryitem.owner.components.container 
                    and item.components.inventoryitem.owner.components.inventoryitem then
                item.prevcontainer = item.components.inventoryitem.owner.components.container
                item.prevslot = item.components.inventoryitem.owner.components.container:GetItemSlot(item)
            end
            -----

            local owner = item.components.inventoryitem.owner

            --IMPORTANT! REMOVES THE DUPLICATED SPRITE FROM PRINCE'S INVENTORY!
            if owner then
                if owner:HasTag("blindprince") then
                    item.components.inventoryitem:RemoveFromOwner(true)
                    owner.components.container:RemoveItem(item)
                end
            end
            --IMPORTANT! REMOVES THE DUPLICATED SPRITE FROM PRINCE'S INVENTORY!

                if item.components.inventoryitem then
            item = item.components.inventoryitem:RemoveFromOwner(item.components.equippable.equipstack) or item
        else
            item = self:RemoveItem(item, item.components.equippable.equipstack) or item
        end

        local leftovers = nil
        if item == self.activeitem then
            leftovers = self.activeitem
            self:SetActiveItem(nil)
        end
    
        local eslot = item.components.equippable.equipslot
        if self.equipslots[eslot] ~= item then
            local olditem = self.equipslots[eslot]
            if leftovers then
                if old_to_active then
                    self:GiveActiveItem(leftovers)
                else
                    self:GiveItem(leftovers)
                end
            end
            if olditem then
                self:Unequip(eslot)
                olditem.components.equippable:ToPocket()
                if olditem.components.inventoryitem and not olditem.components.inventoryitem.cangoincontainer and not self.ignorescangoincontainer then
                    olditem.components.inventoryitem:OnRemoved()
                    self:DropItem(olditem)
                else
                    if old_to_active then
                        self:GiveActiveItem(olditem)
                    else
                        self:GiveItem(olditem)
                    end
                end
            end
        
            item.components.inventoryitem:OnPutInInventory(self.inst)
            item.components.equippable:Equip(self.inst)
            self.equipslots[eslot] = item
            self.inst:PushEvent("equip", {item=item, eslot=eslot})
            if METRICS_ENABLED and item.prefab then
                ProfileStatsAdd("equip_"..item.prefab)
                FightStat_Equip(item.prefab,eslot)
            end
            return true
        end

    else

            return _oldEquip(self, item, old_to_active)
        
        end

    end



end



end)



















--For Prince's inventory size decreasing when dismounting boats!
AddComponentPostInit("container", function(self)

    local _oldSetNumSlots = self.SetNumSlots
    function self:SetNumSlots(numslots, skipcheck)
        if not skipcheck then 
            if numslots >= self.numslots then
                assert(numslots >= self.numslots)
            elseif
            numslots <= self.numslots then
                assert(numslots <= self.numslots)
            end
        end 
    self.numslots = numslots
    end

end)


















--Overwrites some conflicting item giving for Prince!
AddComponentPostInit("tradable", function(self)

    local _oldCollectUseActions = self.CollectUseActions
    function self:CollectUseActions(doer, target, actions)
        if target:HasTag("blindprince") then
            if not doer.components.rider or not doer.components.rider:IsRiding() then

                if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                    if target.components.weapon and target.components.trader then
                        if target.components.trader:CanAccept(self.inst, doer) then
                            table.insert(actions, ACTIONS.GIVE)
                        end
                    end
                end

                if (target.components.trader and target.components.trader.enabled) and (self.inst.components.equippable or (self.inst.components.edible and target.components.eater:CanEat(self.inst) ) ) then
                    table.insert(actions, ACTIONS.GIVE)
                end
            end
        else
            return _oldCollectUseActions(self, doer, target, actions)
        end
    end


end)




















--Let Prince accept usable items!
AddComponentPostInit("inventoryitem", function(self)


    if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

        --Items that Prince holds should still get wet!
        function self:IsSheltered()
        return self:IsHeld() and
            ((self.owner.components.container and not self.owner:HasTag("blindprince")) or (self.owner.components.inventory and self.owner.components.inventory:IsWaterproof()))
        end

    end

    
    local _oldCollectUseActions = self.CollectUseActions
    function self:CollectUseActions(doer, target, actions)
            --Store incompatible edibles, eat compatible edibles!
            if target:HasTag("blindprince") and self.inst.components.edible then
                if target.components.eater:CanEat(self.inst) then
                    if not self.inst.components.tradable then
                        self.inst:AddComponent("tradable")
                    end
                    --target.components.container:Close()
                    return table.insert(actions, ACTIONS.GIVE)
                elseif not target.components.eater:CanEat(self.inst) then
                    --target.components.container:Close()
                    return table.insert(actions, ACTIONS.STORE)
                end
            end 


            --Check for sailing DLC for boat equippables to interact with Prince properly!
            if (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) or (GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
                --Attempt to arm Prince with tools and armor. Don't equip him with a sail, he's not a boat!
                if target:HasTag("blindprince") and self.inst.components.equippable and self.inst.components.equippable.boatequipslot then
                    if not self.inst.components.tradable then
                        self.inst:AddComponent("tradable")
                    end
                    --target.components.container:Close()
                    return table.insert(actions, ACTIONS.GIVE)
                end
                if target:HasTag("blindprince") and self.inst.components.equippable and not self.inst.components.equippable.boatequipslot then
                    if not self.inst.components.tradable then
                        self.inst:AddComponent("tradable")
                    end
                    --target.components.container:Close()
                    return table.insert(actions, ACTIONS.GIVE)
                end
            end
            --If neither sailing DLC is available, use this code instead for equippables!
            if not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                if target:HasTag("blindprince") and self.inst.components.equippable then
                    if not self.inst.components.tradable then
                        self.inst:AddComponent("tradable")
                    end
                    --target.components.container:Close()
                    return --table.insert(actions, ACTIONS.GIVE)
                end
            end


            --Allow inedible tradables in Prince's container.
            if target:HasTag("blindprince") and self.inst.components.tradable and not self.inst.components.equippable and not self.inst.components.edible and not self.inst.components.healer then
                return table.insert(actions, ACTIONS.STORE)
            end


            --Let healing items like honey poultices usable on Prince!
            if target:HasTag("blindprince") and self.inst.components.healer and target.components.health and not target.components.health:IsDead() then
                --target.components.container:Close()
                return 
            end

        return _oldCollectUseActions(self, doer, target, actions)
    end


end)




















--Make Bearger and Moose's disarming abilities work consistently for Prince!
if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

AddPrefabPostInit("moose", function(inst)

local function DisarmPrince(inst)
    local item = nil
    local target = inst.components.combat.target
    if target and target.components.inventory then
        item = target.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
    end
    if item and item.Physics then
        if target:HasTag("blindprince") then
            item.components.equippable:Unequip(target)
            target.components.inventory:RemoveItem(item)
            target.components.inventory:DropItem(item, true, true)
            local x, y, z = item:GetPosition():Get()
            y = .1
            item.Physics:Teleport(x,y,z)
            local hp = target:GetPosition()
            local pt = inst:GetPosition()
            local vel = (hp - pt):GetNormalized()     
            local speed = 5 + (math.random() * 2)
            local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * GLOBAL.DEGREES
            item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)
        elseif not target:HasTag("blindprince") then
            target.components.inventory:DropItem(item)
            local x, y, z = item:GetPosition():Get()
            y = .1
            item.Physics:Teleport(x,y,z)
            local hp = target:GetPosition()
            local pt = inst:GetPosition()
            local vel = (hp - pt):GetNormalized()     
            local speed = 5 + (math.random() * 2)
            local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * GLOBAL.DEGREES
            item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)
        end
    end
    inst.CanDisarm = false
end

inst:ListenForEvent("doattack", function(inst)

    --print("I think we need to run a few... TESTS.")
    local target = inst.components.combat.target
    if target and target:HasTag("blindprince") and inst.CanDisarm then
        inst:DoTaskInTime(0.4, function()
            DisarmPrince(inst)
        end)
    end
end)

end)


AddPrefabPostInit("bearger", function(inst)

    local function LaunchItem(inst, target, item)
    if item.Physics then

        local x, y, z = item:GetPosition():Get()
        y = .1
        item.Physics:Teleport(x,y,z)

        local hp = target:GetPosition()
        local pt = inst:GetPosition()
        local vel = (hp - pt):GetNormalized()     
        local speed = 5 + (math.random() * 2)
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * GLOBAL.DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)

    end
end

    local function OnHitOther(inst, data)
        local other = data.target
        if other and other.components.inventory then
            local item = other.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
            if not item or item:HasTag("cantdrop") then return end
            if other:HasTag("blindprince") then
                other.components.inventory:RemoveItem(item)
                other.components.inventory:DropItem(item, true, true)
                LaunchItem(inst, data.target, item)
            elseif not other:HasTag("blindprince") then
                other.components.inventory:DropItem(item)
                LaunchItem(inst, data.target, item)
            end
        end
    end

    inst:ListenForEvent("onhitother", OnHitOther)

end)

end




















--Princess won't enter caves or travel worlds without Prince!
AddComponentPostInit("activatable", function(self)
    
    local _oldCollectSceneActions = self.CollectSceneActions
    function self:CollectSceneActions(doer, actions)

        if self.inst then

            --Check if Prince is following Princess before deciding to go into or out of the caves, using the Wooden Thing, riding a Seaworthy or Skyworthy!
            local player = GLOBAL.GetPlayer()
            if player.prefab == "princess" and (self.inst.prefab == "cave_entrance" or self.inst.prefab == "cave_exit" 
            or self.inst.prefab == "shipwrecked_entrance" or self.inst.prefab == "shipwrecked_exit"
            or self.inst.prefab == "porkland_entrance" or self.inst.prefab == "porkland_exit" 
            or self.inst.prefab == "teleportato_base" or self.inst.prefab == "teleportato_checkmate" 
            or self.inst.prefab == "teleportato_sw_base" or self.inst.prefab == "teleportato_hamlet_base"
            or self.inst.prefab == "volcano" or self.inst.prefab == "volcano_exit") then
                if self.inactive and doer:HasTag("princeleader") then
                    table.insert(actions, ACTIONS.ACTIVATE)
                end
            end

            --The Wooden Thing in Adventure Mode has a right click option to travel. These lines of code disables that option for Princess if Prince isn't following her!
            if player.prefab == "princess" and self.inst.prefab == "teleportato_base" and GLOBAL.SaveGameIndex:GetCurrentMode() == "adventure" then
                if self.inactive and not doer:HasTag("princeleader") then
                    self.inst:SetInherentSceneAltAction(nil)
                else
                    self.inst:SetInherentSceneAltAction(ACTIONS.TRAVEL)
                end
            end

            --Other activatables like Maxwell's portal should be fine.
            if player.prefab == "princess" and self.inst.prefab ~= "cave_entrance" and self.inst.prefab ~= "cave_exit" 
            and self.inst.prefab ~= "shipwrecked_entrance" and self.inst.prefab ~= "shipwrecked_exit"
            and self.inst.prefab ~= "porkland_entrance" and self.inst.prefab ~= "porkland_exit"
            and self.inst.prefab ~= "teleportato_base" and self.inst.prefab ~= "teleportato_checkmate" 
            and self.inst.prefab ~= "teleportato_sw_base" and self.inst.prefab ~= "teleportato_hamlet_base" 
            and self.inst.prefab ~= "volcano"  and self.inst.prefab ~= "volcano_exit" then
                return _oldCollectSceneActions(self, doer, actions)
            end

            --Other player characters should be ineffected by the previous codes!
            if player.prefab ~= "princess" then
                return _oldCollectSceneActions(self, doer, actions)
            end

        end

    end

    --Ensure other means of activation (like space bar) don't separate Princess from Prince!
    local _oldDoActivate = self.DoActivate
    function self:DoActivate(doer)
        local player = GLOBAL.GetPlayer()
        if player.prefab == "princess" and (self.inst.prefab == "cave_entrance" or self.inst.prefab == "cave_exit" or self.inst.prefab == "shipwrecked_entrance" or self.inst.prefab == "shipwrecked_exit" or self.inst.prefab == "porkland_entrance" or self.inst.prefab == "porkland_exit" or self.inst.prefab == "teleportato_base" or self.inst.prefab == "teleportato_checkmate" or self.inst.prefab == "teleportato_sw_base" or self.inst.prefab == "teleportato_hamlet_base" or self.inst.prefab == "volcano" or self.inst.prefab == "volcano_exit") then
            if self.OnActivate ~= nil and doer:HasTag("princeleader") then
                self.inactive = false
                --This is for Prince's inventory to be consistent between entering and exiting the volcano!
                local prince = GLOBAL.FindEntity(doer, 15, function(ent)
                    return ent:HasTag("blindprince")
                end)
                if prince then
                    prince.components.container:Close()

                    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        
                        if prince.boatstate == "CARGO" or prince.boatstate == "ENCRUSTED" then

                            local boat = prince.components.driver and prince.components.driver.vehicle
                            if boat.components.container then
                                if prince.boatstate == "CARGO" then
                                    for i = 1, boat.components.container:GetNumSlots() do
                                        local item = prince.components.container:RemoveItemBySlot((15+i)) --The 15 is to skip Prince's original 15 slots, to go straight to his "boat slots".
                                        boat.components.container:GiveItem(item)
                                    end
                                elseif prince.boatstate == "ENCRUSTED" then
                                    for i = 1, boat.components.container:GetNumSlots() do
                                        local item = prince.components.container:RemoveItemBySlot((15+i)) --The 15 is to skip Prince's original 15 slots, to go straight to his "boat slots".
                                        boat.components.container:GiveItem(item)
                                    end
                                end

                            end

                        end

                    end

                end
                self.OnActivate(self.inst, doer)
            else
                local missingprince = {"I'm not going anywhere without Prince.", "I can't leave Prince alone.", "Prince won't be able to survive if I leave him.", "I'll have to bring Prince with me first."}
                doer.components.talker:Say(missingprince[math.random(1, #missingprince)])
                return
            end

        elseif (player.prefab ~= "princess") or (player.prefab == "princess" and self.inst.prefab ~= "cave_entrance" and self.inst.prefab ~= "cave_exit" and self.inst.prefab ~= "shipwrecked_entrance" and self.inst.prefab ~= "shipwrecked_exit" or self.inst.prefab ~= "porkland_entrance" and self.inst.prefab ~= "porkland_exit" and self.inst.prefab ~= "teleportato_base" and self.inst.prefab ~= "teleportato_checkmate" and self.inst.prefab ~= "teleportato_sw_base" and self.inst.prefab ~= "teleportato_hamlet_base" and self.inst.prefab ~= "volcano" and self.inst.prefab ~= "volcano_exit") then
            return _oldDoActivate(self, doer)

            --if self.OnActivate ~= nil then
                --self.inactive = false
                --self.OnActivate(self.inst, doer)
            --end

        end

    end


end)



















AddComponentPostInit("leader", function(self)

    --Prince should remain loyal to his leader, even if they are dead!
    function self:RemoveAllFollowers()
        for k,v in pairs(self.followers) do
            if not k:HasTag("blindprince") then
                self:RemoveFollower(k)
            end
        end
    end

    --Prince should not aggro onto assailants that attack his leader unless they attack them first!
    local _oldOnAttacked = self.OnAttacked
    function self:OnAttacked(attacker)
        if self.inst.prefab == "princess" then
            if not self:IsFollower(attacker) and self.inst ~= attacker then
                for k,v in pairs(self.followers) do
                    if k.components.combat and k.components.follower and k.components.follower.canaccepttarget and not k:HasTag("blindprince") then
                        k.components.combat:SuggestTarget(attacker)
                    end
                end
            end
        else
            return _oldOnAttacked(self, attacker)
        end
    end

end)



















--Make Prince's inventory wet! RoG version!
if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

AddComponentPostInit("moisturelistener", function(self)

    function self:GetTargetMoisture()
        if (not GLOBAL.GetWorld().components.seasonmanager:IsRaining() and not 
        (self.inst.components.inventoryitem and self.inst.components.inventoryitem.owner)) or not 
        self.inst.components.inventoryitem then
            return 0
        end
        local owner = self.inst.components.inventoryitem.owner
        if owner then
            if owner.components.container and not owner:HasTag("blindprince") then
                --All containers keep items dry. Except Prince!
                return 0
            end 
            if (owner.components.inventory and owner.components.moisture) or (owner.components.container and owner:HasTag("blindprince")) then
                return owner.components.moisture:GetMoisture() 
            end  
        end
        return GLOBAL.GetWorld().components.moisturemanager:GetWorldMoisture()
    end

end)

end



















--Make Prince's inventory wet! Shipwrecked version!
if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

AddComponentPostInit("moisturelistener", function(self)

    function self:GetTargetMoisture()
        if not self.inst.components.inventoryitem then 
            return 0 
        end 

        if (not (GLOBAL.GetWorld().components.seasonmanager:IsRaining()) and not 
        (self.inst.components.inventoryitem and self.inst.components.inventoryitem.owner)) then
            if self.inst.Transform then 
                local x,y,z = self.inst.Transform:GetWorldPosition()
                if x and y and z then 
                    if GLOBAL.GetWorld().Flooding ~= nil and GLOBAL.GetWorld().Flooding:OnFlood(x, y, z) then
                        return GLOBAL.TUNING.MOISTURE_MAX_WETNESS
                    end     
                end
            end 

            return 0
        end
        local owner = self.inst.components.inventoryitem.owner
        if owner then
            if owner.components.container and not owner:HasTag("blindprince") then
                --All containers keep items dry. Except Prince!
                return 0
            end 
            if (owner.components.inventory and owner.components.moisture) or (owner.components.container and owner:HasTag("blindprince")) then
                return owner.components.moisture:GetMoisture() 
            end  
        end
        return GLOBAL.GetWorld().components.moisturemanager:GetWorldMoisture()
    end

end)

end



















--Make Prince's inventory wet! Hamlet version!
if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

AddComponentPostInit("moisturelistener", function(self)

    function self:GetTargetMoisture()

        if not self.inst.components.inventoryitem and not self.overrideinventoryonly then 
            return 0 
        end 

        if ( (not (GLOBAL.GetWorld().components.seasonmanager:IsRaining()) and not (self.inst.components.inventoryitem and self.inst.components.inventoryitem.owner)) or
            self.inst:CheckIsInInterior() ) then
            if self.inst.Transform and not self.inst:CheckIsInInterior() then 
                local x,y,z = self.inst.Transform:GetWorldPosition()
                if x and y and z then 
                    if GLOBAL.GetWorld().Flooding ~= nil and GLOBAL.GetWorld().Flooding:OnFlood(x, y, z) then
                        return GLOBAL.TUNING.MOISTURE_MAX_WETNESS
                    end     
                end
            end 

            return 0
        end
    
        local owner = nil
        if self.inst.components.inventoryitem then
            owner = self.inst.components.inventoryitem.owner
        end
        if owner then
            if owner.components.container and not owner:HasTag("blindprince") then
                --All containers keep items dry. Except Prince!
                return 0
            end 
            if (owner.components.inventory and owner.components.moisture) or (owner.components.container and owner:HasTag("blindprince")) then
                return owner.components.moisture:GetMoisture() 
            end  
        end
        return GLOBAL.GetWorld().components.moisturemanager:GetWorldMoisture()

    end

end)

end





















if (GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)) or (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)) or (GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then

--Prince shouldn't be labelled wet unless he actually is wet!
AddComponentPostInit("moisturemanager", function(self)

    function self:IsEntityWet(inst)

    --!!FOR PRINCE!!--
    if inst.prefab == "prince" then
        if inst.components.moisture and inst.components.moisture.moisture <= 40 then
            return false
        end
    end
    --!!FOR PRINCE!!--

    if inst.components.moisturelistener then
        return inst.components.moisturelistener:IsWet()
    end

    if inst.components.waterproofer then
        return false
    end

    if self:IsWorldWet() and not self.entities[inst] then
        return true
    end

    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        if inst:GetIsFlooded() then 
            return true 
        end 
    end
end

    function self:IsEntityDry(inst)

    --!!FOR PRINCE!!--
    if inst.prefab == "prince" then
        if inst.components.moisture and inst.components.moisture.moisture <= 40 then
            return true
        end
    end
    --!!FOR PRINCE!!--

    if inst.components.moisturelistener then
        return not inst.components.moisturelistener:IsWet()
    end

    --If inst isn't in here then it's wet
    if inst.components.waterproofer then
        return true
    end

    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
        if inst:GetIsFlooded() then 
            return false
        end 
    end

    return self.entities[inst]
end

end)

end



















AddComponentPostInit("combat", function(self)

    function self:SetTarget(target)
        local new = target ~= self.target
        local player = GLOBAL.GetPlayer()

        if new and (not target or self:IsValidTarget(target) ) and not (target and target.sg and target.sg:HasStateTag("hiding") and (target:HasTag("player") or target:HasTag("blindprince"))) then
            if METRICS_ENABLED and self.target == player and new ~= player then
                FightStat_GaveUp(self.inst)
            end

            if self.target then
                if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                    self:StopTrackingTarget(self.target)
                end
                self.lasttargetGUID = self.target.GUID
            else
                self.lasttargetGUID = nil
            end
        
            if not GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                self.target = target
                self.inst:PushEvent("newcombattarget", {target=target})
            else
                local oldtarget = self.target
                self.target = target
                self.inst:PushEvent("newcombattarget", {target=target, oldtarget=oldtarget})
            end

            if METRICS_ENABLED and (player == target or target and target.components.follower and target.components.follower.leader == player) then
                FightStat_Targeted(self.inst)
            end
        
            if target and self.keeptargetfn then
                self.inst:StartUpdatingComponent(self)
            else
                self.inst:StopUpdatingComponent(self)
            end
        
            if target and self.inst.components.follower and self.inst.components.follower.leader == target and self.inst.components.follower.leader.components.leader then
                self.inst.components.follower.leader.components.leader:RemoveFollower(self.inst)
            end

            if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
                self:StartTrackingTarget(target)
            end
        end
    end


    --Prevent Wolf from friendly firing Prince!
    if not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
    local _oldDoAreaAttack = self.DoAreaAttack
    function self:DoAreaAttack(target, range, weapon, validfn)
        if self.inst and self.inst.prefab == "princess" then
            local hitcount = 0
            local pt = GLOBAL.Vector3(target.Transform:GetWorldPosition() )
            local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, range)
            for i,ent in ipairs(ents) do
                if ent.components.combat 
                and ent ~= target 
                and ent ~= self.inst 
                and ent.prefab ~= "prince" 
                and self:CanAreaHitTarget(ent)
                and (not validfn or validfn(ent)) then
                    self.inst:PushEvent("onareaattackother", {target = target, weapon = weapon})
                    ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon)
                    hitcount = hitcount + 1
                elseif ent.components.combat 
                and ent == target 
                and ent ~= self.inst 
                and self.inst.sg:HasStateTag("secondattack")
                and self:CanAreaHitTarget(ent)
                and (not validfn or validfn(ent)) then
                    self.inst:PushEvent("onareaattackother", {target = target, weapon = weapon})
                    ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon)
                    hitcount = hitcount + 1
                end
            end
            return hitcount
        else
        return _oldDoAreaAttack(self, target, range, weapon, validfn)
        end
    end
    end
    --Prevent Wolf from friendly firing Prince! Shipwrecked and Hamlet version!
    if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
    local _oldDoAreaAttack = self.DoAreaAttack
    function self:DoAreaAttack(target, range, weapon, validfn, stimuli)
        if self.inst and self.inst.prefab == "princess" then
            local hitcount = 0
            local pt = GLOBAL.Vector3(target.Transform:GetWorldPosition() )
            local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, range, nil, {"falling", "FX", "NOCLICK", "DECOR", "INLIMBO"})
            for i,ent in ipairs(ents) do
                if ent.components.combat 
                and ent ~= target 
                and ent ~= self.inst
                and ent.prefab ~= "prince" 
                and not ent:HasTag("pugalisk")
                --and not ent:HasTag("pugalisk")
                and self:CanAreaHitTarget(ent) 
                and (not validfn or validfn(ent)) then
                    self.inst:PushEvent("onareaattackother", {target = target, weapon = weapon, stimuli = stimuli})
                    ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
                    hitcount = hitcount + 1
                elseif ent.components.combat 
                and ent == target 
                and ent ~= self.inst 
                and self.inst.sg:HasStateTag("secondattack")
                and self:CanAreaHitTarget(ent)
                and (not validfn or validfn(ent)) then
                    self.inst:PushEvent("onareaattackother", {target = target, weapon = weapon, stimuli = stimuli})
                    ent.components.combat:GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
                    hitcount = hitcount + 1
                end
            end
            return hitcount
        else
        return _oldDoAreaAttack(self, target, range, weapon, validfn, stimuli)
        end
    end
    end

end)



















if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then


--Make Prince get affected by waves too!
AddPrefabPostInit("wave_ripple", function(inst)

local function wetanddamage(inst, other)
    --get wet and take damage 
    if other and other.components.moisture then
        local hitmoisturerate = 1.0
        if other.components.driver and other.components.driver.vehicle and other.components.driver.vehicle.components.drivable then
            hitmoisturerate = other.components.driver.vehicle.components.drivable:GetHitMoistureRate()
        end
        local waterproofMultiplier = 1 
        if other.components.inventory then 
            waterproofMultiplier = 1 - other.components.inventory:GetWaterproofness()
        end 
        other.components.moisture:DoDelta(inst.hitmoisture * hitmoisturerate * waterproofMultiplier)
    end 
    if other and other.components.driver and other.components.driver.vehicle then 
        local vehicle = other.components.driver.vehicle
        if vehicle.components.boathealth then
            vehicle.components.boathealth:DoDelta(inst.hitdamage, "wave")
        end
    end 
end

local function splash(inst)

    local splash = GLOBAL.SpawnPrefab("splash_water")
    local pos = inst:GetPosition()
    splash.Transform:SetPosition(pos.x, pos.y, pos.z)

    inst:Remove()

end 

local function oncollidewave(inst, other)

    local boostThreshold = GLOBAL.TUNING.WAVE_BOOST_ANGLE_THRESHOLD
    if other:HasTag("blindprince") or other == GLOBAL.GetPlayer() then-- and inst.sg:HasStateTag("idle") then
        local moving = other.sg:HasStateTag("moving") or GLOBAL.GetPlayer().sg:HasStateTag("moving")
        local playerAngle =  other.Transform:GetRotation()
        if playerAngle < 0 then playerAngle = playerAngle + 360 end 

        local waveAngle = inst.Transform:GetRotation()
        if waveAngle < 0 then waveAngle = waveAngle + 360 end 

        local angleDiff = math.abs(waveAngle - playerAngle)
        inst.SoundEmitter:PlaySound( "dontstarve_DLC002/common/wave_break")
        if angleDiff > 180 then angleDiff = 360 - angleDiff end

        local surfer = false
        if other.components.locomotor then
            surfer = other.components.locomotor:HasSpeedModifier("SURF")
        end

        if (angleDiff < boostThreshold or surfer) and moving then
            --Do boost
            local rogueboost
            local player = GLOBAL.GetPlayer()
            if other:HasTag("blindprince") or other == player then
                if (player.components.driver.vehicle and player.components.driver.vehicle.prefab == "surfboard") or (other.components.driver.vehicle and other.components.driver.vehicle.prefab == "surfboard") then
                    rogueboost = GLOBAL.TUNING.SURFBOARD_ROGUEBOOST
                end
            end
            other:PushEvent("boostbywave", {position = inst.Transform:GetWorldPosition(), velocity = inst.Physics:GetVelocity(), boost = rogueboost})
            inst.SoundEmitter:PlaySound( "dontstarve_DLC002/common/wave_boost")
        elseif not surfer then
            wetanddamage(inst, other)
        end 

        splash(inst)
    elseif other and other.components.waveobstacle then
        other.components.waveobstacle:OnCollide(inst)
        wetanddamage(inst, other)
        splash(inst)
    end
end 


local function oncolliderogue(inst, other)
    -- check for surfboard, which actually just boosts
    local player = GLOBAL.GetPlayer()
    if other:HasTag("blindprince") or other == player then
        local surfer = false
        if other.components.locomotor then
            surfer = other.components.locomotor:HasSpeedModifier("SURF")
        end

        if surfer or (player.components.driver.vehicle and player.components.driver.vehicle.prefab == "surfboard") or (other.components.driver.vehicle and other.components.driver.vehicle.prefab == "surfboard") then
            oncollidewave(inst, other)
            return
        else
            wetanddamage(inst, other)
            splash(inst)
            return 
        end
    end

    if other and other.components.waveobstacle then
        other.components.waveobstacle:OnCollide(inst)
        wetanddamage(inst, other)
        splash(inst)
    end
   
end


--Determine the wave type, then its colliding behavior!
if inst.prefab == "wave_ripple" then
    inst.Physics:SetCollisionCallback(oncollidewave)
end
if inst.prefab == "rogue_wave" then
    inst.Physics:SetCollisionCallback(oncolliderogue)
end

end)


















--This is to warp Prince across the map if the player travels through the Shipwrecked world's edge fog!
AddComponentPostInit("mapwrapper", function(self)


local STATE_WAIT = 0
local STATE_WARN = 1
local STATE_MOVETOEDGE = 2
local STATE_MOVEFROMEDGE = 3
local STATE_MOVEEXTRA = 4


function self:OnUpdate( dt )
    local map = GLOBAL.GetWorld().Map
    local w, h = map:GetSize()
    local x, y, z = self.inst.Transform:GetLocalPosition()
    local tx, ty = map:GetTileCoordsAtPoint(x, y, z)

    local is_inrange = function(range)
        return (tx < range) or (w - tx < range) or (ty < range) or (h - ty < range)
    end

    if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

        local tile, tileinfo = self.inst:GetCurrentTileType(x, y, z)

        if tile == GLOBAL.GROUND.INTERIOR then
            return
        end

    end

    --if self.state ~= STATE_WAIT then print(string.format("%d (%d, %d) - (%d, %d)\n\t(%4.2f, %4.2f, %4.2f)\n", self.state, tx, ty, w, h, x, y, z)) end
    --local angle = self.inst.Transform:GetRotation()
    --print("angle", angle, angle * DEGREES)

    if self.state == STATE_WAIT then
        if is_inrange(GLOBAL.TUNING.MAPWRAPPER_WARN_RANGE) then

            self.inst.components.talker:Say(GLOBAL.GetString(self.inst.prefab, "ANNOUNCE_MAPWRAP_WARN"))

            self.state = STATE_WARN
        end

    elseif self.state == STATE_WARN then
        if not is_inrange(GLOBAL.TUNING.MAPWRAPPER_WARN_RANGE) then
            self.state = STATE_WAIT
        elseif is_inrange(GLOBAL.TUNING.MAPWRAPPER_LOSECONTROL_RANGE) then
            print("lose control", GLOBAL.TUNING.MAPWRAPPER_LOSECONTROL_RANGE, self.inst.Transform:GetRotation())

            if not self.inst:HasTag("blindprince") then
                self.inst.components.talker:Say(GLOBAL.GetString(self.inst.prefab, "ANNOUNCE_MAPWRAP_LOSECONTROL"))
            end

            self.inst.components.health:SetInvincible(true)
            if GLOBAL.TUNING.DO_SEA_DAMAGE_TO_BOAT and (self.inst.components.driver and self.inst.components.driver.vehicle and self.inst.components.driver.vehicle.components.boathealth) then
                self.inst.components.driver.vehicle.components.boathealth:SetInvincible(true)
            end


            --print("lose control get_angle2", -self.inst.Transform:GetRotation()*DEGREES, -self.inst.Transform:GetRotation())
            --local angle = get_angle2(x, y, z, -self.inst.Transform:GetRotation()*DEGREES)
            local angle = 0 
            local xDist = math.min(tx, math.abs(tx - w))
            local zDist = math.min(ty, math.abs(ty - h))
            
            if xDist < zDist then --horizontal (x)
                if x < 0 then 
                    angle = 180
                    self.warpdir = "left"
                else 
                    angle = 0 
                    self.warpdir = "right"
                end 
            else --vertical (z)
                if z < 0 then 
                    angle = 90 
                    self.warpdir = "down"
                else 
                    angle = -90
                    self.warpdir = "up"
                end 
            end 
            
            --self.inst.Transform:SetRotation(angle)
            --self.inst.components.locomotor:RunInDirection(angle)
            self.inst.components.locomotor:Stop(true)
            self.inst.components.locomotor:EnableGroundSpeedMultiplier(false)

            if self.inst == GLOBAL.GetPlayer() then
                self.inst.components.playercontroller:Enable(false)
            end
            if self.inst ~= GLOBAL.GetPlayer() then
                self.inst.components.locomotor.runspeed = 0
            end


            self.inst.Transform:SetRotation(angle)
            self.inst.Physics:SetMotorVelOverride(GLOBAL.TUNING.WILSON_RUN_SPEED, 0, 0)
            --self.inst.Physics:SetCollides(false)
            GLOBAL.GetPlayer().HUD:Hide()
            GLOBAL.TheFrontEnd:Fade(false, 6, nil, 1)
            self.state = STATE_MOVETOEDGE
        end

    elseif self.state == STATE_MOVETOEDGE then
        --print("move to egde", x, y, z, self.inst.Transform:GetRotation())
        --self.inst.components.locomotor:WalkForward()
        self.inst.Physics:SetMotorVelOverride(GLOBAL.TUNING.WILSON_RUN_SPEED, 0, 0)
        if is_inrange(GLOBAL.TUNING.MAPWRAPPER_TELEPORT_RANGE) then
            --print(string.format("run_test(%f, %f, %f, %f)", x, y, z, self.inst.Transform:GetRotation()))
            --local dx, dy, dz = get_dest(self.inst, x, y, z, self.inst.Transform:GetRotation() * DEGREES, true)
            local width = (w - 2)*GLOBAL.TILE_SCALE
            local height = (h - 2)*GLOBAL.TILE_SCALE
            local right, top = width/2.0, height/2.0
            local left, bottom = -right, -top

            local dx, dy, dz = x, y, z  

            if self.warpdir == "left" then 
                dx = right 
                dz = math.min(dz, top - (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE * 4 + 4))
                dz = math.max(dz, bottom + (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE * 4 + 4))
            elseif self.warpdir == "right" then 
                dx = left 
                dz = math.min(dz, top - (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE * 4 + 4))
                dz = math.max(dz, bottom + (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE * 4+ 4))
            elseif self.warpdir == "up" then 
                dz = bottom
                dx = math.min(dx, right - (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE*4 + 4))
                dx = math.max(dx, left + (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE*4 + 4))
            elseif self.warpdir == "down" then 
                dz = top
                dx = math.min(dx, right - (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE*4 + 4))
                dx = math.max(dx, left + (GLOBAL.TUNING.MAPWRAPPER_GAINCONTROL_RANGE*4 + 4))
            end 

            print("teleport", dx, dy, dz, self.inst.Transform:GetRotation())
            self.inst.Transform:SetPosition(dx, dy, dz)
            if self.inst.components.driver and self.inst.components.driver.vehicle then 
                self.inst.components.driver.vehicle.Transform:SetPosition(dx, dy, dz)
            end 
            self.state = STATE_MOVEFROMEDGE
            self.inst:DoTaskInTime(2, function()
                GLOBAL.TheFrontEnd:Fade(true, 6)
            end)
        end

    elseif self.state == STATE_MOVEFROMEDGE then
        --self.inst.components.locomotor:WalkForward()
        self.inst.Physics:SetMotorVelOverride(GLOBAL.TUNING.WILSON_RUN_SPEED, 0, 0)

        if not is_inrange(TUNING.MAPWRAPPER_GAINCONTROL_RANGE) then
            print("gain control")
            GLOBAL.GetPlayer().HUD:Show()
            if self.inst.components.sanity then
                self.inst.components.sanity:DoDelta(-GLOBAL.TUNING.SANITY_MED)
            end

            self.inst.components.talker:Say(GLOBAL.GetString(self.inst.prefab, "ANNOUNCE_MAPWRAP_RETURN"))

            --self.inst.components.locomotor:Clear()
            --self.inst.components.locomotor:StopMoving()
            self.inst.Physics:Stop()
            self.inst.components.locomotor:Stop()
            self.inst.components.locomotor:EnableGroundSpeedMultiplier(true)
            self.inst.components.health:SetInvincible(false)
            if TUNING.DO_SEA_DAMAGE_TO_BOAT and (self.inst.components.driver and self.inst.components.driver.vehicle and self.inst.components.driver.vehicle.components.boathealth) then
                self.inst.components.driver.vehicle.components.boathealth:SetInvincible(false)
            end
                
            if self.inst == GLOBAL.GetPlayer() then
                self.inst.components.playercontroller:Enable(true)
            end
            if self.inst ~= GLOBAL.GetPlayer() then
                self.inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED
            end

            --Warp Prince to Princess's new location!
            --self.inst:DoTaskInTime(4, function()
                local prince = GLOBAL.FindEntity(self.inst, 15000, function(ent)
                    return ent:HasTag("blindprince")
                end)
                if prince and prince.components.follower and prince.components.follower.leader then

                    prince.Transform:SetPosition(self.inst:GetPosition():Get())
                    local fx = GLOBAL.SpawnPrefab("statue_transition_2")
                    if fx then
                        fx.Transform:SetPosition(prince:GetPosition():Get())
                        fx.AnimState:SetScale(2,3,2)
                    end

                    if self.inst.components.leader and prince.components.follower and not prince.components.follower.leader then
                        self.inst.components.leader:AddFollower(prince)
                    end

                end
            --end)

            --self.inst.Physics:SetCollides(true)
            self.state = STATE_WARN
        end

    --[[elseif self.state == STATE_MOVEEXTRA then
        self.inst.components.locomotor:WalkForward()
        if not is_inrange(TUNING.MAPWRAPPER_GAINCONTROL_RANGE + 2) or self.inst.components.playercontroller:WalkButtonDown() then
            print("move extra")
            self.inst.components.locomotor:Clear()
            self.inst.components.locomotor:StopMoving()
            self.state = STATE_WARN
        end]]
    end
end

end)


end


















--Princess should be resistant to sneezing!
if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then

AddComponentPostInit("hayfever", function(self)

function self:CanSneeze()

    local can = true

    local x, y, z = self.inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, y, z, 30, {"prevents_hayfever"})
    local suppressorNearby = (#ents > 0)

    if self.inst:HasTag("has_gasmask") or self.inst:HasTag("has_hayfeverhat") or suppressorNearby or self.inst:HasTag("liarprincess") or self.inst:HasTag("wolf") then
        can = false
    end

    return can
end

end)



















--Long and hideous, but it's to make sure the Roc (Johnson) doesn't abduct Princess in Wolf form. Wolf should scare her away!
AddComponentPostInit("roccontroller", function(self)
function self:OnUpdate(dt)

    local function getanglepointtopoint(x1,z1,x2,z2)                
        local dz = z1 - z2
        local dx = x2 - x1
        local angle = math.atan2(dz, dx) / GLOBAL.DEGREES
        return angle                
    end 


    local HEAD_ATTACK_DIST = 0.1 -- 1.5
    local SCALERATE = 1/(30 *2)  -- 2 seconds to go from 0 to 1

    local HEADDIST = 17
    local HEADDIST_TARGET = 15
    local BODY_DIST_TOLLERANCE = 2

    local TAILDIST = 13

    local LEGDIST = TUNING.ROC_LEGDSIT
    local LEG_WALKDIST = 4
    local LEG_WALKDIST_BIG = 6
    local LAND_PROX = 15 --7


    local player = GLOBAL.GetPlayer()
    local px,py,pz = player.Transform:GetWorldPosition()
    
    local ground = GLOBAL.GetWorld()
    local tile = GLOBAL.GetVisualTileType(px, py, pz)
    local onvalidtiles = true
    if tile == GLOBAL.GROUND.FOUNDATION or tile == GLOBAL.GROUND.COBBLEROAD or tile == GLOBAL.GROUND.LAWN or tile == GLOBAL.GROUND.LILYPOND or tile == GLOBAL.GROUND.DEEPRAINFOREST or tile == GLOBAL.GROUND.GASJUNGLE then    --  tile == GROUND.FIELDS or
        onvalidtiles = false
    end

    if player.sg:HasStateTag("scary_to_predator") then
        onvalidtiles = false
    end

    -- Roc doesnt like the living artifact.
    if player.livingartifact then
        onvalidtiles = false
    end

    -- Roc doesn't like Wolf either!
    if player:HasTag("wolf") then
        onvalidtiles = false
    end

    if GLOBAL.TheCamera.interior then
        onvalidtiles = false
    end

    local onvaliddungtiles = false  

    local cx,cy,cz = self.inst.Transform:GetWorldPosition()
    local roctile = ground.Map:GetTileAtPoint(cx,cy,cz)

    if roctile == GLOBAL.GROUND.RAINFOREST or roctile == GLOBAL.GROUND.PLAINS then     
        onvaliddungtiles = true
    end


    local disttoplayer = self.inst:GetDistanceSqToInst(player)
    if disttoplayer > 50*50 then --The 50's were SCREEN_DIST, but they amount to 50 in the roccontroller component.
        -- has landed and is flying again, should leave now
        if self.liftoff and not self.inst.teleporting then
            print("FLY AWAY")
            self.inst:Remove()
        elseif not self.landed then         
            self.inst.Transform:SetRotation(self.inst:GetAngleToPoint(px, py, pz))
        end
    end

    if self.scaleup then
        local currentscale = self.inst.Transform:GetScale()
        if currentscale ~= self.scaleup.targetscale then
            local setscale = math.min( currentscale + (SCALERATE*dt), self.scaleup.targetscale )
            self:setscale(setscale)         
        else 
            self.scaleup = nil
        end
    end

    if self.inst.Transform:GetScale() == 1 and not self.landed and not self.liftoff then                    
        if disttoplayer < LAND_PROX*LAND_PROX and onvalidtiles then
            self.landed = true
            self.inst:PushEvent("land")
        end         
    end

    local dungok = true
    if GLOBAL.GetWorld().getworldgenoptions(GLOBAL.GetWorld())["dungpile"] then
        if GLOBAL.GetWorld().getworldgenoptions(GLOBAL.GetWorld())["dungpile"] == "never" then
            dungok = false
        end
    end

    if not self.landed and onvaliddungtiles and dungok then             

        if self.dungtime > 0 then
            self.dungtime = math.max(self.dungtime - dt,0)
        else
            local pos = GLOBAL.Vector3(self.inst.Transform:GetWorldPosition())
            local ents = GLOBAL.TheSim:FindEntities(pos.x,pos.y,pos.z, 50, {"dungpile"})
            if #ents < 2 then
                
                self.inst:DoTaskInTime(1 + GLOBAL.Remap(self.inst.Transform:GetScale(), 0.35, 1,2,0), function()
                    local crap = GLOBAL.SpawnPrefab("dungpile")
                    crap.Transform:SetPosition(cx,cy,cz)
                    crap.fall(crap)
                end)
            end
            self.dungtime = math.random()*10 + 2
        end     
    end

    if not self.busy then
        if self.landed and self.head and self.tail and self.leg1 and self.leg2 then
            if onvalidtiles and not GLOBAL.GetClock():IsNight() and not player.components.health:IsDead() and not player:HasTag("wolf") then

                local target = self:GetTarget()
                
                -- HEAD
                if not self.head.sg:HasStateTag("busy") then
                    local targetpos =GLOBAL.Vector3(target.Transform:GetWorldPosition())   
                    local headdistsq = self.head:GetDistanceSqToInst(target) 
                    if headdistsq > HEAD_ATTACK_DIST*HEAD_ATTACK_DIST then          
                        self.head_vel = math.min(self.head_vel + (self.head_acc *dt), self.head_vel_max)
                    else                    
                        if self.target:HasTag("isinventoryitem") or self.target == GLOBAL.GetPlayer() then                         
                            if self.target == GLOBAL.GetPlayer() and not self.target.sg:HasStateTag("cower") then
                                GLOBAL.GetPlayer():PushEvent("cower")
                            end                                                             
                            if headdistsq < 0.2 then
                                self.head:PushEvent("gobble")               
                            end
                        else
                            self.head:PushEvent("bash")             
                        end
                        self.head_vel = math.max(self.head_vel - (self.head_acc *dt), 0)
                    end
                    local HEAD_VEL = self.head_vel *dt

                    local angle = self.head:GetAngleToPoint(targetpos)*GLOBAL.DEGREES
                    local offset = GLOBAL.Vector3(HEAD_VEL * math.cos( angle ), 0, -HEAD_VEL * math.sin( angle ))
                    local pos = GLOBAL.Vector3(self.head.Transform:GetWorldPosition())
                    self.head.Transform:SetPosition(pos.x+offset.x,0,pos.z+offset.z)
                end

                -- BODY
                local bodistsq = self.inst:GetDistanceSqToInst(self.head) 
                local pos = GLOBAL.Vector3(self.inst.Transform:GetWorldPosition())
                
                local BOD_VEL_MAX = self.speed
                local BOD_ACC_MAX = 0.5 --5
                local targetpos = GLOBAL.Vector3(self.head.Transform:GetWorldPosition())
                local angle = self.head:GetAngleToPoint(pos)*GLOBAL.DEGREES
                local offset = GLOBAL.Vector3(1 * math.cos( angle ), 0, -1 * math.sin( angle ))
                offset.x = offset.x*HEADDIST_TARGET
                offset.z = offset.z*HEADDIST_TARGET
                targetpos = targetpos + GLOBAL.Vector3(offset.x,0,offset.z)

                local bodistsq = self.inst:GetDistanceSqToPoint(targetpos) 

                if bodistsq > BODY_DIST_TOLLERANCE * BODY_DIST_TOLLERANCE then
                    local cpbv = pos + GLOBAL.Vector3(self.body_vel.x,0,self.body_vel.z)
                    local angle = getanglepointtopoint(cpbv.x,cpbv.z,targetpos.x,targetpos.z)*GLOBAL.DEGREES           
                    local offset = GLOBAL.Vector3(BOD_ACC_MAX * math.cos( angle ), 0, -BOD_ACC_MAX * math.sin( angle ))            
                    local cpbvtv = cpbv + GLOBAL.Vector3(offset.x,0,offset.z)
                    local finalangle = self.inst:GetAngleToPoint(cpbvtv)*GLOBAL.DEGREES
                    local finalvel = math.min(BOD_VEL_MAX, math.sqrt(self.inst:GetDistanceSqToPoint(cpbvtv))    )
                    self.body_vel = GLOBAL.Vector3(finalvel * math.cos( finalangle ), 0, -finalvel * math.sin( finalangle ))
                else

                    local angle = self.inst:GetAngleToPoint(targetpos)*GLOBAL.DEGREES          
                    local vel = math.max( math.sqrt((self.body_vel.x * self.body_vel.x) + (self.body_vel.z * self.body_vel.z)) - (BOD_ACC_MAX*dt) , 0)
                    self.body_vel = GLOBAL.Vector3(vel * math.cos( angle ), 0, -vel * math.sin( angle ))
                end
                self.inst.Transform:SetPosition(pos.x+(self.body_vel.x * dt),0,pos.z+(self.body_vel.z *dt)  )

                --TAIL
                local angle = (self.inst.Transform:GetRotation()*GLOBAL.DEGREES) + GLOBAL.PI
                local tailtarget =  GLOBAL.Vector3(TAILDIST * math.cos( angle ), 0, -TAILDIST * math.sin( angle ))
                tailtarget =GLOBAL.Vector3(self.inst.Transform:GetWorldPosition()) + tailtarget
                local taildistsq = self.tail:GetDistanceSqToPoint(tailtarget)
                local pos = GLOBAL.Vector3(self.tail.Transform:GetWorldPosition())
                local TAIL_VEL_MAX = self.speed 
                local TAIL_ACC_MAX = 0.3 --5

                if taildistsq > 1 * 1 then
                    local cpbv = pos + GLOBAL.Vector3(self.tail_vel.x,0,self.tail_vel.z)
                    local angle = getanglepointtopoint(cpbv.x,cpbv.z,tailtarget.x,tailtarget.z)*GLOBAL.DEGREES         
                    local offset = GLOBAL.Vector3(TAIL_ACC_MAX * math.cos( angle ), 0, -TAIL_ACC_MAX * math.sin( angle ))          
                    local cpbvtv = cpbv + GLOBAL.Vector3(offset.x,0,offset.z)
                    local finalangle = self.tail:GetAngleToPoint(cpbvtv)*GLOBAL.DEGREES
                    local finalvel = math.min(TAIL_VEL_MAX, math.sqrt(self.tail:GetDistanceSqToPoint(cpbvtv))    )
                    self.tail_vel = GLOBAL.Vector3(finalvel * math.cos( finalangle ), 0, -finalvel * math.sin( finalangle ))
                else

                    local angle = self.tail:GetAngleToPoint(tailtarget)*GLOBAL.DEGREES         
                    local vel = math.max( math.sqrt((self.tail_vel.x * self.tail_vel.x) + (self.tail_vel.z * self.tail_vel.z)) - (TAIL_ACC_MAX*dt) , 0)
                    self.tail_vel = GLOBAL.Vector3(vel * math.cos( angle ), 0, -vel * math.sin( angle ))
                end
                self.tail.Transform:SetPosition(pos.x+(self.tail_vel.x * dt),0,pos.z+(self.tail_vel.z *dt)  )

                -- set rotations
                local headpos =GLOBAL.Vector3(self.head.Transform:GetWorldPosition())

                        -- body rotation has velocity. 
                        local body_angular_vel_max = 36/3
                        if not self.body_angle_vel then
                            self.body_angle_vel = 0
                        end
                        
                        local targetAngle = self.inst:GetAngleToPoint(headpos)
                        local currentAngle = self.inst.Transform:GetRotation()
                    
                        if math.abs(GLOBAL.anglediff( currentAngle, targetAngle)) < 20 then

                            if self.body_angle_vel > 0 then
                                self.body_angle_vel = math.max(0, self.body_angle_vel - (self.angular_body_acc *dt))
                            elseif self.body_angle_vel < 0 then
                                self.body_angle_vel = math.min(0, self.body_angle_vel + (self.angular_body_acc *dt))
                            end
                            
                        else
                            if targetAngle > currentAngle then
                                if targetAngle - currentAngle < 180 then
                                    self.body_angle_vel = math.min(body_angular_vel_max, self.body_angle_vel + (self.angular_body_acc *dt))
                                else
                                    self.body_angle_vel = math.max(-body_angular_vel_max, self.body_angle_vel - (self.angular_body_acc *dt))
                                end
                            else
                                if currentAngle - targetAngle < 180 then
                                    self.body_angle_vel = math.max(-body_angular_vel_max, self.body_angle_vel - (self.angular_body_acc *dt))                            
                                else
                                    self.body_angle_vel = math.min(body_angular_vel_max, self.body_angle_vel + (self.angular_body_acc *dt))
                                end                     
                            end
                        end 

                        --print("self.body_angle_vel",self.body_angle_vel)
                        currentAngle = currentAngle + (self.body_angle_vel*dt)          
                        self.inst.Transform:SetRotation( currentAngle )
                
                if not self.head.sg:HasStateTag("busy") then
                    local targetpos =GLOBAL.Vector3(target.Transform:GetWorldPosition())
                    local angle = self.head:GetAngleToPoint(targetpos.x,targetpos.y,targetpos.z)
                    self.head.Transform:SetRotation(angle)
                end

                --self.head.Transform:SetRotation(self.inst.Transform:GetRotation())    
                self.tail.Transform:SetRotation(self.inst.Transform:GetRotation())  

                -- LEGS
                if not self.leg1.sg:HasStateTag("walking") and not self.leg2.sg:HasStateTag("walking") then

                    local legdir = GLOBAL.PI/2
                    if self.currentleg == 2 then
                        legdir = legdir * -1
                    end

                    local angle = self.inst.Transform:GetRotation()*GLOBAL.DEGREES

                    local currentlegtargetpos = GLOBAL.Vector3(self.inst.Transform:GetWorldPosition()) + GLOBAL.Vector3(LEGDIST * math.cos( angle+legdir ), 0, -LEGDIST * math.sin( angle+legdir ))
                    local legdistsq = self.currentleg:GetDistanceSqToPoint(currentlegtargetpos)
                    local anglediff =  GLOBAL.anglediff(self.currentleg.Transform:GetRotation(), self.inst.Transform:GetRotation())
                    if legdistsq > LEG_WALKDIST * LEG_WALKDIST or anglediff > self.turn_threshold then

                        if legdistsq < LEG_WALKDIST_BIG*LEG_WALKDIST_BIG  or (anglediff > self.turn_threshold and legdistsq <= LEG_WALKDIST_BIG*LEG_WALKDIST_BIG ) then
                            self.currentleg:PushEvent("walkfast")
                        else
                            self.currentleg:PushEvent("walk")
                        end
                                                            
                        if self.currentleg == self.leg1 then
                            self.currentleg = self.leg2
                        else
                            self.currentleg = self.leg1
                        end
                    end         
                end
            else
                self.inst:PushEvent("liftoff")
            end
            -- move tail to point in position like head. 
        end
    end
end

end)

end



















--All of this from here on is to make sure Prince is affected by heat stones in his inventory. Hideous, but it must be done.

--Prince's thermal stone compatibility code! Vanilla version!
if not GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
AddComponentPostInit("temperature", function(self)

local _oldOnUpdate = self.OnUpdate
function self:OnUpdate(dt, applyhealthdelta)
    
if self.inst:HasTag("blindprince") then

    if self.settemp then return end


    if applyhealthdelta == nil then
        applyhealthdelta = true
    end
    
    if (self.inst.components.health and self.inst.components.health.invincible == true) or self.inst.is_teleporting == true then
        return
    end

    local last = self.current

    local ambient_delta = GLOBAL.GetSeasonManager() and (GLOBAL.GetSeasonManager():GetCurrentTemperature() - self.current) or 30

    --figure out our insulation
    local total_insulation = 0

    total_insulation = total_insulation + self.inherentinsulation

    if self.inst.components.inventory then
        for k,v in pairs (self.inst.components.inventory.equipslots) do
            if v.components.heater then
                local heat = v.components.heater:GetEquippedHeat()
                if heat > self.current and not v.components.heater.iscooler then
                    ambient_delta = ambient_delta + (heat - self.current)
                elseif heat < self.current and v.components.heater.iscooler then
                    ambient_delta = ambient_delta + (heat - self.current)
                end
            end
            
            if v.components.insulator then
                total_insulation = total_insulation + v.components.insulator.insulation
            end
        end
        for k,v in pairs(self.inst.components.inventory.itemslots) do
            if v.components.heater then
                local heat = v.components.heater:GetCarriedHeat()
                if heat > self.current and not v.components.heater.iscooler then
                    ambient_delta = ambient_delta + (heat - self.current)
                elseif heat < self.current and v.components.heater.iscooler then
                    ambient_delta = ambient_delta + (heat - self.current)
                end
            end
        end

        if self.inst.components.inventory.overflow and self.inst.components.inventory.overflow.components.container then
            for k,v in pairs(self.inst.components.inventory.overflow.components.container.slots) do
                if v.components.heater then
                    local heat = v.components.heater:GetCarriedHeat()
                    if heat > self.current and not v.components.heater.iscooler then
                        ambient_delta = ambient_delta + (heat - self.current)
                    elseif heat < self.current and v.components.heater.iscooler then
                        ambient_delta = ambient_delta + (heat - self.current)
                    end
                end
            end
        end



        --FOR PRINCE!!!
        if self.inst.components.container then
            for k,v in pairs(self.inst.components.container.slots) do
                if v.components.heater then
                    local heat = v.components.heater:GetCarriedHeat()
                    if heat > self.current and not v.components.heater.iscooler then
                        ambient_delta = ambient_delta + (heat - self.current)
                    elseif heat < self.current and v.components.heater.iscooler then
                        ambient_delta = ambient_delta + (heat - self.current)
                    end
                end
            end
        end
        --FOR PRINCE!!!



    end
    
    if self.inst.components.beard then
        total_insulation = total_insulation + self.inst.components.beard:GetInsulation()
    end

    --now figure out the temperature where we are standing
    local x,y,z = self.inst.Transform:GetWorldPosition()
    
    local ZERO_DISTANCE = 10
    local ZERO_DISTSQ = ZERO_DISTANCE*ZERO_DISTANCE

    local ents = GLOBAL.TheSim:FindEntities(x,y,z, ZERO_DISTANCE, {"HASHEATER"})
    for k,v in pairs(ents) do 
        if v.components.heater and v ~= self.inst and not v:IsInLimbo() then
            local heat = v.components.heater:GetHeat(self.inst)
            local distsq = self.inst:GetDistanceSqToInst(v)

            -- This produces a gentle falloff from 1 to zero.
            local heatfactor = ((-1/ZERO_DISTSQ)*distsq) + 1

            if heat*heatfactor > self.current then
                ambient_delta = ambient_delta + (heat*heatfactor - self.current)
            end
        end
    end 

    local delta = ambient_delta
    self.last_real_delta = delta
    local freeze_time = GLOBAL.TUNING.SEG_TIME + total_insulation
    local WARM_DEGREES_PER_SECOND = 1
    local THAW_DEGREES_PER_SECOND = 5
    
    if delta < 0 then
        self.rate = math.max(delta, -30 / freeze_time)
    elseif delta > 0 then
        
        self.rate = math.min(delta, self.current <= 0 and THAW_DEGREES_PER_SECOND or WARM_DEGREES_PER_SECOND)
    else
        self.rate = 0
    end
    
    
    self.current = math.max( math.min( self.current + self.rate*dt, self.maxtemp), self.mintemp)
    
    if (self.current < 0) ~= (last < 0)  then
        if self.current < 0 then
            self.inst:PushEvent("startfreezing")
        else
            self.inst:PushEvent("stopfreezing")
        end
    end

    self.inst:PushEvent("temperaturedelta")
    
    if applyhealthdelta and self.current < 0 and self.inst.components.health then
        self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "cold") 
    end

else
    return _oldOnUpdate(self, dt, applyhealthdelta)
end
    
end

end)
end



















--Prince's thermal stone compatibility code! Reign of Giants version!
if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) and not GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) and not GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
AddComponentPostInit("temperature", function(self)

local _oldOnUpdate = self.OnUpdate
function self:OnUpdate(dt, applyhealthdelta)

if self.inst:HasTag("blindprince") then
    
    if self.settemp then return end

    if applyhealthdelta == nil then
        applyhealthdelta = true
    end
    
    if (self.inst.components.health and self.inst.components.health.invincible == true) or self.inst.is_teleporting == true then
        return
    end

    local last = self.current

    local seasonmgr = GLOBAL.GetSeasonManager()
    local ambient_delta = ((seasonmgr and seasonmgr:GetCurrentTemperature() or GLOBAL.TUNING.STARTING_TEMP) - self.current) or 0

    ambient_delta = ambient_delta - self:GetMoisturePenalty()

    if seasonmgr and self.inst.components.inventory then
        for k,v in pairs (self.inst.components.inventory.equipslots) do
            if v.components.heater then
                local heat = v.components.heater:GetEquippedHeat()
                if heat ~= nil and heat > self.current then
                    ambient_delta = ambient_delta + (heat - self.current)
                elseif heat ~= nil and heat < self.current then
                    ambient_delta = ambient_delta - (self.current - heat)
                end
            end
        end
        for k,v in pairs(self.inst.components.inventory.itemslots) do
            if v.components.heater then
                local carrieddelta = v.components.heater:GetCarriedHeat()
                if carrieddelta ~= nil then
                    ambient_delta = ambient_delta + carrieddelta
                end
            end
        end
        if self.inst.components.inventory.overflow and self.inst.components.inventory.overflow.components.container then
            for k,v in pairs(self.inst.components.inventory.overflow.components.container.slots) do
                if v.components.heater then
                    local carrieddelta = v.components.heater:GetCarriedHeat()
                    if carrieddelta ~= nil then
                        ambient_delta = ambient_delta + carrieddelta
                    end
                end
            end
        end



        ----FOR PRINCE!!!
        if self.inst.components.container then
            for k,v in pairs(self.inst.components.container.slots) do
                if v.components.heater then
                    local carrieddelta = v.components.heater:GetCarriedHeat()
                    if carrieddelta ~= nil then
                        ambient_delta = ambient_delta + carrieddelta
                    end
                end
            end
        end
        ----FOR PRINCE!!!



        -- Recently eaten temperatured food is inherently equipped heat/cold
        if self.inst.recent_temperatured_food and self.inst.recent_temperatured_food ~= 0 then
            ambient_delta = ambient_delta + self.inst.recent_temperatured_food
        end
    end

    -- If very hot (basically only when have overheating screen effect showing) and under shelter, cool slightly
    if self.current > GLOBAL.TUNING.TREE_SHADE_COOLING_THRESHOLD and self.sheltered then
        ambient_delta = ambient_delta - (self.current - GLOBAL.TUNING.TREE_SHADE_COOLER)
    end

    --now figure out the temperature where we are standing
    local x,y,z = self.inst.Transform:GetWorldPosition()
    
    local ZERO_DISTANCE = 10
    local ZERO_DISTSQ = ZERO_DISTANCE*ZERO_DISTANCE

    local ents = GLOBAL.TheSim:FindEntities(x,y,z, ZERO_DISTANCE, {"HASHEATER"})
    local area_heat = 0
    local num_area_heat_sources = 0
    for k,v in pairs(ents) do 
        if v.components.heater and v ~= self.inst and not v:IsInLimbo() then
            local heat = v.components.heater:GetHeat(self.inst)
            local distsq = self.inst:GetDistanceSqToInst(v)

            -- This produces a gentle falloff from 1 to zero.
            local heatfactor = ((-1/ZERO_DISTSQ)*distsq) + 1
            local mm = GLOBAL.GetWorld().components.moisturemanager
            if mm and ((not mm:IsEntityDry(self.inst)) or (mm:IsWorldWet() and not GLOBAL.GetPlayer().components.inventory:IsWaterproof())) then
                heatfactor = heatfactor * GLOBAL.TUNING.WET_HEAT_FACTOR_PENALTY
            end

            if heat*heatfactor > self.current then
                if heat > 0 then
                    area_heat = area_heat + (heat*heatfactor - self.current)
                    num_area_heat_sources = num_area_heat_sources + 1
                end
            elseif heat*heatfactor < self.current then
                if heat < 0 then
                    area_heat = area_heat - (self.current - heat*heatfactor)
                    num_area_heat_sources = num_area_heat_sources + 1
                end
            end
        end
    end 
    if num_area_heat_sources > 0 then
        ambient_delta = ambient_delta + (area_heat / num_area_heat_sources)
    end
    
    local winterInsulation, summerInsulation = self:GetInsulation()

    local delta = ambient_delta
    self.last_real_delta = delta
    local freezeTime = GLOBAL.TUNING.SEG_TIME + winterInsulation
    local overheatTime = GLOBAL.TUNING.SEG_TIME + summerInsulation 
    -- local freeze_or_overheat_time = TUNING.SEG_TIME + total_insulation

    if seasonmgr then
        if self:IsCooling() and self:IsCool() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --cooling down, obj is cold, world is hot
                self.rate = math.max(delta, -GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            else --cooling down, obj is cold, world is cold
                self.rate = math.max(delta, -GLOBAL.TUNING.SEG_TIME / freezeTime) 
            end
        elseif self:IsWarming() and self:IsCool() then 
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --warming up, obj is cold and world is hot
                self.rate = math.min(delta, GLOBAL.TUNING.SEG_TIME / overheatTime)
            else --warming up, obj is cold and world is cold
                self.rate = math.min(delta, self.current <= 0 and GLOBAL.TUNING.THAW_DEGREES_PER_SEC or GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            end
        elseif self:IsCooling() and self:IsWarm() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --cooling down, obj is warm and world is hot
                self.rate = math.max(delta, self.current >= self.overheattemp and -GLOBAL.TUNING.THAW_DEGREES_PER_SEC or -GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            else --cooling down, obj is warm and world is cold
                self.rate = math.max(delta, -GLOBAL.TUNING.SEG_TIME / freezeTime)
            end
        elseif self:IsWarming() and self:IsWarm() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --warming up, obj is warm, world is hot
                self.rate = math.min(delta, GLOBAL.TUNING.SEG_TIME / overheatTime)
            else --warming up, obj is warm, world is cold
                self.rate = math.min(delta, GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            end
        else
            self.rate = 0
        end
    end

    if self.inst.components.inventoryitem and 
        self.inst.components.inventoryitem.owner and 
        self.inst.components.inventoryitem.owner:HasTag("fridge") and not
        self.inst.components.inventoryitem.owner:HasTag("nocool") and --For icepack.
        self.current > 0 then -- Don't cool it below freezing
        self.rate = -GLOBAL.TUNING.WARM_DEGREES_PER_SEC
        if self.inst.components.inventoryitem.owner:HasTag("lowcool") then
            self.rate = self.rate * .5
        end
    end
        
    -- --Always get "slowest" rate. Max when cooling, Min when warming.
    -- if delta < 0 and self.current < TUNING.STARTING_TEMP then
    --  self.rate = math.max(delta, -TUNING.SEG_TIME / freeze_or_overheat_time)
    -- elseif delta > 0 and self.current < TUNING.STARTING_TEMP then    
    --  self.rate = math.min(delta, self.current <= 0 and TUNING.THAW_DEGREES_PER_SEC or TUNING.WARM_DEGREES_PER_SEC)
    -- elseif delta < 0 and self.current >= TUNING.STARTING_TEMP then
    --  self.rate = math.max(delta, self.current <= self.overheattemp and -TUNING.THAW_DEGREES_PER_SEC or -TUNING.WARM_DEGREES_PER_SEC)
    -- elseif delta > 0 and self.current >= TUNING.STARTING_TEMP then   
    --  self.rate = math.min(delta, TUNING.SEG_TIME / freeze_or_overheat_time)
    -- else
    --  self.rate = 0
    -- end
        
    self.current = math.max( math.min( self.current + self.rate*dt, self.maxtemp), self.mintemp)
    
    if (self.current < 0) ~= (last < 0)  then
        if self.current < 0 then
            self.inst:PushEvent("startfreezing")
        else
            self.inst:PushEvent("stopfreezing")
        end
    end

    if (self.current > self.overheattemp) ~= (last > self.overheattemp) then
        if self.current > self.overheattemp then
            self.inst:PushEvent("startoverheating")
        else
            self.inst:PushEvent("stopoverheating")
        end
    end

    self.inst:PushEvent("temperaturedelta")
    
    if applyhealthdelta and self.current < 0 and self.inst.components.health then
        self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "cold") 
    elseif applyhealthdelta and self.current > self.overheattemp and self.inst.components.health then
        self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "hot") 
    end

else
    return _oldOnUpdate(self, dt, applyhealthdelta)
end
    
end

end)
end



















--Prince's thermal stone compatibility code! Shipwrecked and Hamlet version!
if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
AddComponentPostInit("temperature", function(self)

local _oldOnUpdate = self.OnUpdate
function self:OnUpdate(dt, applyhealthdelta)

if self.inst:HasTag("blindprince") then
    
    if self.settemp then return end

    if applyhealthdelta == nil then
        applyhealthdelta = true
    end
    
    if (self.inst.components.health and self.inst.components.health.invincible == true) or self.inst.is_teleporting == true then
        return
    end

    local last = self.current

    local seasonmgr = GLOBAL.GetSeasonManager()
    local ambient_delta = ((seasonmgr and seasonmgr:GetCurrentTemperature() or GLOBAL.TUNING.STARTING_TEMP) - self.current) or 0

    ambient_delta = ambient_delta - self:GetMoisturePenalty()

    if seasonmgr and self.inst.components.inventory then
        for k,v in pairs (self.inst.components.inventory.equipslots) do
            if v.components.heater then
                local heat = v.components.heater:GetEquippedHeat(self.inst)
                if v.components.heater.show_heat then
                    v:PushEvent("get_heat")
                end
                if heat ~= nil and heat > self.current then
                    ambient_delta = ambient_delta + (heat - self.current)
                elseif heat ~= nil and heat < self.current then
                    ambient_delta = ambient_delta - (self.current - heat)
                end
            end
        end
        for k,v in pairs(self.inst.components.inventory.itemslots) do
            if v.components.heater then
                local carrieddelta = v.components.heater:GetCarriedHeat()
                if v.components.heater.show_heat then
                    v:PushEvent("get_heat")
                end
                if carrieddelta ~= nil then
                    ambient_delta = ambient_delta + carrieddelta
                end
            end
        end
        if self.inst.components.inventory.overflow and self.inst.components.inventory.overflow.components.container then
            for k,v in pairs(self.inst.components.inventory.overflow.components.container.slots) do
                if v.components.heater then
                    local carrieddelta = v.components.heater:GetCarriedHeat()
                    if v.components.heater.show_heat then
                        v:PushEvent("get_heat")
                    end
                    if carrieddelta ~= nil then
                        ambient_delta = ambient_delta + carrieddelta
                    end
                end
            end
        end



        --FOR PRINCE!!!
        if self.inst.components.container then
            for k,v in pairs(self.inst.components.container.slots) do
                if v.components.heater then
                    local carrieddelta = v.components.heater:GetCarriedHeat()
                    if v.components.heater.show_heat then
                        v:PushEvent("get_heat")
                    end
                    if carrieddelta ~= nil then
                        ambient_delta = ambient_delta + carrieddelta
                    end
                end
            end
        end
        --FOR PRINCE!!!



        -- Recently eaten temperatured food is inherently equipped heat/cold
        if self.inst.recent_temperatured_food and self.inst.recent_temperatured_food ~= 0 then
            ambient_delta = ambient_delta + self.inst.recent_temperatured_food
        end
    end

    -- If very hot (basically only when have overheating screen effect showing) and under shelter, cool slightly
    if self.current > GLOBAL.TUNING.TREE_SHADE_COOLING_THRESHOLD and self.sheltered then
        ambient_delta = ambient_delta - (self.current - GLOBAL.TUNING.TREE_SHADE_COOLER)
    end

    --now figure out the temperature where we are standing
    local x,y,z = self.inst.Transform:GetWorldPosition()
    
    local ZERO_DISTANCE = 10
    local ZERO_DISTSQ = ZERO_DISTANCE*ZERO_DISTANCE

    local ents = GLOBAL.TheSim:FindEntities(x,y,z, ZERO_DISTANCE, {"HASHEATER"})
    local area_heat = 0
    local num_area_heat_sources = 0
    for k,v in pairs(ents) do 
        if v.components.heater and v ~= self.inst and not v:IsInLimbo() then
            local heat = v.components.heater:GetHeat(self.inst)
            if v.components.heater.show_heat then
                v:PushEvent("get_heat")
            end
            local distsq = self.inst:GetDistanceSqToInst(v)

            -- This produces a gentle falloff from 1 to zero.
            local heatfactor = ((-1/ZERO_DISTSQ)*distsq) + 1
            local mm = GLOBAL.GetWorld().components.moisturemanager
            if mm and ((not mm:IsEntityDry(self.inst)) or (mm:IsWorldWet() and not GLOBAL.GetPlayer().components.inventory:IsWaterproof())) then
                heatfactor = heatfactor * GLOBAL.TUNING.WET_HEAT_FACTOR_PENALTY
            end

            if heat*heatfactor > self.current then
                if heat > 0 then
                    area_heat = area_heat + (heat*heatfactor - self.current)
                    num_area_heat_sources = num_area_heat_sources + 1
                end
            elseif heat*heatfactor < self.current then
                if heat < 0 then
                    area_heat = area_heat - (self.current - heat*heatfactor)
                    num_area_heat_sources = num_area_heat_sources + 1
                end
            end
        end
    end 
    if num_area_heat_sources > 0 then
        ambient_delta = ambient_delta + (area_heat / num_area_heat_sources)
    end

    -- Volcano adds heat
    local lava_dist = math.huge
    if GLOBAL.GetWorld().IsVolcano() then
        if GLOBAL.GetWorld().components.volcanomanager:IsErupting() then
            ambient_delta = ambient_delta + GLOBAL.TUNING.VOLCANORIM_ACTIVE_HEAT
        else
            local map = GLOBAL.GetWorld().Map
            if map and map:IsTileGridValid() then
                local tx, ty = map:GetTileXYAtPoint(x, y, z)
                lava_dist = map:GetClosestTileDist(tx, ty, GLOBAL.GROUND.VOLCANO_LAVA, GLOBAL.TUNING.VOLCANORIM_LAVA_DIST)
                if lava_dist <= GLOBAL.TUNING.VOLCANORIM_LAVA_DIST then
                    ambient_delta = ambient_delta + GLOBAL.TUNING.VOLCANORIM_LAVA_HEAT
                end
            end
        end
    end
    
    local winterInsulation, summerInsulation = self:GetInsulation()

    local delta = ambient_delta
    self.last_real_delta = delta
    local freezeTime = GLOBAL.TUNING.SEG_TIME + winterInsulation
    local overheatTime = GLOBAL.TUNING.SEG_TIME + summerInsulation 
    -- local freeze_or_overheat_time = TUNING.SEG_TIME + total_insulation

    if seasonmgr then
        if self:IsCooling() and self:IsCool() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --cooling down, obj is cold, world is hot
                self.rate = math.max(delta, -GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            else --cooling down, obj is cold, world is cold
                self.rate = math.max(delta, -GLOBAL.TUNING.SEG_TIME / freezeTime) 
            end
        elseif self:IsWarming() and self:IsCool() then 
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --warming up, obj is cold and world is hot
                self.rate = math.min(delta, GLOBAL.TUNING.SEG_TIME / overheatTime)
            else --warming up, obj is cold and world is cold
                self.rate = math.min(delta, self.current <= 0 and GLOBAL.TUNING.THAW_DEGREES_PER_SEC or GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            end
        elseif self:IsCooling() and self:IsWarm() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --cooling down, obj is warm and world is hot
                self.rate = math.max(delta, self.current >= self.overheattemp and -GLOBAL.TUNING.THAW_DEGREES_PER_SEC or -GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            else --cooling down, obj is warm and world is cold
                self.rate = math.max(delta, -GLOBAL.TUNING.SEG_TIME / freezeTime)
            end
        elseif self:IsWarming() and self:IsWarm() then
            if seasonmgr:GetCurrentTemperature() >= GLOBAL.TUNING.STARTING_TEMP then --warming up, obj is warm, world is hot
                self.rate = math.min(delta, GLOBAL.TUNING.SEG_TIME / overheatTime)
            else --warming up, obj is warm, world is cold
                self.rate = math.min(delta, GLOBAL.TUNING.WARM_DEGREES_PER_SEC)
            end
        else
            self.rate = 0
        end
    end

    if self.inst.components.inventoryitem and 
        self.inst.components.inventoryitem.owner and 
        self.inst.components.inventoryitem.owner:HasTag("fridge") and not
        self.inst.components.inventoryitem.owner:HasTag("nocool") and --For icepack.
        self.current > 0 then -- Don't cool it below freezing
        self.rate = -GLOBAL.TUNING.WARM_DEGREES_PER_SEC
        if self.inst.components.inventoryitem.owner:HasTag("lowcool") then
            self.rate = self.rate * .5
        end
    end

    if GLOBAL.GetWorld().IsVolcano() then
        if GLOBAL.GetWorld().components.volcanomanager:IsErupting() then
            self.rate = GLOBAL.TUNING.VOLCANORIM_ACTIVE_MULT * self.rate
        elseif lava_dist <= GLOBAL.TUNING.VOLCANORIM_LAVA_DIST then
            self.rate = GLOBAL.TUNING.VOLCANORIM_LAVA_MULT * (1 - (lava_dist / GLOBAL.TUNING.VOLCANORIM_LAVA_DIST)) * self.rate
        end
    end
        
    -- --Always get "slowest" rate. Max when cooling, Min when warming.
    -- if delta < 0 and self.current < TUNING.STARTING_TEMP then
    --  self.rate = math.max(delta, -TUNING.SEG_TIME / freeze_or_overheat_time)
    -- elseif delta > 0 and self.current < TUNING.STARTING_TEMP then    
    --  self.rate = math.min(delta, self.current <= 0 and TUNING.THAW_DEGREES_PER_SEC or TUNING.WARM_DEGREES_PER_SEC)
    -- elseif delta < 0 and self.current >= TUNING.STARTING_TEMP then
    --  self.rate = math.max(delta, self.current <= self.overheattemp and -TUNING.THAW_DEGREES_PER_SEC or -TUNING.WARM_DEGREES_PER_SEC)
    -- elseif delta > 0 and self.current >= TUNING.STARTING_TEMP then   
    --  self.rate = math.min(delta, TUNING.SEG_TIME / freeze_or_overheat_time)
    -- else
    --  self.rate = 0
    -- end
        
    self.current = math.max( math.min( self.current + self.rate*dt, self.maxtemp), self.mintemp)
    
    if (self.current < 0) ~= (last < 0)  then
        if self.current < 0 then
            self.inst:PushEvent("startfreezing")
        else
            self.inst:PushEvent("stopfreezing")
        end
    end

    if (self.current > self.overheattemp) ~= (last > self.overheattemp) then
        if self.current > self.overheattemp then
            self.inst:PushEvent("startoverheating")
        else
            self.inst:PushEvent("stopoverheating")
        end
    end

    self.inst:PushEvent("temperaturedelta")
    
    if applyhealthdelta and self.current < 0 and self.inst.components.health then
        self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "cold") 
    elseif applyhealthdelta and self.current > self.overheattemp and self.inst.components.health then
        self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "hot") 
    end

else
    return _oldOnUpdate(self, dt, applyhealthdelta)

end
    
end

end)

end