require "behaviours/wander"
require "behaviours/faceentity"
require "behaviours/chaseandattack"
require "behaviours/panic"
require "behaviours/follow"
require "behaviours/attackwall"

require "behaviours/runaway"
require "behaviours/doaction"


local PrinceBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

--Prince will help chop, mine and fight.


--Prince should stay really close!
local MIN_FOLLOW_DIST = 0.5
local TARGET_FOLLOW_DIST = 1.25
local MAX_FOLLOW_DIST = 1.5

local START_FACE_DIST = 6
local KEEP_FACE_DIST = 8

local KEEP_WORKING_DIST = 3
local SEE_WORK_DIST = 5

    local slotpos = {
                    --Left slots!                           --Right slots!
                    Vector3(-162, 130 +114, 0),             Vector3(-87, 130 +114, 0), --Slot 2
                    Vector3(-162, 65 +114, 0),              Vector3(-87, 65 +114, 0), --Slot 4
                    Vector3(-162, 114, 0),                  Vector3(-87, 114, 0), --Slot 6
                    Vector3(-162, -65 +114, 0),             Vector3(-87, -65 +114, 0), --Slot 8
                    Vector3(-162, -130 +114, 0),            Vector3(-87, -130 +114, 0), --Slot 10
                    Vector3(-162, -195 +114, 0),            Vector3(-87, -195 +114, 0), --Slot 12
                    Vector3(-162, -260 +114, 0),            Vector3(-87, -260 +114, 0), --Slot 14
                    Vector3(-162, -325 +114, 0),
                    
                    --Leftmost 3 slots! The "equippables" slots! Slot number 1 is the hand slot, slot number 6 is the body slot, and slot number 11 is the head slot!
                    --Vector3(-(180), 64+32+8+4, -(180)), --HAND SLOT!
                    --Vector3(-(180), 32+4, -(180)), --BODY SLOT!
                    --Vector3(-(180), -(32+4), -(180)), --HEAD SLOT!

                    }

    local slotpos_cargo = {

                    --Left slots!                           --Right slots!
                    Vector3(-162, 130 +114, 0),             Vector3(-87, 130 +114, 0), --Slot 2
                    Vector3(-162, 65 +114, 0),              Vector3(-87, 65 +114, 0), --Slot 4
                    Vector3(-162, 114, 0),                  Vector3(-87, 114, 0), --Slot 6
                    Vector3(-162, -65 +114, 0),             Vector3(-87, -65 +114, 0), --Slot 8
                    Vector3(-162, -130 +114, 0),            Vector3(-87, -130 +114, 0), --Slot 10
                    Vector3(-162, -195 +114, 0),            Vector3(-87, -195 +114, 0), --Slot 12
                    Vector3(-162, -260 +114, 0),            Vector3(-87, -260 +114, 0), --Slot 14
                    Vector3(-162, -325 +114, 0),
                    
                    Vector3(8, 95 +114, 0), --Cargo Boat Slot 1
                    Vector3(8, 20 +114, 0), --Cargo Boat Slot 2
                    Vector3(8, -55 +114, 0), --Cargo Boat Slot 3
                    Vector3(8, -130 +114, 0), --Cargo Boat Slot 4
                    Vector3(8, -205 +114, 0), --Cargo Boat Slot 5
                    Vector3(8, -280 +114, 0) --Cargo Boat Slot 6

                    --Leftmost 3 slots! The "equippables" slots! Slot number 1 is the hand slot, slot number 6 is the body slot, and slot number 11 is the head slot!
                    --Vector3(-(180), 64+32+8+4, -(180)), --HAND SLOT!
                    --Vector3(-(180), 32+4, -(180)), --BODY SLOT!
                    --Vector3(-(180), -(32+4), -(180)), --HEAD SLOT!

                    }

    local slotpos_encrusted = {

                    --Left slots!                           --Right slots!
                    Vector3(-162, 130 +114, 0),             Vector3(-87, 130 +114, 0), --Slot 2
                    Vector3(-162, 65 +114, 0),              Vector3(-87, 65 +114, 0), --Slot 4
                    Vector3(-162, 114, 0),                  Vector3(-87, 114, 0), --Slot 6
                    Vector3(-162, -65 +114, 0),             Vector3(-87, -65 +114, 0), --Slot 8
                    Vector3(-162, -130 +114, 0),            Vector3(-87, -130 +114, 0), --Slot 10
                    Vector3(-162, -195 +114, 0),            Vector3(-87, -195 +114, 0), --Slot 12
                    Vector3(-162, -260 +114, 0),            Vector3(-87, -260 +114, 0), --Slot 14
                    Vector3(-162, -325 +114, 0),

                    Vector3(8, -205 +114, 0), --Encrusted Boat Slot 1
                    Vector3(8, -280 +114, 0) --Encrusted Boat Slot 2

                    --Leftmost 3 slots! The "equippables" slots! Slot number 1 is the hand slot, slot number 6 is the body slot, and slot number 11 is the head slot!
                    --Vector3(-(180), 64+32+8+4, -(180)), --HAND SLOT!
                    --Vector3(-(180), 32+4, -(180)), --BODY SLOT!
                    --Vector3(-(180), -(32+4), -(180)), --HEAD SLOT!

                    }

local function FindLightSourceInPockets(inst)

    --if not inst.LightWatcher:IsInLight() then
    inst.components.container:Close()


    local item = inst.components.container:FindItem(function(lightsource)
        return lightsource.prefab == "torch"
        or (lightsource.prefab == "lantern" and lightsource.components.fueled and not lightsource.components.fueled:IsEmpty())
        or (lightsource.prefab == "bottlelantern" and lightsource.components.fueled and not lightsource.components.fueled:IsEmpty())
        or lightsource.prefab == "tarlamp"
    end)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        if not inst:HasTag("armingprince") then
            inst:AddTag("armingprince")
        end

        if item then

            local itemremoval = inst.components.container:GetItemSlot(item)

                --Weirdly, tools don't label themselves as hand equippables...
                    local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
                        if currenthand and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" 
                        or (currenthand and currenthand.prefab == "lantern" and currenthand.components.fueled and currenthand.components.fueled:IsEmpty())
                        or (currenthand and currenthand.prefab == "bottlelantern" and currenthand.components.fueled and currenthand.components.fueled:IsEmpty()) then

                                inst.components.inventory:RemoveItem(currenthand)--:Remove() 
                                inst.components.container:GiveItem(currenthand)
                                inst.components.container:RemoveItemBySlot(itemremoval)--:Remove()  
                                --inst.components.inventory:GiveItem(item)
                                print("Prince is providing light!")
                                inst.components.inventory:Equip(item)
                        end

                        if not currenthand then
                            inst.components.container:RemoveItemBySlot(itemremoval)--:Remove()  
                            --inst.components.inventory:GiveItem(item)
                            print("Prince is providing light!")
                            inst.components.inventory:Equip(item)
                        end

            --Try to reset Prince's acknowlegement of light!
            inst.LightWatcher:SetLightThresh(.075)
            inst.LightWatcher:SetDarkThresh(.05)

        end

        if inst:HasTag("armingprince") then
            inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)
        end


    --end


end


local function FindLightSourceOnBoat(inst)

    --If Prince is riding a boat and his boat has a light attached, turn that on!
        if inst.components.driver and inst.components.driver.vehicle and inst.components.driver.vehicle.components.container.hasboatequipslots then
            local boat = inst.components.driver.vehicle
            local boatlight = boat.components.container:GetItemInBoatSlot(BOATEQUIPSLOTS.BOAT_LAMP)
            if boatlight then
                if boatlight.prefab == "boat_lantern" or boatlight.prefab == "boat_torch" or boatlight.prefab == "tarlamp" then
                    if not boatlight.components.fueled:IsEmpty() then
                        local action = BufferedAction(inst, boatlight, ACTIONS.TOGGLEON)
                        print("Prince is providing light!")
                        
                        --Try to reset Prince's acknowlegement of light!
                        inst.LightWatcher:SetLightThresh(.075)
                        inst.LightWatcher:SetDarkThresh(.05)
                        
                        inst:PushBufferedAction(action)
                    end
                end
            elseif not boatlight then
                FindLightSourceInPockets(inst)
            end
        end

end


local function TurnLightOff(inst)

    --if not inst.LightWatcher:IsInLight() then

    --If Prince is riding a boat and his boat's light is on, turn it off when it's daytime!
    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        if inst.components.driver and inst.components.driver.vehicle and inst.components.driver.vehicle.components.container.hasboatequipslots then
            local boat = inst.components.driver.vehicle
            local boatlight = boat.components.container:GetItemInBoatSlot(BOATEQUIPSLOTS.BOAT_LAMP)
            if boatlight then
                if boatlight and boatlight.prefab == "boat_lantern" or boatlight.prefab == "boat_torch" then
                    if boatlight.components.equippable:IsToggledOn() then
                        local action = BufferedAction(inst, boatlight, ACTIONS.TOGGLEOFF)
                        print("Rise and shine!")
                        inst:PushBufferedAction(action)
                    end
                end
            end
        end
    end

end



local function HandNotOccupied(inst)

    local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    return (currenthand and not currenthand.components.waterproofer and not currenthand.components.fishingrod 
    and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" and not currenthand.components.tool)
    or not currenthand    

end

local function StayDryHand(inst)

    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        if item then
                
                --Weirdly, tools don't label themselves as hand equippables...
                if item.components.equippable and item.components.waterproofer and item.components.equippable.equipslot ~= EQUIPSLOTS.BODY and item.components.equippable.equipslot ~= EQUIPSLOTS.HEAD then
                    local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
                        if currenthand and not currenthand.components.waterproofer
                        or (currenthand and currenthand.components.waterproofer and currenthand.components.waterproofer.effectiveness < item.components.waterproofer.effectiveness) then
                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currenthand)--:Remove()  
                            inst.components.container:GiveItem(currenthand)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currenthand then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end
    
                end

        end

    end

end

local function StayDry(inst)

    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        inst:AddTag("armingprince")

        if item then

                if item.components.equippable and item.components.waterproofer and item.components.equippable.equipslot == EQUIPSLOTS.BODY then
                    local currentbody = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
                        if (currentbody and currentbody.prefab ~= "armorsnurtleshell" and currentbody.prefab ~= "amulet" and not currentbody.components.waterproofer) 
                        or (currentbody and currentbody.components.waterproofer and currentbody.components.waterproofer.effectiveness < item.components.waterproofer.effectiveness) then
                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currentbody)--:Remove()  
                            inst.components.container:GiveItem(currentbody)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currentbody then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end
        
                end



                if item.components.equippable and item.components.waterproofer and item.components.equippable.equipslot == EQUIPSLOTS.HEAD then
                    local currenthead = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
                        if (currenthead and not currenthead.components.waterproofer)
                        or (currenthead and currenthead.components.waterproofer and currenthead.components.waterproofer.effectiveness < item.components.waterproofer.effectiveness) then
                            if (currenthead.prefab ~= "icehat" and currenthead.prefab ~= "watermelonhat" and currenthead.prefab ~= "gasmaskhat" and currenthead.prefab ~= "gashat" and currenthead.prefab ~= "bushhat") then

                                inst.components.container:Close()
                                inst.components.inventory:RemoveItem(currenthead)--:Remove()  
                                inst.components.container:GiveItem(currenthead)
                                inst.components.container:RemoveItemBySlot(i)--:Remove()  
                                print("Prince is trying to stay dry!")
                                inst.components.inventory:Equip(item)
                            end
                        end

                        if not currenthead then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end
        

                end

        end

        --When the tag is removed, it should keep the player from accidentally transporting items into his inaccessible inventory.
        inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)
       
    end

end

local function GetWarm(inst)

    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        inst:AddTag("armingprince")

        if item then


                --Weirdly, Prince will equip an umbrella to stay warm, even though umbrellas are for summer shade...
                if item.components.equippable and item.components.insulator and (item.components.insulator.type == "WINTER" and item.components.insulator.type ~= "SUMMER") and item.components.equippable.equipslot ~= EQUIPSLOTS.BODY and item.components.equippable.equipslot ~= EQUIPSLOTS.HEAD then
                    local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
                        if (currenthand and not currenthand.components.insulator and not currenthand.components.fishingrod and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" and not currenthand.components.tool)
                        or (currenthand and currenthand.components.insulator and currenthand.components.insulator.type ~= "WINTER" and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" and not currenthand.components.tool) then
                                inst.components.container:Close()
                                inst.components.inventory:RemoveItem(currenthand)--:Remove()  
                                inst.components.container:GiveItem(currenthand)
                                inst.components.container:RemoveItemBySlot(i)--:Remove()  
                                print("Prince is trying to stay warm!")
                                inst.components.inventory:Equip(item)
                        end

                        if not currenthand then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay warm!")
                            inst.components.inventory:Equip(item)
                        end
    
                end


                if item.components.equippable and item.components.insulator and item.components.equippable.equipslot == EQUIPSLOTS.BODY and item.components.insulator.type == "WINTER" then
                    local currentbody = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
                        if (currentbody and currentbody.prefab ~= "armorsnurtleshell" and not currentbody.components.insulator)
                        or (currentbody and currentbody.components.insulator and currentbody.components.insulator.type ~= "WINTER") then
                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currentbody)--:Remove()  
                            inst.components.container:GiveItem(currentbody)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay warm!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currentbody then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay warm!")
                            inst.components.inventory:Equip(item)
                        end
        
                end



                if item.components.equippable and item.components.insulator and item.components.equippable.equipslot == EQUIPSLOTS.HEAD and item.components.insulator.type == "WINTER" then
                    local currenthead = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
                        if (currenthead and currenthead.prefab ~= "bushhat" and not currenthead.components.insulator)
                        or (currenthead and currenthead.components.insulator and currenthead.components.insulator.type ~= "WINTER") then

                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currenthead)--:Remove()  
                            inst.components.container:GiveItem(currenthead)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay warm!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currenthead then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay warm!")
                            inst.components.inventory:Equip(item)
                        end
        

                end

        end

        --When the tag is removed, it should keep the player from accidentally transporting items into his inaccessible inventory.
        inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)
            
    end

end

local function GetCool(inst)

    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        inst:AddTag("armingprince")

        if item then


                --Weirdly, tools don't label themselves as hand equippables...
                if item.components.equippable and item.components.insulator and (item.components.insulator.type == "SUMMER" and item.components.insulator.type ~= "WINTER") and item.components.equippable.equipslot ~= EQUIPSLOTS.BODY and item.components.equippable.equipslot ~= EQUIPSLOTS.HEAD then
                    local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
                        if (currenthand and not currenthand.components.insulator and not currenthand.components.fishingrod and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" and not currenthand.components.tool)
                        or (currenthand and currenthand.components.insulator and currenthand.components.insulator.type ~= "SUMMER" and currenthand.prefab ~= "lantern" and currenthand.prefab ~= "bottlelantern" and currenthand.prefab ~= "torch" and not currenthand.components.tool) then
                                inst.components.container:Close()
                                inst.components.inventory:RemoveItem(currenthand)--:Remove()  
                                inst.components.container:GiveItem(currenthand)
                                inst.components.container:RemoveItemBySlot(i)--:Remove()  
                                print("Prince is trying to stay cool!")
                                inst.components.inventory:Equip(item)
                        end

                        if not currenthand then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay cool!")
                            inst.components.inventory:Equip(item)
                        end
    
                end


                if item.components.equippable and item.components.insulator and item.components.equippable.equipslot == EQUIPSLOTS.BODY and item.components.insulator.type == "SUMMER" then
                    local currentbody = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
                        if (currentbody and currentbody.prefab ~= "armorsnurtleshell" and currentbody.prefab ~= "armorsnurtleshell" and not currentbody.components.insulator and not currentbody.tool)
                        or (currentbody and currentbody.components.insulator and currentbody.components.insulator.type ~= "SUMMER" and not currentbody.tool) then
                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currentbody)--:Remove()  
                            inst.components.container:GiveItem(currentbody)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay cool!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currentbody then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay cool!")
                            inst.components.inventory:Equip(item)
                        end
        
                end



                if item.components.equippable and item.components.insulator and item.components.equippable.equipslot == EQUIPSLOTS.HEAD and item.components.insulator.type == "SUMMER" then
                    local currenthead = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
                        if (currenthead and currenthead.prefab ~= "bushhat" and not currenthead.components.insulator and not currenthead.tool)
                        or (currenthead and currenthead.components.insulator and currenthead.components.insulator.type ~= "SUMMER" and not currenthead.tool) then

                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currenthead)--:Remove()  
                            inst.components.container:GiveItem(currenthead)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay cool!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currenthead then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay cool!")
                            inst.components.inventory:Equip(item)
                        end
        

                end

        end

        --When the tag is removed, it should keep the player from accidentally transporting items into his inaccessible inventory.
        inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)
  
    end

end

local function GetGasMask(inst)

    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        inst:AddTag("armingprince")

        if item then


                if (item.components.equippable and item:HasTag("gasmask") and item.components.equippable.equipslot == EQUIPSLOTS.HEAD) 
                or (item.components.equippable and item.prefab == "gashat" and item.components.equippable.equipslot == EQUIPSLOTS.HEAD) then
                    local currenthead = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
                        if (currenthead and currenthead.prefab ~= "gasmaskhat") or (currenthead and currenthead.prefab ~= "gashat") then

                            inst.components.container:Close()
                            inst.components.inventory:RemoveItem(currenthead)--:Remove()  
                            inst.components.container:GiveItem(currenthead)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is protecting himself from the gas!")
                            inst.components.inventory:Equip(item)
                        end

                        if not currenthead then
                            inst.components.container:Close()
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            print("Prince is trying to stay dry!")
                            inst.components.inventory:Equip(item)
                        end
        

                end

        end

        --When the tag is removed, it should keep the player from accidentally transporting items into his inaccessible inventory.
        inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)
  
    end

end


--Prince will wear protective gear if there is an earthquake!
local function EarthquakeSuitUp(inst)

    inst.components.container:Close()
    local container = inst.components.container
    for i = 1, container:GetNumSlots() do
        local item = container:GetItemInSlot(i)

        --This tag is a workaround so that Prince's container can give him the tools he needs, while preventing items from getting lost in his inventory.
        inst:AddTag("armingprince")

        if item then

                if item.components.equippable and item.components.equippable.equipslot == EQUIPSLOTS.BODY and item.components.armor then
                    local currentbody = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
                        if currentbody and not currentbody.components.armor then

                            print("Prince is protecting himself from an earthquake!")
                            inst.components.inventory:RemoveItem(currentbody)--:Remove()  
                            inst.components.container:GiveItem(currentbody)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            inst.components.inventory:Equip(item)
                        end

                        if not currentbody then
                            print("Prince is protecting himself from an earthquake!")
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            inst.components.inventory:Equip(item)
                        end
        
                end



                if item.components.equippable and item.components.equippable.equipslot == EQUIPSLOTS.HEAD and item.components.armor then
                    local currenthead = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
                        if (currenthead and not currenthead.components.armor) and (currenthead and currenthead.prefab ~= "minerhat") then

                            print("Prince is protecting himself from an earthquake!")
                            inst.components.inventory:RemoveItem(currenthead)--:Remove()  
                            inst.components.container:GiveItem(currenthead)
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            inst.components.inventory:Equip(item)
                        end

                        if not currenthead then
                            print("Prince is protecting himself from an earthquake!")
                            inst.components.container:RemoveItemBySlot(i)--:Remove()  
                            inst.components.inventory:Equip(item)
                        end
        

                end
    

        end

        --When the tag is removed, it should keep the player from accidentally transporting items into his inaccessible inventory.
        inst:DoTaskInTime(0.01, function() inst:RemoveTag("armingprince") end)

    end

end

local function Complain(inst)
    return print("Prince can't think!")
end

local function IsInsideBuilding(inst)
    return inst.IsIndoors
end

local function IndoorSanityDrain(inst)
    inst.components.sanity.night_drain_mult = 0
end

local function IsOutsideBuilding(inst)
    local pt = inst:GetPosition()
    local tile = GetWorld().Map:GetTileAtPoint(pt.x,pt.y,pt.z)
    return tile ~= GROUND.INTERIOR
end
   
local function OutdoorSanityDrain(inst)

    --if not TheCamera.interior and not GetInteriorSpawner():InPlayerRoom() then
        inst.components.sanity.night_drain_mult = 1
    --end
    inst.HouseSanity = 0

end



local function EatFoodInInventory(inst)

    local food = inst.components.container:FindItem(function(item)
        return item.components.edible and inst.components.eater:CanEat(item) and item.components.edible.healthvalue >= 0 and item.components.edible.hungervalue > 0 and item.components.edible.foodtype ~= "SEEDS" --If it's not poisonous, not a seed, and is edible, Prince will eat it.
    end)
    if food and inst.components.hunger:GetPercent() < 0.8 and not inst.components.combat.target and not inst.sg:HasStateTag("busy") and not inst:HasTag("hiding") then
        if not inst:HasTag("hungryprince") then
            inst:AddTag("hungryprince") --This tag is so Prince can keep eating until he's full!
        end
        print("Prince is feeding himself!")
        return BufferedAction(inst, food, ACTIONS.EAT)
    end
end


local function IsNearLightning(inst)
    return FindEntity(inst, 2, function(target) return target.prefab == "lightning" end)
end


local function RepairBoat(inst)

    local vehicle = inst.components.driver.vehicle
    local repairkit = inst.components.container:FindItem(function(item)
        return item.components.repairer and item.components.repairer.repairmaterial == "boat"    
    end)
    if repairkit and vehicle.components.boathealth:GetPercent() <= 0.5 and not inst.components.combat.target and not inst.sg:HasStateTag("busy") and not inst.sg:HasStateTag("repairing") then
        if not inst:HasTag("repairmanprince") then
            inst:AddTag("repairmanprince") --This tag is so Prince can keep repairing his boat until it is in good condition!
        end
        print("Prince is repairing his boat!")
        return BufferedAction(inst, vehicle, ACTIONS.REPAIRBOAT, repairkit) --inst is who's doing it (Prince), vehicle is what is being interacted with (Prince's boat). ACTIONS.REPAIRBOAT is what the interactor will do to the interacted (Prince will repair his boat), and repairkit is the item being used during the interaction (Prince will use a boat repair kit he has to repair his boat)
    end
end

local function CurePoison(inst)

    local cure = inst.components.container:FindItem(function(item)
        return item.components.poisonhealer
    end)
    if cure and not inst.components.combat.target and not inst.sg:HasStateTag("busy") and not inst.sg:HasStateTag("repairing") then
        print("Prince is curing his illness!")
        return BufferedAction(inst, inst, ACTIONS.CUREPOISON, cure)
    end
end


local function ShouldRunAway(inst, target)
    return inst.components.combat.target and inst.components.follower and not inst.components.follower.leader and not inst.sg:HasStateTag("hiding")
    --Prince should flee if he's outside...
    and ( ( ( IsDLCEnabled(PORKLAND_DLC) and not inst.IsIndoors and not TheCamera.interior) 
    --Or if he's in the same room as Princess... (DON'T MAKE HIM RUN IF HE'S IN INDOOR LIMBO)
    or ( IsDLCEnabled(PORKLAND_DLC) and inst.IsIndoors and TheCamera.interior and inst:GetPosition() ~= GetWorld().components.interiorspawner.spawn_storage_origin) )
    --Or in general, if Hamlet is not enabled.
    or not ( IsDLCEnabled(PORKLAND_DLC) ) )
end


local function HasStateTags(inst, tags)
    for k,v in pairs(tags) do
        if inst.sg:HasStateTag(v) then
            return true
        end
    end
end

local function KeepWorkingAction(inst, actiontags)
    local currenttool = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    return inst.components.follower.leader and inst.components.follower.leader:GetDistanceSqToInst(inst) <= 3 and
    HasStateTags(inst.components.follower.leader, actiontags) and not inst.sg:HasStateTag("toolbroken")
end

local function StartWorkingCondition(inst, actiontags)
    local currenttool = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    return inst.components.follower.leader and HasStateTags(inst.components.follower.leader, actiontags) and not HasStateTags(inst, actiontags)
end

local function StartWorkingConditionBoat(inst, actiontags)
    local currenttool = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    return inst.components.follower.leader and inst.components.follower.leader:GetIsOnWater() and inst:GetIsOnWater() and HasStateTags(inst.components.follower.leader, actiontags) and not HasStateTags(inst, actiontags)
end

local function FindObjectToWorkAction(inst, action)
    if inst.sg:HasStateTag("working") then
        return 
    end

    local target = nil
    local yestags = {"aquatic", "tree", "structure"}
    local notags = {"FX", "NOCLICK", "DECOR","INLIMBO"}
    if action == ACTIONS.HACK then
        target = FindEntity(inst.components.follower.leader, SEE_WORK_DIST, function(item) return item.components.hackable end, nil, notags)
    elseif action ~= ACTIONS.HACK then
        target = FindEntity(inst.components.follower.leader, SEE_WORK_DIST, function(item) return item.components.workable and item.components.workable.action == action end, nil, notags)
    end   
    if target then

        --Get Prince to equip the right tool for the job!
        local tool = inst.components.container:FindItem(function(equippable)
                return equippable.components.tool and equippable.components.tool:CanDoAction(action)
            end)
        local currenttool = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)


        if not tool and not currenttool or (currenttool and currenttool.components.tool and not currenttool.components.tool:CanDoAction(action) and not tool) or (currenttool and currenttool.prefab == "lantern") or (currenttool and currenttool.prefab == "torch") then
            --print("Prince doesn't have the tool to help out!")
            return
        end


        if tool or (currenttool and currenttool.components.tool and currenttool.components.tool:CanDoAction(action)) then

            inst.components.container:Close()

            local actiontool = inst.components.container:GetItemSlot(tool)

            local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if (currenthand and not currenthand.components.tool) or (currenthand and currenthand.components.tool and not currenthand.components.tool:CanDoAction(action)) then

                inst.components.inventory:RemoveItem(currenthand)--:Remove()  
                inst.components.container:GiveItem(currenthand)
                inst.components.container:RemoveItemBySlot(actiontool)--:Remove()  
                inst.components.inventory:Equip(tool)
            end

            if not currenthand then
                inst.components.container:RemoveItemBySlot(actiontool)--:Remove()  
                inst.components.inventory:Equip(tool)
            end

            if not inst:HasTag("canwork") then
                inst:AddTag("canwork")
            end

            --print("Prince is going to help work!")
            return BufferedAction(inst, target, action, tool)
        end

    end

end


local function FindObjectToFishAction(inst, action)
    if inst.sg:HasStateTag("working") and not inst.sg:HasStateTag("fishing") then
        return 
    end

    local notags = {"FX", "NOCLICK", "DECOR","INLIMBO"}
    local target = FindEntity(inst.components.follower.leader, SEE_WORK_DIST, function(item) return item.components.fishable and not item.components.flotsamfisher
    and ((IsDLCEnabled(PORKLAND_DLC) and not item.components.sinkable) or not IsDLCEnabled(PORKLAND_DLC)) end)
    if target then

        --Get Prince to equip the right tool for the job!
        local tool = inst.components.container:FindItem(function(equippable)
            return equippable.components.fishingrod
        end)
        local currenttool = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)


        if not tool and not currenttool
        or (currenttool and not currenttool.components.fishingrod and not tool)
        or (currenttool and currenttool.prefab == "tarlamp") or (currenttool and currenttool.prefab == "torch") then
            --print("Prince doesn't have a fishing rod!")
            return
        end


        if tool or (currenttool and currenttool.components.fishingrod) then

            inst.components.container:Close()

            local actiontool = inst.components.container:GetItemSlot(tool)

            local currenthand = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if (currenthand and not currenthand.components.fishingrod) then

                if currenthand.prefab == "lantern" or currenthand.prefab == "bottlelantern" then
                    inst.components.inventory:RemoveItem(currenthand)
                    inst.components.inventory:DropItem(currenthand, true, true) 
                else
                    inst.components.inventory:RemoveItem(currenthand)--:Remove()  
                    inst.components.container:GiveItem(currenthand)
                end
                inst.components.container:RemoveItemBySlot(actiontool)--:Remove()  
                inst.components.inventory:Equip(tool)
            end

            if not currenthand then
                inst.components.container:RemoveItemBySlot(actiontool)--:Remove()  
                inst.components.inventory:Equip(tool)
            end

            if not inst:HasTag("canwork") then
                inst:AddTag("canwork")
            end

            --print("Prince is going to help work!")
            return BufferedAction(inst, target, action, tool)
        end

    end

end


local function GetLeaderLand(inst)
local leader = inst.components.follower.leader 
    return leader and not leader:GetIsOnWater()
end

local function GetLeaderBoat(inst)
local leader = inst.components.follower.leader 
    return leader and leader:GetIsOnWater()
end

local function GetFaceTargetFn(inst)
    local target = GetClosestInstWithTag("player", inst, START_FACE_DIST)
    if target and not target:HasTag("notarget") then
        return target
    end
end

local function KeepFaceTargetFn(inst, target)
    return inst:IsNear(target, KEEP_FACE_DIST) and not target:HasTag("notarget")
end


local function WarpFactors(inst)
    local leader = inst.components.follower.leader
    return (leader and leader.components.mapwrapper.state == 2) or (leader and leader.components.mapwrapper.state == 3)
end


local function WarpAcrossMap(inst)
    local leader = inst.components.follower.leader
    if leader then

        local princess = GetPlayer()

        inst:AddTag("warping")
        inst:DoTaskInTime(7, function() 
            inst.Transform:SetPosition(princess:GetPosition():Get())
            local fx = SpawnPrefab("statue_transition_2")
            if fx then
                fx.Transform:SetPosition(inst:GetPosition():Get())
                fx.AnimState:SetScale(2,3,2)
            end
            inst:RemoveTag("warping") 
        end)

    end
end


local function TagsMatch(inst)
    local leader = inst.components.follower.leader
    return leader and leader:HasTag("aquatic") == inst:HasTag("aquatic")
end

local function BoatAction(inst)
    local leader = inst.components.follower.leader

    if not leader then return end

    if leader:HasTag("aquatic") and not inst:HasTag("aquatic") then
        local boat = FindEntity(inst, 10, function(ent)
            return ent:HasTag("boat")
        end)
        if boat then 

            --Increase Prince's inventory size if his boat has more container slots!
            inst.components.container:Close()

            if boat.prefab == "cargoboat" then
                inst.components.container:SetNumSlots(#slotpos_cargo)
                inst.components.container.widgetslotpos = slotpos_cargo
                inst.boatstate = "CARGO"
            elseif
            boat.prefab == "encrustedboat" then
                inst.components.container:SetNumSlots(#slotpos_encrusted)
                inst.components.container.widgetslotpos = slotpos_encrusted
                inst.boatstate = "ENCRUSTED"
            end
            local boatcontainer = boat.components.container
            if boat.components.container then
                for k,v in pairs(boat.components.container.slots) do
                    local item = boat.components.container:RemoveItemBySlot(k)
                    inst.components.container:GiveItem(item)
                end
            end

            return BufferedAction(inst, boat, ACTIONS.MOUNT, nil, nil, nil, 100)
        end
    elseif not leader:HasTag("aquatic") and inst:HasTag("aquatic") then
        --Get off boat near leader
        local offset = FindGroundOffset(leader:GetPosition(), math.random() * 2*PI, 2, 36)
        if offset then


            local boat = inst.components.driver and inst.components.driver.vehicle
            if boat then 

                --Return Prince's inventory size to normal and give items in his "boat slots" to the boat he's riding on!
                inst.components.container:Close()

                if boat.components.container then
                    if inst.boatstate == "CARGO" then
                        for i = 1, boat.components.container:GetNumSlots() do
                            local item = inst.components.container:RemoveItemBySlot((15+i)) --The 15 is to skip Prince's original 15 slots, to go straight to his "boat slots".
                            boat.components.container:GiveItem(item)
                        end
                    elseif inst.boatstate == "ENCRUSTED" then
                        for i = 1, boat.components.container:GetNumSlots() do
                            local item = inst.components.container:RemoveItemBySlot((15+i)) --The 15 is to skip Prince's original 15 slots, to go straight to his "boat slots".
                            boat.components.container:GiveItem(item)
                        end

                    end
                end
                inst.components.container:SetNumSlots(#slotpos)
                inst.components.container.widgetslotpos = slotpos
            end

            local pos = leader:GetPosition() + offset
            inst.boatstate = "NORMAL"
            return BufferedAction(inst, nil, ACTIONS.DISMOUNT, nil, pos, nil, 100)
        end
    end
end


function PrinceBrain:OnStart()
    local root = PriorityNode(
    {


        --It burns!
        ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.PANICFIRE,
            WhileNode(function() return self.inst.components.health.takingfiredamage end, "OnFire",
                    Panic(self.inst)
                )
            ),


        --Shocking!
        WhileNode(function() return IsNearLightning(self.inst) end, "Struck by lightning!",
                DoAction(self.inst, function() return self.inst:PushEvent("lightningstrike") end)
            ),


        --Prince will try to keep himself dry during the rain when it's not a cold or hot season!
        WhileNode(function() return GetSeasonManager():GetSeason() ~= SEASONS.WINTER and GetSeasonManager():GetSeason() ~= SEASONS.SUMMER and GetSeasonManager():GetSeason() ~= SEASONS.DRY
        and ((GetSeasonManager():GetSeason() == SEASONS.SPRING and GetSeasonManager().percent_season > 0.15) or GetSeasonManager():GetSeason() ~= SEASONS.SPRING)
        and ((GetWorld().components.quaker and not GetWorld().components.quaker.quake) or not GetWorld().components.quaker)
        and self.inst.components.moisture.moisture > 0 and not self.inst.components.container:IsOpen() and not self.inst.components.combat.target end, "Getting wet!",
                DoAction(self.inst, function() return StayDry(self.inst) end)
            ),
        --For lag reasons, Prince's dry hand equippable will be a different function!
        WhileNode(function() return GetSeasonManager():GetSeason() ~= SEASONS.WINTER and GetSeasonManager():GetSeason() ~= SEASONS.SUMMER and GetSeasonManager():GetSeason() ~= SEASONS.DRY
        and ((GetSeasonManager():GetSeason() == SEASONS.SPRING and GetSeasonManager().percent_season > 0.15) or GetSeasonManager():GetSeason() ~= SEASONS.SPRING)
        and ((GetWorld().components.quaker and not GetWorld().components.quaker.quake) or not GetWorld().components.quaker)
        and self.inst.components.moisture.moisture > 0 and not self.inst.components.container:IsOpen() and not self.inst.components.combat.target 
        and HandNotOccupied(self.inst) end, "Getting wet!",
                DoAction(self.inst, function() return StayDryHand(self.inst) end)
            ),
        --Prince will find warm clothes in the cold!
        WhileNode(function() return (GetSeasonManager():GetSeason() == SEASONS.WINTER or (GetSeasonManager():GetSeason() == SEASONS.SPRING and GetSeasonManager().percent_season <= 0.15))
        and ((GetWorld().components.quaker and not GetWorld().components.quaker.quake) or not GetWorld().components.quaker)
        and not self.inst.components.container:IsOpen() and not self.inst.components.combat.target end, "Getting cold!",
                DoAction(self.inst, function() return GetWarm(self.inst) end)
            ),
        --Prince will find cool clothes in the heat!
        WhileNode(function() return self.inst.components.moisture.moisture <= 0 and (GetSeasonManager():GetSeason() == SEASONS.SUMMER or GetSeasonManager():GetSeason() == SEASONS.DRY)
        and ((GetWorld().components.quaker and not GetWorld().components.quaker.quake) or not GetWorld().components.quaker)
        and not self.inst.components.container:IsOpen() and not self.inst.components.combat.target end, "Getting hot!",
                DoAction(self.inst, function() return GetCool(self.inst) end)
            ),
        --Prince will put on a gas mask in the poisonous rain forest!
        WhileNode(function() return IsDLCEnabled(PORKLAND_DLC) and self.inst.components.tiletracker and self.inst.components.tiletracker.ongas
        and not self.inst.components.container:IsOpen() and not self.inst:HasTag("gasmask") end, "GAS!",
                DoAction(self.inst, function() return GetGasMask(self.inst) end)
            ),


        --Prince will wear armor to protect himself when an earthquake starts!
        WhileNode(function() return GetWorld().components.quaker and GetWorld().components.quaker.quake end, "Earthquake!",
                DoAction(self.inst, function() return EarthquakeSuitUp(self.inst) end)
            ),


        --Prince will help work on things!
        WhileNode(function() return StartWorkingCondition(self.inst, {"chopping", "prechop"}) and 
        KeepWorkingAction(self.inst, {"chopping", "prechop"}) end, "keep chopping",
            LoopNode{ 
                ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.WORKASSIST,
                    DoAction(self.inst, function() return FindObjectToWorkAction(self.inst, ACTIONS.CHOP) end)
                    )
                }
            ),
        WhileNode(function() return StartWorkingCondition(self.inst, {"mining", "premine"}) and 
        KeepWorkingAction(self.inst, {"mining", "premine"}) end, "keep mining",    
            LoopNode{ 
                ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.WORKASSIST,               
                    DoAction(self.inst, function() return FindObjectToWorkAction(self.inst, ACTIONS.MINE) end)
                    )
                }
            ),
        WhileNode(function() return StartWorkingCondition(self.inst, {"digging", "predig"}) and 
        KeepWorkingAction(self.inst, {"digging", "predig"}) end, "keep digging",         
            LoopNode{ 
                ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.WORKASSIST,               
                    DoAction(self.inst, function() return FindObjectToWorkAction(self.inst, ACTIONS.DIG) end)
                    )
                }
            ),
        WhileNode(function() return StartWorkingCondition(self.inst, {"hacking", "prehack"}) and 
        KeepWorkingAction(self.inst, {"hacking", "prehack"}) end, "keep hacking",        
            LoopNode{ 
                ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.WORKASSIST,                
                    DoAction(self.inst, function() return FindObjectToWorkAction(self.inst, ACTIONS.HACK) end)
                    )
                }
            ),
        WhileNode(function() return StartWorkingCondition(self.inst, {"fishing"}) and 
        KeepWorkingAction(self.inst, {"fishing"}) end, "Start fishing!",    
            --LoopNode{ 
                --ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.WORKASSIST,               
                    DoAction(self.inst, function() return FindObjectToFishAction(self.inst, ACTIONS.FISH) end)
                    --)
                --}
            ),


        --Prince will provide light if it's dark! Boat version!
        IfNode(function() return (self.inst.components.driver and self.inst.components.driver.vehicle and self.inst.components.driver.vehicle.components.container.hasboatequipslots) and not self.inst.LightWatcher:IsInLight() end, "It's dark at sea!",
            DoAction(self.inst, function() return FindLightSourceOnBoat(self.inst) end)
        ),
        --Prince will provide light if it's dark! Land Shipwrecked version!
        IfNode(function() return not self.inst.LightWatcher:IsInLight() and not self.inst.components.driver.vehicle and not IsDLCEnabled(PORKLAND_DLC) end, "It's dark!",
            DoAction(self.inst, function() return FindLightSourceInPockets(self.inst) end)
        ),
        --Prince will provide light if it's dark! Land Hamlet version!
        IfNode(function() return not self.inst.LightWatcher:IsInLight() and not self.inst.components.driver.vehicle and IsDLCEnabled(PORKLAND_DLC) 
            --If Prince and Princess are both inside...
            and ( (IsInsideBuilding(self.inst) and TheCamera.interior) 
            --If Prince is outside and Princess is inside while it's night...
            or (TheCamera.interior and GetClock():IsNight() and not IsInsideBuilding(self.inst)) 
            --If Prince and Princess are both outside...
            or not TheCamera.interior and not IsInsideBuilding(self.inst) ) end, "It's dark!",
            DoAction(self.inst, function() return FindLightSourceInPockets(self.inst) end)
        ),
        --Prince will provide light if it's dark!
        WhileNode(function() return GetClock() and GetClock():IsDay() end, "Turn boat light off!",
            DoAction(self.inst, function() return TurnLightOff(self.inst) end)
        ),


        --Prince will try to feed himself if he's hungry and has edible food!
        WhileNode(function() return (self.inst.components.hunger and self.inst.components.hunger:GetPercent() < TUNING.HUNGRY_THRESH) or self.inst:HasTag("hungryprince") end, "hungry",
        DoAction(self.inst, function() return EatFoodInInventory(self.inst, ACTIONS.EAT) end)
        ),

        --Prince will try to feed himself if he's hungry and has edible food!
        WhileNode(function() return (self.inst.components.driver and self.inst.components.driver.vehicle and self.inst.components.driver.vehicle.components.boathealth and self.inst.components.driver.vehicle.components.boathealth:GetPercent() <= 0.5) or self.inst:HasTag("repairmanprince") end, "wantstorepair",
        DoAction(self.inst, function() return RepairBoat(self.inst, ACTIONS.REPAIRBOAT) end)
        ),

        --Prince will try to cure his illness if he has a cure!
        WhileNode(function() return self.inst.components.poisonable and self.inst.components.poisonable.poisoned == true end, "sick",
        DoAction(self.inst, function() return CurePoison(self.inst, ACTIONS.CUREPOISON) end)
        ),


        --Prince should only fight things under the company of Princess!
        ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.BATTLECRY,
            WhileNode(function() return self.inst.components.follower.leader end, "attack",
                    ChaseAndAttack(self.inst, 5)
                )
            ),
        ChattyNode(self.inst, STRINGS.CHARACTERS.PRINCE.PANICRETREAT,
            WhileNode( function() return self.inst.components.combat.target end, "Panic",
                RunAway(self.inst, function() return self.inst.components.combat.target end, 10, 15, function(target) return ShouldRunAway(self.inst, target) end)
                )
            ),


        --Prince can ride boats! This is placed here because it interferes with Prince's behaviors above; he wouldn't perform any of them if he's not following Princess.
        IfNode(function() return not TagsMatch(self.inst) end, "On Land",
            --SequenceNode{
                --WaitNode(0.5),
                DoAction(self.inst, function() return BoatAction(self.inst) end)--,
            --}
        ),


        WhileNode(function() return GetLeaderLand(self.inst) end, "has leader",
            --Prince should stop following Princess if she gets too far!
            Follow(self.inst, function() return self.inst.components.follower and self.inst.components.follower.leader end, MIN_FOLLOW_DIST, TARGET_FOLLOW_DIST, MAX_FOLLOW_DIST),            
            FaceEntity(self.inst, GetFaceTargetFn, KeepFaceTargetFn )
            ),

        WhileNode(function() return GetLeaderBoat(self.inst) end, "has leader at sea",
            --Prince should stop following Princess if she gets too far!
            Follow(self.inst, function() return self.inst.components.follower and self.inst.components.follower.leader end, 1, 3, 3.25),            
            FaceEntity(self.inst, GetFaceTargetFn, KeepFaceTargetFn )
            ),

        WhileNode(function() return IsInsideBuilding(self.inst) and not TheCamera.interior end, "I think we need to run a few... TESTS.",
            DoAction(self.inst, function() return Complain(self.inst) end)
            ),


        --IRRELEVANT CODE NOW! Warping Prince across the fog is now handled in the modmain in "mapwrapper's" PostinIt!
        --If Princess is warping to the other side of the map in Shipwrecked via the edge fog, warp to her location!
        --WhileNode(function() return WarpFactors(self.inst) end, "Warp",
            --DoAction(self.inst, function() return WarpAcrossMap(self.inst) end)
            --),

        --Prince won't lose sanity indoors!
        IfNode(function() return IsDLCEnabled(PORKLAND_DLC) and IsInsideBuilding(self.inst) end, "Is indoors",
            DoAction(self.inst, function() return IndoorSanityDrain(self.inst) end)
            ),

        IfNode(function() return IsDLCEnabled(PORKLAND_DLC) and not IsInsideBuilding(self.inst) end, "Is outdoors",
            DoAction(self.inst, function() return OutdoorSanityDrain(self.inst) end)
            ),

        --If Prince isn't occupied, he'll stay put!
        --WhileNode(function() return not self.inst.components.health.takingfiredamage and not self.inst.components.combat.target and not self.inst.components.follower.leader end, "Wait here",
            StandStill(self.inst)
            --),


    }, .25)
    
    self.bt = BT(self.inst, root)    
end

return PrinceBrain