require "behaviours/panic"
require "behaviours/chaseandattack"

local MIN_FOLLOW_DIST = 0
local MAX_FOLLOW_DIST = 12
local TARGET_FOLLOW_DIST = 6

local MAX_WANDER_DIST = 3

local DO_ACTIONS_DISTANCE = 30

local FOOD_TAGS = {"edible"}
local NO_TAGS = {"FX", "NOCLICK", "DECOR", "INLIMBO", "kittenchow"}


local WolfieBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)


local function EatFoodAction(inst)
    local target = nil

    local pt = inst:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, DO_ACTIONS_DISTANCE, FOOD_TAGS, NO_TAGS)

    for _, ent in pairs(ents) do
        if inst.components.eater:CanEat(ent) then
            target = ent
            break
        end
    end

    if target then
        return BufferedAction(inst, target, ACTIONS.EAT)--(PICK UP ACTION)
    end
end


function WolfieBrain:OnStart()
    local root = 
    PriorityNode({
        WhileNode( function() return self.inst.components.health.takingfiredamage end, "OnFire", Panic(self.inst)),
        Wander(self.inst, function() return self.inst.components.knownlocations:GetLocation("home") end, MAX_WANDER_DIST),
    
        ChaseAndAttack(self.inst, 100),

        DoAction(self.inst, EatFoodAction, "Eat Action"),
        
    }, .25)
    self.bt = BT(self.inst, root)
end

return WolfieBrain