local easing = require "easing"

local function GoToSleep(inst)
	if inst.components.prince_anti_persister then
    	inst.components.prince_anti_persister.NearPrince = false
    	--print("["..inst.prefab.."] is far from Prince!")
    	inst.entity:SetCanSleep(true)
    	--If it produces light, let its light sleep again!
    	--if inst.Light then
    		--self.Light:Enable(false)
    	--end
    end
end

local function StayAwake(inst)
    if inst.components.prince_anti_persister then
    	inst.components.prince_anti_persister.NearPrince = true
    	--print("Prince is near a ["..inst.prefab.."]!")
    	inst.entity:SetCanSleep(false)
    	--If it produces light, don't let its light sleep!
    	--if inst.Light then
    		--inst.Light:Enable(true)
    	--end
    end
end

local PrinceAntiPersister = Class(function(self, inst)
    self.inst = inst
    self.NearPrince = false

    inst:ListenForEvent("FarFromPrince", GoToSleep)
    inst:ListenForEvent("NearPrince", StayAwake)

    
end)




function PrinceAntiPersister:OnSave()
    return {NearPrince = self.NearPrince}
end


function PrinceAntiPersister:OnLoad(data)
	self.NearPrince = data.NearPrince or self.NearPrince

	if self.NearPrince then
		--print("Prince is near a ["..self.inst.prefab.."]!")
    	self.inst.entity:SetCanSleep(false)
    else
    	--print("["..self.inst.prefab.."] is far from Prince!")
    	self.inst.entity:SetCanSleep(true)
    end

end


return PrinceAntiPersister
