local SGWilson=require "stategraphs/SGwilson"
require "actions"


--Gives Princess the ability to transform into a wolf on command!
local TRANSFORM = Action({mount_enabled=false})
TRANSFORM.id = "TRANSFORM"
TRANSFORM.str = "Transform"
TRANSFORM.fn = function(act)
	if act.doer.prefab == "princess" then
    		if act.doer.IsWolf then
        	act.doer:PushEvent("transform_to_princess")
        	--return true
    	else
    		act.doer:PushEvent("transform_to_wolf")
    		--return true
    		end 
        return false
	end

end

--Should allow the player to bring Prince along or have him stay put!
local HOLDHAND = Action({mount_enabled=false}, 1, true, true)
HOLDHAND.id = "HOLDHAND"
HOLDHAND.str = "Call"
--HOLDHAND.strfn = function(act)
--local subject = act.target
--if subject and act.doer.components.leader and subject.components.follower and not subject.components.follower.leader then
--        HOLDHAND.str = "Call"
--    else
--        HOLDHAND.str = "Stay"
--    end
--end
HOLDHAND.fn = function(act)
    if act.doer.components.leader and act.target.components.follower and not act.target.components.follower.leader then
            
        act.doer.components.leader:AddFollower(act.target)

            if act.target.sg:HasStateTag("asleep") then

                act.target.sg:GoToState("wakeup")

                if act.doer.prefab == "princess" then

                    local wakingprincess = {"Wake up, Prince.", "Are you OK, Prince?"}
                    act.doer.components.talker:Say(wakingprincess[math.random(1, #wakingprincess)])

                end

            else

                if act.doer.prefab == "princess" and act.doer:HasTag("liarprincess") then

                    local happyprincess = {"I'm over here, Prince!", "Here I am, Prince!", "Hello, Prince!", "This way, Prince."}
                    act.doer.components.talker:Say(happyprincess[math.random(1, #happyprincess)])

                    act.target:DoTaskInTime(0.5, function()
                        if act.target.components.follower and act.target.components.follower.leader then
                            local happyprince = {"I'm coming, Princess!", "There you are, Princess.", "Hello, Princess.", "You're back!"}
                            act.target.components.talker:Say(happyprince[math.random(1, #happyprince)])
                        end
                    end)
                elseif act.doer.prefab ~= "princess" then
                    act.target:DoTaskInTime(0.5, function()
                        if act.target.components.follower and act.target.components.follower.leader then
                            local confusedprince = {"Why are you helping me?", "Who are you?", "I don't recognize your voice.", "What do you want with me?"}
                            act.target.components.talker:Say(confusedprince[math.random(1, #confusedprince)])
                        end
                    end)
                end

            end

        else

        act.target.components.follower:StopFollowing()

            if act.target.sg:HasStateTag("asleep") then

                act.target.sg:GoToState("wakeup")

                if act.doer.prefab == "princess" then

                    local wakingprincess = {"Wake up, Prince.", "Are you OK, Prince?"}
                    act.doer.components.talker:Say(wakingprincess[math.random(1, #wakingprincess)])

                end

            else

                if act.doer.prefab == "princess" then

                    local leavingprincess = {"Wait right here, OK Prince?", "I'll be back, Prince.", "Stay here, Prince.", "I won't be long, Prince."}
                    act.doer.components.talker:Say(leavingprincess[math.random(1, #leavingprincess)])

                    act.target:DoTaskInTime(1, function()
                        local waitingprince = {"I'll wait for you, Princess.", "Be careful, Princess.", "Take care, Princess.", "Be safe, Princess."}
                        act.target.components.talker:Say(waitingprince[math.random(1, #waitingprince)])
                    end)
                elseif act.doer.prefab ~= "princess" then
                    act.target:DoTaskInTime(1, function()
                        local waitingprince = {"I'll be here.", "Goodbye, then."}
                        act.target.components.talker:Say(waitingprince[math.random(1, #waitingprince)])
                    end)
                end

            end
            
        return true
    end

end

ACTIONS.TRANSFORM = TRANSFORM
ACTIONS.HOLDHAND = HOLDHAND