local assets =
{
	Asset("ANIM", "anim/princecloak.zip"),
    Asset("ATLAS", "images/inventoryimages/princecloak.xml"),

    --Asset("ATLAS", "images/inventoryimages/badprincecloak.xml"),
}

local prefabs =
{
}


local function GetStatus(inst)
    --print("smallbird - GetStatus")
    if inst.components.fueled then
        if inst.components.fueled:IsEmpty() then
            return "WORNOUT"
        end
    end
end

local function onequip(inst, owner) --, fname_override
    --local build = fname_override or "princecloak"
    owner.AnimState:OverrideSymbol("swap_body", "princecloak", "swap_body")
    --inst.components.fueled:StartConsuming()
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    --inst.components.fueled:StopConsuming()
end


local function wearout(inst)

    local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
    if owner then
        owner:PushEvent("cloakranout", {cloak = inst})
    end

    if inst.components.fueled:IsEmpty() then

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst.components.equippable.dapperness = 0
        else
            inst.components.dapperness.dapperness = 0
        end

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            if inst.components.insulator then
                inst.components.insulator:SetInsulation(0)
            end

            if inst.components.waterproofer then
                inst.components.waterproofer:SetEffectiveness(0)
            end
        end

        --inst.components.inventoryitem:ChangeImageName("tattered_princecloak")

    end

end

local function ReturnUsefulness(inst)

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst.components.equippable.dapperness = TUNING.DAPPERNESS_MED
        else
            inst.components.dapperness.dapperness = TUNING.DAPPERNESS_MED
        end

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            if inst.components.insulator then
                inst.components.insulator:SetInsulation(TUNING.INSULATION_SMALL)
                inst.components.insulator:SetSummer()
            end

            if inst.components.waterproofer then
                inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_SMALL)
            end
        end

end

local function fuelupdate(inst)
    
    if inst.components.fueled and not inst.components.fueled:IsEmpty() then

        ReturnUsefulness(inst)

        --inst.components.inventoryitem:ChangeImageName("princecloak")

    end

end

local function onrepair(inst)

        if inst.components.equippable and inst.components.equippable:IsEquipped() then

            local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
            if owner then
                --local equipslot = inst.components.equippable.equipslot
                --owner.components.inventory:Equip(inst)
                onequip(inst, owner)
                inst.components.fueled:StartConsuming()
            end
            --inst.components.inventoryitem:ChangeImageName("princecloak")

        end

        ReturnUsefulness(inst)

end


local function OnSave(inst, data)

end

local function OnLoad(inst, data)

    if inst.components.fueled:IsEmpty() then

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst.components.equippable.dapperness = 0
        else
            inst.components.dapperness.dapperness = 0
        end

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            if inst.components.insulator then
                inst.components.insulator:SetInsulation(0)
            end

            if inst.components.waterproofer then
                inst.components.waterproofer:SetEffectiveness(0)
            end
        end

        --inst.components.inventoryitem:ChangeImageName("tattered_princecloak")
    
    else

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst.components.equippable.dapperness = TUNING.DAPPERNESS_MED
        else
            inst.components.dapperness.dapperness = TUNING.DAPPERNESS_MED
        end

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            if inst.components.insulator then
                inst.components.insulator:SetInsulation(TUNING.INSULATION_SMALL)
                inst.components.insulator:SetSummer()
            end

            if inst.components.waterproofer then
                inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_SMALL)
            end
        end

        --inst.components.inventoryitem:ChangeImageName("princecloak")

    end

end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("princecloak")
    inst.AnimState:SetBuild("princecloak")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("princecloak")

    inst:AddTag("vented") --For Hamlet fog

    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        MakeInventoryFloatable(inst, "idle_water", "idle")
        MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.LIGHT, TUNING.WINDBLOWN_SCALE_MAX.LIGHT)
    end
    
    inst:AddComponent("inventoryitem")

    inst.components.inventoryitem.atlasname = "images/inventoryimages/princecloak.xml"

    inst:AddComponent("named")
    inst.components.named.possiblenames = {"Prince's Cloak"}
    inst.components.named:PickNewName()

    -----------------------------------
    inst:AddComponent("inspectable")
    inst.components.inspectable.getstatus = GetStatus

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY

    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --inst.components.equippable.walkspeedmult = 0.1
    --else
        --inst.components.equippable.walkspeedmult = 1.1
    --end

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.equippable.dapperness = TUNING.DAPPERNESS_MED
    else
        inst:AddComponent("dapperness")
        inst.components.dapperness.dapperness = TUNING.DAPPERNESS_MED
    end

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst:AddComponent("insulator")
        inst.components.insulator:SetInsulation(TUNING.INSULATION_SMALL)
        inst.components.insulator:SetSummer()

        inst:AddComponent("waterproofer")
        inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_SMALL)
    end

    --inst:AddComponent("fueled")
    --inst.components.fueled.fueltype = "USAGE"
    --inst.components.fueled:InitializeFuelLevel(10) --TUNING.WALRUSHAT_PERISHTIME
    --inst.components.fueled:SetDepletedFn(wearout)
    --inst.components.fueled:SetUpdateFn(fuelupdate)
    --inst.components.fueled.ontakefuelfn = onrepair

    inst:AddComponent("characterspecific")
    inst.components.characterspecific:SetOwner("princess")

    --inst.OnSave = OnSave
    --inst.OnLoad = OnLoad

    return inst
end

return Prefab("princecloak", fn, assets)