local easing = require "easing"                                --Use the PC Command Prompt to utilize ktools! Add " cd " before your directory when decompiling!
local MakePlayerCharacter = require "prefabs/player_common" --krane.exe anim.bin build.bin output_dir FOR DECOMPILING! ktech.exe for TEX DECOMPILING!

--These are to get Prince's status bars to work properly
local Badge = require "widgets/badge"
local Widget = require "widgets/widget" 
local hungerbadge = require "widgets/hungerbadge"
local healthbadge = require "widgets/healthbadge"
local sanitybadge = require "widgets/sanitybadge"


local UIAnim = require "widgets/uianim"

local assets = {

        -- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/princess.zip" ),
        Asset("ANIM", "anim/princess_happy.zip"),
        
        Asset( "ANIM", "anim/wolf.zip" ),
        Asset( "ANIM", "anim/wolf_drowning.zip" ),


        Asset("IMAGE", "images/colour_cubes/beaver_vision_cc.tex"),

        --Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
    --Asset("ANIM", "anim/player_mount_wilson.zip"),
    --Asset("ANIM", "anim/player_common.zip"),

}

local prefabs = {}

--Probably a better way to program Prince's stats into the game HUD, but I'm Frankensteining my way through it. Much of the code here is sampled from "statusdisplay".
local function CheckPrinceStatus(inst, data)

    local prince = nil
    if data and data.inst.prefab == "prince" then
        prince = data.inst
    elseif not data then
        prince = FindEntity(inst, 10000, function(ent)
            return ent:HasTag("blindprince")
        end)
    end
    if prince then

    local controls = GetPlayer().HUD.controls
    local status = controls.status

    local PrinceHungerBadge = Class(hungerbadge, function(self, owner)
        Badge._ctor(self, "hunger", owner)
    end)

    local PrinceHealthBadge = Class(healthbadge, function(self, owner)
        Badge._ctor(self, "health", owner)

            self.sanityarrow = self.underNumber:AddChild(UIAnim())
            self.sanityarrow:GetAnimState():SetBank("sanity_arrow")
            self.sanityarrow:GetAnimState():SetBuild("sanity_arrow")
            self.sanityarrow:GetAnimState():PlayAnimation("neutral")
            self.sanityarrow:SetClickable(false)
    
            self.topperanim = self.underNumber:AddChild(UIAnim())
            self.topperanim:GetAnimState():SetBank("effigy_topper")
            self.topperanim:GetAnimState():SetBuild("effigy_topper")
            self.topperanim:GetAnimState():PlayAnimation("anim")
            self.topperanim:SetClickable(false)

            if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                self.poisonanim = self.underNumber:AddChild(UIAnim())
                self.poisonanim:GetAnimState():SetBank("poison")
                self.poisonanim:GetAnimState():SetBuild("poison_meter_overlay")
                self.poisonanim:GetAnimState():PlayAnimation("deactivate")
                self.poisonanim:Hide()
                self.poisonanim:SetClickable(false)
            end
    
            self:StartUpdating()
    end)

    local PrinceSanityBadge = Class(sanitybadge, function(self, owner)
        Badge._ctor(self, "sanity", owner)
    
        self.sanityarrow = self.underNumber:AddChild(UIAnim())
        self.sanityarrow:GetAnimState():SetBank("sanity_arrow")
        self.sanityarrow:GetAnimState():SetBuild("sanity_arrow")
        self.sanityarrow:GetAnimState():PlayAnimation("neutral")
        self.sanityarrow:SetClickable(false)

        self.topperanim = self.underNumber:AddChild(UIAnim())
        self.topperanim:GetAnimState():SetBank("effigy_topper")
        self.topperanim:GetAnimState():SetBuild("effigy_topper")
        self.topperanim:GetAnimState():PlayAnimation("anim")
        self.topperanim:SetClickable(false)

        self:StartUpdating()
    end)


    --Add Prince's Hunger Bar!
    if not status.princehunger then
        status.princehunger = status:AddChild(PrinceHungerBadge(prince))
        status.princehunger:SetPosition(-200,20,0)
        status.princehunger:SetPercent(prince.components.hunger:GetPercent(), prince.components.hunger.max)
    elseif status.princehunger then --To reset the Prince status bars if there are multiple princes.
        status.princehunger:Kill()

        status.princehunger = status:AddChild(PrinceHungerBadge(prince))
        status.princehunger:SetPosition(-200,20,0)
        status.princehunger:SetPercent(prince.components.hunger:GetPercent(), prince.components.hunger.max)
    end

    status.princehunger.inst:ListenForEvent("hungerdelta", function(inst, data)

    status.princehunger:SetPercent(prince.components.hunger:GetPercent(), prince.components.hunger.max)

        if data.newpercent <= 0 then
        status.princehunger:StartWarning()
        else
        status.princehunger:StopWarning()
        end
    
        if not data.overtime then
            if data.newpercent > data.oldpercent then
                status.princehunger:PulseGreen()
                TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/hunger_up")
            elseif data.newpercent < data.oldpercent then
                TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/hunger_down")
                status.princehunger:PulseRed()
            end
        end

    end, prince)
    

    --Add Prince's health bar!
    if not status.princehealth then
        status.princehealth = status:AddChild(PrinceHealthBadge(prince))
        status.princehealth:SetPosition(-120,20,0)
        status.princehealth:SetPercent(prince.components.health:GetPercent(), prince.components.health:GetMaxHealth())
    elseif status.princehealth then --To reset the Prince status bars if there are multiple princes.
        status.princehealth:Kill()
        
        status.princehealth = status:AddChild(PrinceHealthBadge(prince))
        status.princehealth:SetPosition(-120,20,0)
        status.princehealth:SetPercent(prince.components.health:GetPercent(), prince.components.health:GetMaxHealth())
    end

    status.princehealth.inst:ListenForEvent("healthdelta", function(inst, data)

    status.princehealth:SetPercent(prince.components.health:GetPercent(), prince.components.health.maxhealth, prince.components.health:GetPenaltyPercent()) 
    
    if data.oldpercent > .33 and data.newpercent <= .33 then
        status.princehealth:StartWarning()
    else
        status.princehealth:StopWarning()
    end
    
    if not data.overtime then
        if data.newpercent > data.oldpercent then
            status.princehealth:PulseGreen()
            TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
        elseif data.newpercent < data.oldpercent then
            TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
            status.princehealth:PulseRed()

            if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                if prince.components.poisonable:IsPoisoned() then
                    TheFrontEnd:GetSound():PlaySound("dontstarve_DLC002/common/HUD_Poisoned")
                end
            end

        end
    end

    end, prince)
    

    --Add Prince's sanity bar!
    if not status.princesanity then
        status.princesanity = status:AddChild(PrinceSanityBadge(prince))
        status.princesanity:SetPosition(-160,-40,0)
        status.princesanity:SetPercent(prince.components.sanity:GetPercent(), prince.components.sanity.max, prince.components.sanity:GetPenaltyPercent())
    elseif status.princehealth then --To reset the Prince status bars if there are multiple princes.
        status.princesanity:Kill()
        
        status.princesanity = status:AddChild(PrinceSanityBadge(prince))
        status.princesanity:SetPosition(-160,-40,0)
        status.princesanity:SetPercent(prince.components.sanity:GetPercent(), prince.components.sanity.max, prince.components.sanity:GetPenaltyPercent())
    end

    status.princesanity.inst:ListenForEvent("sanitydelta", function(inst, data)

    status.princesanity:SetPercent(prince.components.sanity:GetPercent(), prince.components.sanity.max, prince.components.sanity:GetPenaltyPercent())
    
    
        if prince.components.sanity:IsCrazy() then
            status.princesanity:StartWarning()
        else
            status.princesanity:StopWarning()
        end
    
        if not data.overtime then
            if data.newpercent > data.oldpercent then
                status.princesanity:PulseGreen()
                TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/sanity_up")
            elseif data.newpercent < data.oldpercent then
                status.princesanity:PulseRed()
                TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/sanity_down")
            end
        end

    end, prince)
        

    end

end

--Monitor Prince's boat's health if he's riding one!
local function CheckPrinceBoatStatus(inst, data)

    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
    local boatbadge = require "widgets/boatbadge"

    local controls = GetPlayer().HUD.controls
    local status = controls.status

    local prince = nil
    if data and data.inst.prefab == "prince" then
        prince = data.inst
    elseif not data then
        prince = FindEntity(inst, 10000, function(ent)
            return ent:HasTag("blindprince")
        end)
    end
    if prince and prince.components.driver and prince.components.driver.vehicle then

        local PrinceBoatBadge = Class(boatbadge, function(self, owner)
            Badge._ctor(self, "boat_health", owner)

            self.boatarrow = self.underNumber:AddChild(UIAnim())
            self.boatarrow:GetAnimState():SetBank("sanity_arrow")
            self.boatarrow:GetAnimState():SetBuild("sanity_arrow")
            self.boatarrow:GetAnimState():PlayAnimation("neutral")
            self.boatarrow:SetClickable(false)

            --self.num:SetSize(40)

            --self:SetScale(0.78)
    
            self:StartUpdating()
        end)


        status.princeboathealth = status:AddChild(PrinceBoatBadge(prince.components.driver.vehicle))
        status.princeboathealth:SetPosition(-280,20,0) -- -250,-677.25,0 was the original coordinates, but it loses position if the HUD size is increased or decreased.
        status.princeboathealth:SetPercent(prince.components.driver.vehicle.components.boathealth:GetPercent(), prince.components.driver.vehicle.components.boathealth.maxhealth)
        
            --OnUpdate()

        status.princeboathealth.inst:ListenForEvent("boathealthchange", function(inst, data) 
               status.princeboathealth:SetPercent(prince.components.driver.vehicle.components.boathealth:GetPercent(), prince.components.driver.vehicle.components.boathealth.maxhealth)
                --if not data.overtime then
                    --if data.newpercent > data.oldpercent then
                        --status.princeboathealth:PulseGreen()
                        --TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
                    --elseif data.newpercent < data.oldpercent then
                        --TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
                        --status.princeboathealth:PulseRed()
                    --end
                --end
            end, prince.components.driver.vehicle)

    end

    if prince and status.princeboathealth and prince.components.driver and not prince.components.driver.vehicle then
        if status.princeboathealth then
            status.princeboathealth:Kill()
        end
    end

    end

end


--Display Prince's wetness if he's wet! The code here is ripped from "moisturemeter"!
local function CheckPrinceWetness(inst, data)

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        local moisturebadge = require "widgets/moisturemeter"
        local Text = require "widgets/text"

        local prince = nil
        if data and data.inst.prefab == "prince" then
            prince = data.inst
        elseif not data then
            prince = FindEntity(inst, 10000, function(ent)
                return ent:HasTag("blindprince")
            end)
        end
        if prince or (data and data.prefab == "prince") then

        local controls = GetPlayer().HUD.controls
        local status = controls.status


            local PrinceMoistureMeter = Class(moisturebadge, function(self, owner)
                Widget._ctor(self, "MoistureMeter")
                self.owner = owner

                self:SetPosition(0,0,0)

                self.active = false

                self.numDrops = 0
                self.drops = {}

                self.moisture = 0
                self.active = false

                self.anim = self:AddChild(UIAnim())
                self.anim:GetAnimState():SetBank("wet")
                self.anim:GetAnimState():SetBuild("wet_meter_player")
                self.anim:SetClickable(true )


                self.arrow = self.anim:AddChild(UIAnim())
                self.arrow:GetAnimState():SetBank("sanity_arrow")
                self.arrow:GetAnimState():SetBuild("sanity_arrow")
                self.arrow:GetAnimState():PlayAnimation("neutral")
                self.arrow:SetClickable(false)

                self.underNumber = self:AddChild(Widget("undernumber"))

                self.num = self:AddChild(Text(BODYTEXTFONT, 33))
                self.num:SetHAlign(ANCHOR_MIDDLE)
                self.num:SetPosition(5, 0, 0)
                self.num:SetClickable(false)
    
                self.num:Hide()

                self:StartUpdating()
            end)


        --Add Prince's Moisture Bar!
        if not status.princemoisture then
            status.princemoisture = status:AddChild(PrinceMoistureMeter(prince))
            status.princemoisture:SetPosition(-160,-115,0)
        end
        --local currentmoisture = prince.components.moisture:GetMoisture()
        --status.princemoisture.anim:GetAnimState():SetPercent("anim", prince.components.moisture:GetMoisture()/100)


        status.princemoisture.inst:ListenForEvent("moisturechange", function(inst, data) 

            if prince.components.moisture.moisture > 0 then
                --This is to prevent the animation from looping indefinintely!
                if not inst:HasTag("princewetnesstracking") then
                    inst:AddTag("princewetnesstracking")
                    status.princemoisture:Show()
                    status.princemoisture.anim:GetAnimState():PlayAnimation("open")
                    inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/HUD_wet_open")
                end
                status.princemoisture.animTask = inst:DoPeriodicTask(.5, function() status.princemoisture.anim:GetAnimState():SetPercent("anim", prince.components.moisture:GetMoisture()/100) end)
            end
            
            if prince.components.moisture.moisture <= 0 then
                if status.princemoisture.animTask then
                    status.princemoisture.animTask:Cancel()
                    status.princemoisture.animTask = nil
                    inst:DoTaskInTime(0.15, function() status.princemoisture:Hide() end)
                end
                --This is to prevent the animation from looping indefinintely!
                if inst:HasTag("princewetnesstracking") then
                    inst:RemoveTag("princewetnesstracking")
                    status.princemoisture.anim:GetAnimState():PlayAnimation("close")
                    inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/HUD_wet_close")
                end         
            end

        end, prince)


        end



    end


end



--Princess should not comment on monster meat hurting her belly.
local function oneat(inst, data)

    --[REDACTED!] Monster meats need to be excluded in DLC because Princess would gain sanity from eating them, since she shares the trait with Webber that she can eat monster meat.
    if data.food and
        (data.food.prefab == "monstermeat" or data.food.prefab == "cookedmonstermeat" or data.food.prefab == "monstermeat_dried" or data.food.prefab == "monsterlasagna") then
        if data.food.components.perishable and data.food.components.perishable:IsStale() then
            inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_EAT", "STALE"))
        elseif data.food.components.perishable and data.food.components.perishable:IsSpoiled() then
            inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_EAT", "SPOILED"))
        elseif data.food.components.perishable and data.food.components.perishable:IsFresh() then
            inst.components.talker:ShutUp() --Please.
        end
    end

    --Should I make Princess lose sanity eating spoiled food that normally doesn't drain sanity with any of the DLC enabled? It seems to only be a thing in vanilla Don't Starve...
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --if data.food
        --and data.food.components.edible.foodtype == "MEAT" and data.food.components.edible.foodstate == "COOKED"
        --and data.food.components.perishable and data.food.components.perishable:IsSpoiled() then
            --print("IT'S ROTTEN!")
            --inst.components.sanity:DoDelta(-TUNING.SANITY_SMALL, false)
        --end
    --end

    if data.food and data.food.components.edible.healthvalue > 0 and not inst.IsWolf then
        inst.HealthToRegen = inst.HealthToRegen + data.food.components.edible.healthvalue
    end

end

--Princess is afraid of fire!
local function sanityfn(inst)

    local blindprince = FindEntity(inst, 10, function(ent)
        return ent:HasTag("blindprince")
    end)

    local x,y,z = inst.Transform:GetWorldPosition() 
    local delta = 0
    local max_rad = 10
    local ents = TheSim:FindEntities(x,y,z, max_rad, {"fire"})
    for k,v in pairs(ents) do 

            
                                                                            --Princess won't be afraid of torches Prince is wielding.    
        if v.components.burnable and v.components.burnable.burning and not (v.components.inventoryitem and v.components.inventoryitem.owner == blindprince) then
            local sz = -TUNING.SANITYAURA_MED
            local rad = v.components.burnable:GetLargestLightRadius() or 1
            sz = sz * ( math.min(max_rad, rad) / max_rad )
            local distsq = inst:GetDistanceSqToInst(v)
            delta = delta + sz/math.max(1, distsq)
        end

    end
    
    return delta
end


local function WolfActionButton(inst)

    local action_target = FindEntity(inst, 6, function(guy) return (IsDLCEnabled(PORKLAND_DLC) and guy.components.door and not guy.components.door.disabled and (not guy.components.burnable or not guy.components.burnable:IsBurning())) or 
                                                                   (guy.components.inventoryitem and guy.components.inventoryitem.canbepickedup) or 
                                                                   (guy.components.pickable and guy.components.pickable:CanBePicked()) or
                                                                   ((IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) and guy.components.hackable and guy.components.hackable:CanBeHacked() and inst.components.worker:CanDoAction(ACTIONS.HACK)) or
                                                                   (guy.components.activatable and guy.components.activatable.inactive) end)

    if not inst.sg:HasStateTag("busy") and action_target then
        if action_target.components.inventoryitem and action_target.components.inventoryitem.canbepickedup then 
            return BufferedAction(inst, action_target, ACTIONS.PICKUP)
        elseif IsDLCEnabled(PORKLAND_DLC) 
        and action_target.components.door and not action_target.components.door.disabled and (not action_target.components.burnable or not action_target.components.burnable:IsBurning()) then
            return BufferedAction(inst, action_target, ACTIONS.USEDOOR)
        elseif action_target.components.pickable and action_target.components.pickable:CanBePicked() then
            return BufferedAction(inst, action_target, ACTIONS.PICK)
        elseif (IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC)) 
        and action_target.components.hackable and action_target.components.hackable:CanBeHacked() and action_target.components.hackable.hacksleft > 0 then
            return BufferedAction(inst, action_target, ACTIONS.HACK)
        elseif action_target.components.activatable and action_target.components.activatable.inactive 
        and action_target.prefab ~= "cave_entrance" and action_target.prefab ~= "cave_exit" 
        and action_target.prefab ~= "shipwrecked_entrance" and action_target.prefab ~= "shipwrecked_exit"
        and action_target.prefab ~= "porkland_entrance" and action_target.prefab ~= "porkland_exit"
        and action_target.prefab ~= "teleportato_base" and action_target.prefab ~= "teleportato_checkmate" 
        and action_target.prefab ~= "teleportato_sw_base" and action_target.prefab ~= "teleportato_hamlet_base" 
        and action_target.prefab ~= "volcano"  and action_target.prefab ~= "volcano_exit"
        and action_target.prefab ~= "adventure_portal" then
            return BufferedAction(inst, action_target, ACTIONS.ACTIVATE)
        end
    end

    --if IsDLCEnabled(PORKLAND_DLC) then
        --if action_target.components.door and not action_target.components.door.disabled and (not action_target.components.burnable or not action_target.components.burnable:IsBurning()) then
           --return BufferedAction(inst, action_target, ACTIONS.USEDOOR)
        --end
    --end

    --if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --if action_target.components.hackable and action_target.components.hackable:CanBeHacked() and action_target.components.hackable.hacksleft > 0 then
            --return BufferedAction(inst, action_target, ACTIONS.HACK)
        --end
    --end

end



local function SetHUDState(inst)
    if inst.HUD then

        if inst.IsWolf then

            inst.HUD.controls.crafttabs:Hide()

            inst.HUD.controls.mapcontrols.minimapBtn:Hide()
        
        else

        if not inst.IsWolf then

            inst.HUD.controls.crafttabs:Show()
            --inst.HUD.controls.inv:Show()
            --inst.HUD.controls.status:Show()
            inst.HUD.controls.mapcontrols.minimapBtn:Show()

            end

        end

    end

end

local function WolfLeftClickPicker(inst, target_ent, pos)
    local active_item = inst.components.inventory:GetActiveItem()

    if active_item and target_ent and target_ent.components.inventoryitem and not target_ent.components.inventoryitem:IsHeld() and target_ent.components.stackable
    and not target_ent.components.stackable:IsFull() and target_ent.prefab == active_item.prefab and target_ent.components.inventoryitem.canbepickedup then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.COMBINESTACK}, target_ent, active_item)
    end

    if active_item then
        local passable = true
        local ground = GetWorld()

        if pos and ground and ground.Map then
            local tile = ground.Map:GetTileAtPoint(pos.x, pos.y, pos.z)
            passable = tile ~= GROUND.IMPASSABLE
        end

        if (passable and not target_ent) or (passable and target_ent and target_ent ~= inst) then
            return inst.components.playeractionpicker:GetPointActions(pos, active_item)
        end
    end

    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        if target_ent and target_ent.components.burnable and target_ent.components.burnable:IsSmoldering() and not inst.components.playeractionpicker:ShouldForceInspect() and not inst.components.health:IsDead() then    
            return inst.components.playeractionpicker:SortActionList({ACTIONS.SMOTHER}, target_ent, nil)       
        end
    end

    if target_ent and not active_item and target_ent.prefab == "prince" and not inst.components.playeractionpicker:ShouldForceAttack() then
        --if inst.components.playeractionpicker:ShouldForceInspect() then
            return inst.components.playeractionpicker:SortActionList({ACTIONS.LOOKAT}, target_ent, nil)
        --else
            --return inst.components.playeractionpicker:SortActionList({ACTIONS.HOLDHAND}, target_ent, nil)
        --end
    end

    if target_ent and not active_item and target_ent.components.pickable and target_ent.components.pickable.canbepicked == true and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.PICK}, target_ent, nil)
    end

    if target_ent and not active_item and target_ent.components.inventoryitem and target_ent.components.inventoryitem.canbepickedup == true and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.PICKUP}, target_ent, nil)
    end

    if target_ent and not active_item and inst.components.combat:CanTarget(target_ent) and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.ATTACK}, target_ent, nil)
    end

    --if target_ent and not active_item and target_ent.components.edible and inst.components.eater:CanEat(target_ent) and not inst.components.playeractionpicker:ShouldForceInspect() then
        --return inst.components.playeractionpicker:SortActionList({ACTIONS.EAT}, target_ent, nil)
    --end

    if target_ent and target_ent.components.inspectable and not active_item and inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.LOOKAT}, target_ent, nil)
    end

    if target_ent and not active_item and target_ent.components.teleporter and target_ent.components.teleporter.targetTeleporter ~= nil and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.JUMPIN}, target_ent, nil)
    end

    if active_item and active_item.components.edible and target_ent == inst then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.EAT}, nil, active_item)
    end

    if target_ent and not active_item
    and target_ent.components.activatable and target_ent.components.activatable.inactive == true
    --Don't let Wolf use warping things!
    and target_ent.prefab ~= "cave_entrance" and target_ent.prefab ~= "cave_exit" 
    and target_ent.prefab ~= "shipwrecked_entrance" and target_ent.prefab ~= "shipwrecked_exit"
    and target_ent.prefab ~= "porkland_entrance" and target_ent.prefab ~= "porkland_exit"
    and target_ent.prefab ~= "teleportato_base" and target_ent.prefab ~= "teleportato_checkmate" 
    and target_ent.prefab ~= "teleportato_sw_base" and target_ent.prefab ~= "teleportato_hamlet_base" 
    and target_ent.prefab ~= "volcano"  and target_ent.prefab ~= "volcano_exit"
    and target_ent.prefab ~= "adventure_portal"
    and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.ACTIVATE}, target_ent, nil)
    end

    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        if target_ent and not active_item and target_ent.components.hackable and target_ent.components.hackable:CanBeHacked() and target_ent.components.hackable.hacksleft > 0 
        and inst.components.worker:CanDoAction(ACTIONS.HACK) and not inst.components.playeractionpicker:ShouldForceInspect() then
            return inst.components.playeractionpicker:SortActionList({ACTIONS.HACK}, target_ent, nil)
        end
    end


    if IsDLCEnabled(PORKLAND_DLC) then
        if target_ent and not active_item and target_ent.components.door and not target_ent.components.door.disabled and (not target_ent.components.burnable or not target_ent.components.burnable:IsBurning()) then   
            return inst.components.playeractionpicker:SortActionList({ACTIONS.USEDOOR}, target_ent, nil)
        end

        if active_item and target_ent and target_ent:HasTag("weighdownable") then
            return inst.components.playeractionpicker:SortActionList({ACTIONS.WEIGHDOWN}, target_ent, active_item)
        end
    end

    --This is at the bottom so it has the lowest priority in the base game.
    if target_ent and not active_item and target_ent.components.inspectable and not inst.components.combat:CanTarget(target_ent) and not inst.components.playeractionpicker:ShouldForceInspect() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.LOOKAT}, target_ent, nil)
    end

end


--Changes Princess to Wolf!
local function BecomeWolf(inst)
    if inst.components.rider:IsRiding() then
        inst.components.rider:ActualDismount()
    end


    for k,v in pairs(inst.components.leader.followers) do
        if k:HasTag("blindprince") then

            local leavingprincess = {"Wait right here, OK Prince?", "I'll be back, Prince.", "Stay here, Prince.", "I won't be long, Prince."}
            inst.components.talker:Say(leavingprincess[math.random(1, #leavingprincess)])

            k:DoTaskInTime(1, function()
                local waitingprince = {"I'll wait for you, Princess.", "Be careful, Princess.", "Take care, Princess.", "Be safe, Princess."}
                k.components.talker:Say(waitingprince[math.random(1, #waitingprince)])
            end)

            --Princess doesn't want Prince to be near her as a wolf!
            inst.components.leader:RemoveFollowersByTag("blindprince")

        end
    end


    local smoke = SpawnPrefab("poopcloud")
    smoke.Transform:SetPosition(inst:GetPosition():Get())
    smoke.Transform:SetScale(5,5,5)
    local fx = SpawnPrefab("statue_transition_2")
        if fx then
            fx.Transform:SetPosition(inst:GetPosition():Get())
            fx.AnimState:SetScale(3,4.5,3)
        end


    inst:DoTaskInTime(0.1, function()

    --Ensure Prince doesn't follow Princess!
    inst.components.leader:RemoveFollowersByTag("blindprince")

    --Stops an eating sound bug!
    inst.SoundEmitter:KillSound("eating") 
    inst.SoundEmitter:KillSound("make")

    --Little fix in case of turning into Wolf during an "invincible" animation.
    inst.components.health:SetInvincible(false)

    inst:RemoveTag("liarprincess")
    inst:AddTag("monster")
    inst:AddTag("largecreature")
    if not inst:HasTag("NOVACUUM") then
        inst:AddTag("NOVACUUM") --To prevent Sealnado bugs.
    end
    --inst:AddTag("hound")
    inst:AddTag("wolf")
    inst.AnimState:SetBuild("wolf")
    inst.AnimState:SetBank("wolf")

    if IsDLCEnabled(PORKLAND_DLC) then
        inst:SetStateGraph("SGwolfie_h")
    elseif (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) then
        inst:SetStateGraph("SGwolfie_sw")
    elseif IsDLCEnabled(REIGN_OF_GIANTS) and not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
        inst:SetStateGraph("SGwolfie_rog")
    elseif not IsDLCEnabled(REIGN_OF_GIANTS) and not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
        inst:SetStateGraph("SGwolfie")
    end

    --Delayed so that the shadow grows after an umbrella removal.
    inst:DoTaskInTime(0.05, function()
        inst.DynamicShadow:SetSize( 3.9, 1.8 )
    end)


    if inst.components.pinnable then
        if inst.components.pinnable:IsStuck() then
            inst.components.pinnable:Unstick()
        end
        inst:RemoveComponent("pinnable")
    end

    inst.sg:GoToState("transform")

    --Wolf has some resistance to temperature!
    inst.components.temperature.inherentinsulation = TUNING.INSULATION_MED
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.temperature.inherentsummerinsulation = TUNING.INSULATION_MED
    end

    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        inst:AddComponent("worker")
        inst.components.worker:SetAction(ACTIONS.HACK, 2)   

        --Wolf can't ride boats, so she'll break the one she's riding and drown if she's caught at sea in the full moon.
        if inst.components.driver and inst.components.driver:GetIsDriving() then 
                    inst.components.resurrectable.cantdrown = true 
                    inst.components.driver.vehicle.components.boathealth:SetHealth(0)
                    inst.components.driver.vehicle.components.boathealth:DoDelta(-1, "combat")
                    --Force the stategraphs into these states to prevent weird death animation bugs.
                    if IsDLCEnabled(PORKLAND_DLC) then
                        inst.components.driver.landstategraph = "SGwolfie_h"
                        inst.components.driver.boatingstategraph = "SGwolfie_h"
                    elseif (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) then
                        inst.components.driver.landstategraph = "SGwolfie_sw"
                        inst.components.driver.boatingstategraph = "SGwolfie_sw"
                    end
                    inst.sg:GoToState("wolf_death_boat")
        end
    end 


    local handslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
    if handslot then
        handslot.components.equippable:Unequip(inst)
        inst.components.inventory:RemoveItem(handslot)
        inst.components.inventory:DropItem(handslot, true, true)
    end

    local bodyslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
    if bodyslot then
        bodyslot.components.equippable:Unequip(inst)
        inst.components.inventory:RemoveItem(bodyslot)
        inst.components.inventory:DropItem(bodyslot, true, true)
    end

    local headslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
    if headslot then
        headslot.components.equippable:Unequip(inst)
        inst.components.inventory:RemoveItem(headslot)
        inst.components.inventory:DropItem(headslot, true, true)
    end



    --Wolf has night vision!
    --inst.Light:Enable(true)
    --GetClock():SetNightVision(true)
    --GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/beaver_vision_cc.tex")


    inst.PrincessHealthPercent = inst.components.health:GetPercent()
    inst.components.health:SetMaxHealth(2000)
    inst.components.health:SetPercent(inst.WolfHealthPercent)
    if inst.healthregen then
        inst.components.health:DoDelta(inst.HealthToRegen)
        inst.healthregen:Cancel()
        inst.healthregen = nil
    end
    inst.components.health:StartRegen(3, 10) --3 HP every 10 seconds, not every 10 seconds, 3 HP.
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --inst.components.health:SetAbsorptionAmount(0)
    --else
        --inst.components.health:SetAbsorbAmount(0)
    --end

    inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE*7.5)
    inst.components.hunger:SetKillRate(2000/TUNING.STARVE_KILL_TIME)

    inst.components.combat:SetDefaultDamage(60)
    --inst.components.combat:SetAttackPeriod(0.01)
    inst.components.combat:SetRange(4)
    inst.components.combat:SetAreaDamage(4, 0.5)

    inst.components.locomotor.runspeed = 12
    --inst.components.inventory:DropEverything()
    
    inst.components.playercontroller.actionbuttonoverride = WolfActionButton
    inst.components.playeractionpicker.leftclickoverride = WolfLeftClickPicker
    inst.components.playeractionpicker.rightclickoverride = function() return {} end

    inst:DoTaskInTime(0, function() SetHUDState(inst) end)

    inst.IsWolf = true
    

    end)

end

local function CheckWolfToggle(inst) --If Princess is on a boat, don't turn her into a wolf unless it's from the full moon!
    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        if inst.components.driver and inst.components.driver:GetIsDriving() then 
            return
        end
    end
            BecomeWolf(inst)
end

--Changes Wolf to Princess!
local function BecomePrincess(inst)

    if inst:HasTag("wolf") then
        inst.sg:GoToState("revert")
    end

    if not inst.components.pinnable then
        inst:AddComponent("pinnable")
    end

    inst.components.health:StopRegen()
    
    inst:DoTaskInTime(0.5, function()

    local smoke = SpawnPrefab("poopcloud")
    smoke.Transform:SetPosition(inst:GetPosition():Get())
    smoke.Transform:SetScale(5,5,5)
    local fx = SpawnPrefab("statue_transition_2")
        if fx then
            fx.Transform:SetPosition(inst:GetPosition():Get())
            fx.AnimState:SetScale(3,4.5,3)
        end

    inst.ActionStringOverride = nil
    inst.AnimState:SetBank("wilson")
    inst.AnimState:SetBuild("princess")
    inst:SetStateGraph("SGwilson")
    inst:AddTag("liarprincess")
    if inst:HasTag("NOVACUUM") then
        inst:RemoveTag("NOVACUUM") --To prevent Sealnado bugs.
    end
    inst:RemoveTag("monster")
    inst:RemoveTag("largecreature")
    --inst:RemoveTag("hound")
    inst:RemoveTag("wolf")

    inst.DynamicShadow:SetSize( 1.3, .6 )

    if inst.components.worker then
        inst:RemoveComponent("worker")
    end

    --Wolf has some resistance to temperature!
    inst.components.temperature.inherentinsulation = 0
    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        inst.components.temperature.inherentsummerinsulation = 0
    end

    --Princess does not have night vision!
    --inst.Light:Enable(false)
    --GetClock():SetNightVision(false)
    --GetWorld().components.colourcubemanager:SetOverrideColourCube(nil)

    inst.WolfHealthPercent = inst.components.health:GetPercent()
    inst.components.health:SetMaxHealth(50)
    inst.components.health:SetPercent(inst.PrincessHealthPercent)
    inst.HealthToRegen = 0
    inst.healthregen = inst:DoPeriodicTask(10, function() inst.HealthToRegen = inst.HealthToRegen + 3 end)
    inst.components.hunger:SetKillRate(150/TUNING.STARVE_KILL_TIME)

    --Princess takes more damage than Wolf!
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --inst.components.health:SetAbsorptionAmount(-16.7)
    --else
        --inst.components.health:SetAbsorbAmount(-16.7)
    --end

    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        inst.components.driver.landstategraph = "SGwilson"
        inst.components.driver.boatingstategraph = "SGwilsonboating"
    end

    inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE)
    
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED
    inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE)
    inst.components.combat:SetAttackPeriod(TUNING.WILSON_ATTACK_PERIOD)
    inst.components.combat:SetRange(1)
    inst.components.combat:SetAreaDamage(0, 0)
    
    inst.components.playercontroller.actionbuttonoverride = nil
    inst.components.playeractionpicker.leftclickoverride = nil
    inst.components.playeractionpicker.rightclickoverride = nil

    --inst.components.health.redirect = nil 

    --inst.Light:Enable(false)
    --GetWorld().components.colourcubemanager:SetOverrideColourCube(nil)
    --inst.components.temperature:SetTemp(nil)
    inst:DoTaskInTime(0, function() SetHUDState(inst) end)

    inst.IsWolf = false
    

    end)

end




--Creates Prince!
local function SpawnPrince(inst)
    local pt = inst:GetPosition()
    local blindprince = FindEntity(inst, 10000, function(ent)
        return ent:HasTag("blindprince")
    end)
    if blindprince then
        print("Prince is here!")
        inst.PrinceIsAlive = true --PrinceIsAlive is to prevent Princess from duplicating Princes if Princess and Prince are separated through Hamlet interior/exterior.
    elseif inst.PrinceIsAlive ~= true or not inst.PrinceIsAlive then
        print("Time to escort the Blind Prince!")
        --local theta = math.random() * 2 * PI
        pt = inst:GetPosition()
        --local radius = math.random(3, 6)
        --local offset = FindWalkableOffset(pt, theta, radius, 12, true)
        --if offset then
            local princespawn = SpawnPrefab("prince") 
            if princespawn then
                local pos = pt
                princespawn.Transform:SetPosition(pos:Get())

                if inst.ReplacePrince == true then
                    princespawn.components.hunger:SetPercent(2/3)

                    princespawn.components.health:Respawn(20)
                    --Just to make sure Prince revives with half health.
                    princespawn.components.health:SetPercent(0.5)
            
                    if princespawn.components.sanity then
                        princespawn.components.sanity:SetPercent(.5)
                    end

                    if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                        if princespawn.components.moisture then
                            princespawn.components.moisture.moisture = 0
                        end

                        if princespawn.components.temperature then
                            princespawn.components.temperature:SetTemperature(TUNING.STARTING_TEMP)
                        end
                    end
                    princespawn.HasWarped = true
                    inst.ReplacePrince = false
                end

                princespawn.sg:GoToState("sleep")
                inst.PrinceIsAlive = true
                --princespawn.components.follower:SetLeader(inst)
            end
        --end
    end

end


--Kills Princess if Prince dies. Protect him!
local function HeartBreak(inst, data)
    if data.inst:HasTag("blindprince") then
        local reviver = data.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
        if not (reviver and reviver.prefab == "amulet") and not inst.components.health:IsDead() then
            --if not data.inst.sg:HasStateTag("banished") then
                if inst.IsWolf then
                    inst.AnimState:SetBuild("wolf")
                    inst.AnimState:SetBank("wolf")
                end
               -- inst:DoTaskInTime(0.05, function()
                    --if not data.inst.CaveVictim then
                        inst:DoTaskInTime(3, function() 

                            --THIS CHECK IS FOR NON-SHIPWRECKED/HAMLET SAVES
                            if not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
                                 local resurrector = FindEntity(inst, 10000, function(ent)
                                    return ent.components.resurrector and ent.components.resurrector:CanBeUsed()
                                end)
                                if inst.components.resurrectable:CanResurrect() and not resurrector then
                                    local fx = SpawnPrefab("statue_transition_2")
                                    --inst:DoTaskInTime(3, function()    
                                    if fx then
                                        fx.Transform:SetPosition(data.inst:GetPosition():Get())
                                        fx.AnimState:SetScale(2,2,2)
                                    end
                                    data.inst:Remove()
                                end
                            end
                            
                            inst.components.health:Kill() 
                        end) --"Heartbreak" in the parentheses, so her reaction is more delayed.
                    --end
                --end)
            --end
        end
    end
end


local function OnUsePortal(inst)

    inst:AddTag("teleporting")

    for k,v in pairs(inst.components.leader.followers) do
        if not k:HasTag("blindprince") then
            k.components.follower:StopFollowing()
        elseif k:HasTag("blindprince") then

            inst:DoTaskInTime(1, function()
                if not k:HasTag("teleporting") then

                    local container = k.components.container
                    for i = 1, container:GetNumSlots() do
                        local item = container:GetItemInSlot(i)

                        if item then

                            if item:HasTag("irreplaceable") and not item:HasTag("princecloak") then

                                k.components.container:DropItem(item)

                            end

                        end

                    end

                    if not k.HasBanished then
                        k.HasWarped = true
                    end
                    
                    k.sg:GoToState("teleportato_teleport")
                end
            end)
            inst:DoTaskInTime(5, function()

                if not k:HasTag("registered") then

                    SaveGameIndex:GetSaveFollowers(GetPlayer()) 
                    --Just in case!
                    k:AddTag("registered")
                end

            end)

        end
    end

end


local function OnSave(inst, data)

    data.IsWolf = inst.IsWolf

    data.WolfHealthPercent = (inst.IsWolf == true and inst.components.health:GetPercent()) or inst.WolfHealthPercent
    data.PrincessHealthPercent = inst.PrincessHealthPercent
    data.HealthToRegen = inst.HealthToRegen

    data.PrinceIsAlive = inst.PrinceIsAlive

    data.ReplacePrince = inst.ReplacePrince

end

local function OnLoad(inst, data)
    inst.IsWolf = data.IsWolf or false

    inst.WolfHealthPercent = data.WolfHealthPercent or 1
    inst.PrincessHealthPercent = data.PrincessHealthPercent or 1
    inst.HealthToRegen = data.HealthToRegen or 0 --Wolf's health bar regenerates health, even when not in wolf form!

    inst.PrinceIsAlive = data.PrinceIsAlive or false

    inst.ReplacePrince = data.ReplacePrince or false
end



local fn = function(inst)


    --Helps Prince find her!
    inst:AddTag("liarprincess")

    inst.components.health:SetMaxHealth(50)

    --Princess takes more damage than Wolf!
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --inst.components.health:SetAbsorptionAmount(-16.7)
    --else
        --inst.components.health:SetAbsorbAmount(-16.7)
    --end

    inst.components.hunger:SetMax(150)
    inst.components.hunger:SetKillRate(150/TUNING.STARVE_KILL_TIME)
    inst.components.sanity:SetMax(200)

    --Can eat monster meat!
    inst.components.eater:SetCanEatHorrible()
    if not IsDLCEnabled(REIGN_OF_GIANTS) and not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
        inst.components.eater.strongstomach = true
    end
    inst.components.eater.monsterimmune = true

    --inst:DoTaskInTime(0, function()
        --inst:RemoveEventCallback("oneatsomething", inst.components.wisecracker, inst)
    --end)

    --inst:ListenForEvent("oneat", oneat)

    inst:ListenForEvent("oneatsomething", oneat)

    --inst.components.talker.special_speech = true


    inst.components.sanity.custom_rate_fn = sanityfn --Princess is afraid of fire!


    inst.OnSave = OnSave
    inst.OnLoad = OnLoad


    --inst.IsWolf = inst.IsWolf

    if not inst.IsWolf then
        inst.healthregen = inst:DoPeriodicTask(10, function() inst.HealthToRegen = inst.HealthToRegen + 3 end)
        inst.AnimState:SetBank("wilson")
        inst.AnimState:SetBuild("princess")
    else
        inst.AnimState:SetBuild("wolf")
        inst.AnimState:SetBank("wolf")
    end

    --Adds Wolf's night vision!
    --inst.entity:AddLight()
    --inst.Light:Enable(false)
    --inst.Light:SetRadius(5)
    --inst.Light:SetFalloff(.5)
    --inst.Light:SetIntensity(.6)
    --inst.Light:SetColour(245/255,220/255,150/255)
    --inst:DoTaskInTime(0,function()
        --if inst:HasTag("lightsource") then       
           --inst:RemoveTag("lightsource")    
        --end
    --end)  


    --Spawn Prince in if he hasn't died and isn't present!
    inst:DoTaskInTime(0.01, function()
        if not inst.ReplacePrince then
            SpawnPrince(inst)
        end

        if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
            inst:ListenForEvent( "princemoisture", CheckPrinceWetness)
        end
    end)


    inst:ListenForEvent( "checkprincestatus", CheckPrinceStatus)


    --Princess will die of heartbreak if Prince dies!
    inst:ListenForEvent("entity_death", function(world, data) HeartBreak(inst, data) end, GetWorld())




    inst:ListenForEvent("transform_to_wolf", function(inst, data)
        
        if inst.components.playercontroller:IsEnabled() and not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") then
            CheckWolfToggle(inst)
        end

    end)
    inst:ListenForEvent("transform_to_princess", function(inst, data)
        
        if inst.components.playercontroller:IsEnabled() and not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") then
            BecomePrincess(inst)
        end

    end)

    inst:DoTaskInTime(0.1, function() --Makes sure players return to wolf form if they left their save in wolf form!
        if inst.IsWolf and inst.components.health and inst.components.health:IsDead() then
            inst.components.health:Respawn(20)
            inst.components.health:SetPercent(0.01)
            inst.IsWolf = false
            inst.WolfHealthPercent = 0.01
            inst.PrincessHealthPercent = 1
            BecomePrincess(inst)
        elseif inst.IsWolf and inst.components.health and not inst.components.health:IsDead() then
            BecomeWolf(inst)
        end
    end)


    if IsDLCEnabled(PORKLAND_DLC) then
        --Being a wild animal, Princess is immune to hayfever.
        inst.components.hayfever.hayfeverimune = false

        --Princess can understand other creatures naturally!
        inst:AddTag("antlingual")
        inst:ListenForEvent("itemlose", function(it, data)
            
            --if (data.newitem and data.newitem.prefab == "pheromonestone") or (data.item and data.item.prefab == "pheromonestone") then
                inst:DoTaskInTime(0.1, function()
                    if not inst:HasTag("antlingual") then
                        inst:AddTag("antlingual")
                    end
                end)
            --end

        end)

        inst:ListenForEvent("sanity_stun", function(inst, data)
            
            local prince = FindEntity(inst, 20, function(ent)
                return ent:HasTag("blindprince")
            end)
            if prince then
                
                prince:PushEvent("sanity_stun", {duration = 3.5})

            end

        end)

        --Princess's magic reacts to the Aporkalypse!
        inst:ListenForEvent( "daycomplete", function(i, data)

                --The Aporkalypse moon randomly alternates Princess's form that she'll have to endure for the day.
            if SaveGameIndex:IsModePorkland() then
                if GetClock():IsNight() and GetClock():GetMoonPhase() == "full" and GetWorld().prefab ~= "cave" and not inst:HasTag("ironlord") and GetSeasonManager():IsAporkalypse() and not inst.components.health:IsDead() then
                    if math.random() < 0.50 and not inst.IsWolf then 
                        --Give time before forced transformation in case the save laods with an uninterruptable animation.
                        inst:DoTaskInTime(2, function()
                            BecomeWolf(inst)
                        end)
                    elseif inst.IsWolf and not inst.components.health:IsDead() then
                        inst:DoTaskInTime(2, function()
                            --Give time before forced transformation in case the save laods with an uninterruptable animation.
                            BecomePrincess(inst)
                        end)
                    end
                end
            end

        end, 
        GetWorld())

    end


    inst:ListenForEvent("nighttime", function(global, data)
        if IsDLCEnabled(PORKLAND_DLC) then
            --Princess's Aporkalypse curse is handled in the "daycomplete" event.
            if GetClock():GetMoonPhase() == "full" and GetWorld().prefab ~= "cave" and not inst.IsWolf and not inst:HasTag("ironlord") and not (SaveGameIndex:IsModePorkland() and GetSeasonManager():IsAporkalypse()) and not inst.components.health:IsDead() then
                inst:DoTaskInTime(2, function()
                    --Give time before forced transformation in case the save laods with an uninterruptable animation.
                    if GetClock():IsNight() and GetClock():GetMoonPhase() == "full" then
                        BecomeWolf(inst)
                    end
                end)
            end
        elseif GetClock():GetMoonPhase() == "full" and GetWorld().prefab ~= "cave" and not inst.IsWolf and not inst:HasTag("ironlord") and not IsDLCEnabled(PORKLAND_DLC) and not inst.components.health:IsDead() then
            inst:DoTaskInTime(2, function()
                --Give time before forced transformation in case the save laods with an uninterruptable animation.
                BecomeWolf(inst)
            end)
        end
    end, 
    GetWorld())

    inst:ListenForEvent( "equip", function(inst, data)
        if inst.IsWolf then

            local handslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if handslot then
                handslot.components.equippable:Unequip(inst)
                inst.components.inventory:RemoveItem(handslot)
                inst.components.inventory:DropItem(handslot, true, true)
            end

            local bodyslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
            if bodyslot then
                bodyslot.components.equippable:Unequip(inst)
                inst.components.inventory:RemoveItem(bodyslot)
                inst.components.inventory:DropItem(bodyslot, true, true)
            end

            local headslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
            if headslot then
                headslot.components.equippable:Unequip(inst)
                inst.components.inventory:RemoveItem(headslot)
                inst.components.inventory:DropItem(headslot, true, true)
            end

            --Delayed so that the shadow grows after an umbrella removal.
            inst:DoTaskInTime(0.05, function()
                inst.DynamicShadow:SetSize( 3.9, 1.8 )
            end)

        end

        --Princess is afraid of fire!
        local handslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if handslot and handslot.prefab == "torch" then
                inst:DoTaskInTime(math.random( 1, 2 ), function() 
                    if handslot.components.inventoryitem:IsHeldBy(GetPlayer()) then
                        local scaredprincess = {"I'm too scared!", "It's too scary!", "No, I can't do it!", "Ahhh, I don't wanna hold it!"}
                        inst.components.talker:Say(scaredprincess[math.random(1, #scaredprincess)])
                        inst.sg:GoToState("hit")
                        inst.components.inventory:DropItem(handslot, true, true)
                    end
                end)
            end
        local headslot = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
            if headslot and headslot.prefab == "candlehat" then
                inst:DoTaskInTime(math.random( 1, 2 ), function() 
                    if headslot.components.inventoryitem:IsHeldBy(GetPlayer()) then
                        local scaredprincess = {"I'm too scared!", "It's too scary!", "No, I can't do it!", "Ahhh, I don't wanna hold it!"}
                        inst.components.talker:Say(scaredprincess[math.random(1, #scaredprincess)])
                        inst.sg:GoToState("hit")
                        inst.components.inventory:DropItem(headslot, true, true)
                    end
                end)
            end

    end) 


    --Have Prince lose sanity from wormhole jumps too!
    inst:ListenForEvent("wormholespit", function(inst)
        
        for k,v in pairs(inst.components.leader.followers) do

            if k:HasTag("blindprince") then
                --k.sg:GoToState("wakeup")
            --end
                if k.components.sanity then
                    k.components.sanity:DoDelta(-TUNING.SANITY_MED)
                end
            end
        end

    end)

    --Have Prince warp with Princess if she has a place to resurrect!
    inst:ListenForEvent("death", function(inst)
        
        --Try to make Prince warp with Princess across worlds if the resurrector is in another world!
        local resurrector = FindEntity(inst, 10000, function(ent)
                return ent.components.resurrector and ent.components.resurrector:CanBeUsed()
            end)
        if inst.components.resurrectable:CanResurrect() and not resurrector then
            inst:DoTaskInTime(2, function() 

            if inst.IsWolf then
                inst.components.health:Respawn(20)
                inst.components.health:SetPercent(0.01)

                inst.components.health:SetInvincible(true)
            end

            for k,v in pairs(inst.components.leader.followers) do
                if not k:HasTag("blindprince") then
                    k.components.follower:StopFollowing()

                elseif k:HasTag("blindprince") then
                    if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                    print("Prince needs to be \"alive\" for this to work!")
                    k.components.health:Respawn(20)
                    k.components.health:SetPercent(0.5)
                    k.components.health:SetInvincible(true)
                    local fx = SpawnPrefab("statue_transition_2")
                    --inst:DoTaskInTime(3, function()    
                        if fx then
                            fx.Transform:SetPosition(k:GetPosition():Get())
                            fx.AnimState:SetScale(2,2,2)
                        end
                    --end)
                    --k.components.container:DropEverything()
                    inst:DoTaskInTime(0.05, function()
                        if SaveGameIndex:GetCurrentMode() ~= "adventure" then --Prevent Princess from duplicating princes when she dies in Adventure Mode.
                            SaveGameIndex:GetSaveFollowers(GetPlayer())
                        end
                    end)
                    end
                end
            end

            end)
        end


    end)

    --if not IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC) then
        --SaveGameIndex:LoadSavedFollowers(GetPlayer())
    --end

    --Have Prince load in where Princess is!
    inst:ListenForEvent("resurrect", function(inst)

        local effigy = FindEntity(inst, 3, function(ent)
            return ent.prefab == "resurrectionstatue"
        end)

        --Prevent Wolf from getting stuck if getting resurrected by a meat effigy.
        if effigy then

            inst.AnimState:SetBank("wilson")
            inst.AnimState:SetBuild("princess")
            inst:SetStateGraph("SGwilson")

            if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
                inst.components.driver.landstategraph = "SGwilson"
                inst.components.driver.boatingstategraph = "SGwilsonboating"
            end

            BecomePrincess(inst)

        elseif not effigy then

            if inst.IsWolf then
                inst.AnimState:SetBuild("wolf")
                inst.AnimState:SetBank("wolf")
            end

        end
        
        inst:DoTaskInTime(3, function()

            local prince = FindEntity(inst, 10000, function(ent)
                return ent:HasTag("blindprince")
            end)
            if prince then

                local offset = FindWalkableOffset(inst:GetPosition(), math.random()*2*PI, 5, 5) or Vector3(0,0,0)
                local pos = inst:GetPosition() + offset
                prince.components.follower:StopFollowing()
                prince.components.locomotor:StopMoving()

                prince.components.hunger:SetPercent(2/3)

                prince.components.health:Respawn(20)
                --Just to make sure Prince revives with half health.
                prince.components.health:SetPercent(0.5)
            
                if prince.components.sanity then
                    prince.components.sanity:SetPercent(.5)
                end

                if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
                    if prince.components.moisture then
                        prince.components.moisture.moisture = 0
                    end

                    if prince.components.temperature then
                        prince.components.temperature:SetTemperature(TUNING.STARTING_TEMP)
                    end
                end

                prince.sg:GoToState("sleep")

                prince.Transform:SetPosition(pos:Get())

                local fx = SpawnPrefab("statue_transition_2")
                if fx then
                    fx.Transform:SetPosition(prince:GetPosition():Get())
                    fx.AnimState:SetScale(2,2,2)
                end

                --This is to get rid of Prince's former boat badge.
                if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
                    inst:DoTaskInTime(0.5, function()
                        CheckPrinceBoatStatus(inst)
                    end)
                end

                if IsDLCEnabled(PORKLAND_DLC) then
                    local pt = prince:GetPosition()
                    local tile = GetWorld().Map:GetTileAtPoint(pt.x,pt.y,pt.z)
                    if tile == GROUND.INTERIOR then
                        if not prince.IsIndoors then
                            prince.IsIndoors = true
                        end
                        prince.HouseSanity = TUNING.SANITY_PLAYERHOUSE_GAIN
                    elseif tile ~= GROUND.INTERIOR then
                        if prince.IsIndoors then
                            prince.IsIndoors = false
                        end
                        prince.HouseSanity = 0
                    end
                end

            elseif not prince then

                inst.PrinceIsAlive = false
                inst.ReplacePrince = true
                --inst:DoTaskInTime(3, function()
                    SpawnPrince(inst)
                --end)

            end

        end)


    end)



    --Get Prince to follow through the Seaworthy!
    inst:ListenForEvent( "shipwrecked_portal", OnUsePortal)

    --Get Prince to follow through the Skyworthy!
    inst:ListenForEvent( "porkland_portal", OnUsePortal)


    --Make Prince stop following Princess when she uses a living artifact!
    inst:ListenForEvent( "livingartifactoveron", function(inst)

        inst.components.leader:RemoveFollowersByTag("blindprince")

    end)


    --If Prince is on a boat, display his boat's health status!
    if (IsDLCEnabled(CAPY_DLC) and not IsDLCEnabled(PORKLAND_DLC)) or (IsDLCEnabled(PORKLAND_DLC)) then
        inst:DoTaskInTime(0.5, function()
            inst:ListenForEvent("princeboating", CheckPrinceBoatStatus)
        end)
    end

    inst.components.inventory:GuaranteeItems({"princecloak"})

    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("princess_icon.tex")


        inst.soundsname = "liarprincess"

        STRINGS.CHARACTERS.PRINCESS = require "speech_princess"


end

return MakePlayerCharacter("princess", prefabs, assets, fn)
