--Wolf test!

local assets =
{
    Asset("ANIM", "anim/wolf.zip"),
    --Asset("ANIM", "anim/werebeaver_build.zip"),

}

local prefabs =
{
	"tigersharkshadow",
    "splash_water_big",
    "groundpound_fx",
    "groundpoundring_fx",
    "mysterymeat",
    "fish_raw",
    "tigereye",
    "shark_gills",
}

SetSharedLootTable('tigershark',
{
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},

    {"tigereye", 1.00},
    {"tigereye", 0.50},

    {"shark_gills", 1.00},
    {"shark_gills", 1.00},
    {"shark_gills", 0.33},
    {"shark_gills", 0.10},
})

local brain = require "brains/wolfiebrain"

local function ShouldSleep(inst)
    return false
end

local function ShouldWake(inst)
    return true
end

local function GroundTypesMatch(inst, target)
    local target = target or GetTarget(inst)

    if target then
        if target.prefab then
            return inst:HasTag("aquatic") == target:HasTag("aquatic")
        elseif target.x and target.y and target.z then
            local tar_tile = GetMap():GetTileAtPoint(target:Get())
            return WorldSim:IsWater(tar_tile) == inst:GetIsOnWater()
        end
    end

    return true
end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
end

local function RetargetFn(inst)
        return FindEntity(inst, 20, 
            function(guy) 
            return guy.components.combat and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
        end)
end

local function KeepTargetFn(inst, target)
        return inst.components.combat:CanTarget(target)
end

local function ontimerdone(inst, data)
    if data.name == "Run" then
        inst.CanRun = true
    end
end

local function OnSave(inst, data)
    data.CanRun = inst.CanRun
    data.NextFeedTime = GetTime() - inst.NextFeedTime
end

local function OnLoad(inst, data)
    if data then
        inst.CanRun = data.CanRun or true
        inst.NextFeedTime = data.NextFeedTime or 0
    end
end

local function fn()

	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.Transform:SetFourFaced()
    inst.DynamicShadow:SetSize( 6, 3 )
    inst.DynamicShadow:Enable(false)

    inst:AddTag("scarytoprey")
    inst:AddTag("largecreature")
    
    MakePoisonableCharacter(inst)
    MakeCharacterPhysics(inst, 1000, 1.33)

	inst:AddComponent("locomotor")
	inst.components.locomotor.walkspeed = TUNING.TIGERSHARK_WALK_SPEED
	inst.components.locomotor.runspeed = TUNING.TIGERSHARK_RUN_SPEED

    inst.AnimState:SetBank("wolf")
    inst.AnimState:SetBuild("wolf")

    inst.AnimState:SetRayTestOnBB(true)

    inst:AddComponent("inspectable")
    inst.no_wet_prefix = true

	inst:AddComponent("knownlocations")

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.TIGERSHARK_HEALTH)

    inst:AddComponent("eater")
    inst.components.eater.foodprefs = { "MEAT" }
    inst.components.eater.ablefoods = { "MEAT", "VEGGIE", "GENERIC" }

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('tigershark')

    inst:AddComponent("groundpounder")
    inst.components.groundpounder.destroyer = true
    inst.components.groundpounder.damageRings = 3
    inst.components.groundpounder.destructionRings = 1
    inst.components.groundpounder.numRings = 3
    inst.components.groundpounder.noTags = {"sharkitten"}

    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.TIGERSHARK_DAMAGE)
    inst.components.combat:SetRange(TUNING.TIGERSHARK_ATTACK_RANGE, TUNING.TIGERSHARK_ATTACK_RANGE)
    inst.components.combat:SetAreaDamage(TUNING.TIGERSHARK_SPLASH_RADIUS, TUNING.TIGERSHARK_SPLASH_DAMAGE/TUNING.TIGERSHARK_DAMAGE)
    inst.components.combat:SetAttackPeriod(TUNING.TIGERSHARK_ATTACK_PERIOD)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetHurtSound("dontstarve_DLC001/creatures/bearger/hurt")
    --inst.components.combat.canbeattackedfn = CanBeAttacked
    inst.components.combat.notags = {"sharkitten"}

    inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(4)
    inst.components.sleeper:SetSleepTest(ShouldSleep)
    inst.components.sleeper:SetWakeTest(ShouldWake)

    inst:ListenForEvent("killed", function(inst, data)
        if inst.components.combat and data and data.victim == inst.components.combat.target then
            inst.components.combat.target = nil
        end
    end)

    inst.CanRun = true --Can do charge attack

    inst.CanFly = false --Can do leap attack

    inst.AttackCounter = 0
    inst.OnSave = OnSave
    inst.OnLoad = OnLoad

    inst:SetStateGraph("SGwolfie")
    inst:SetBrain(brain)

    inst:AddComponent("timer")
    inst:ListenForEvent("timerdone", ontimerdone)
    inst:ListenForEvent("attacked", OnAttacked)

	return inst
end

return Prefab("wolfie", fn, assets, prefabs)