local function SetHUDState(inst)
    if inst.HUD then

        if inst.IsWolf then

            inst.HUD.controls.crafttabs:Hide()

            inst.HUD.controls.mapcontrols.minimapBtn:Hide()
        
        else

        if not inst.IsWolf then

            inst.HUD.controls.crafttabs:Show()
            --inst.HUD.controls.inv:Show()
            --inst.HUD.controls.status:Show()
            inst.HUD.controls.mapcontrols.minimapBtn:Show()

            end

        end

    end

end

--Changes Wolf to Princess!
local function BecomePrincess(inst)


    --Get Prince to follow Princess again if he is close by!
    --local x,y,z = inst.Transform:GetWorldPosition()
    --    local ents = TheSim:FindEntities(x,y,z, 10, {"prince"})
    --    for k,v in pairs(ents) do
    --        if (not v.components.health or not v.components.health:IsDead() ) and v.components.follower and not v.components.follower.leader and not inst.components.leader:IsFollower(v) then
    --           inst.components.leader:AddFollower(v)
    --        end
    --    end


    inst.ActionStringOverride = nil
    inst.AnimState:SetBank("wilson")
    inst.AnimState:SetBuild("princess")
    inst:AddTag("liarprincess")
    if inst:HasTag("NOVACUUM") then
        inst:RemoveTag("NOVACUUM") --To prevent Sealnado bugs.
    end
    inst:RemoveTag("monster")
    inst:RemoveTag("largecreature")
    --inst:RemoveTag("hound")
    inst:RemoveTag("wolf")

    inst.DynamicShadow:SetSize( 1.3, .6 )

    if inst.components.worker then
        inst:RemoveComponent("worker")
    end


    --Princess does not have night vision!
    --inst.Light:Enable(false)
    --GetClock():SetNightVision(false)
    --GetWorld().components.colourcubemanager:SetOverrideColourCube(nil)

    inst.WolfHealthPercent = inst.components.health:GetPercent()
    inst.components.health:SetMaxHealth(40)
    --inst.components.health:SetPercent(inst.PrincessHealthPercent)
    inst.HealthToRegen = 0
    inst.healthregen = inst:DoPeriodicTask(5, function() inst.HealthToRegen = inst.HealthToRegen + 5 end)

    --Princess takes more damage than Wolf!
    --if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
        --inst.components.health:SetAbsorptionAmount(-16.7)
    --else
        --inst.components.health:SetAbsorbAmount(-16.7)
    --end

    inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE)
    
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED
    inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE)
    inst.components.combat:SetRange(1)
    inst.components.combat:SetAreaDamage(0, 0)
    
    inst.components.playercontroller.actionbuttonoverride = nil
    inst.components.playeractionpicker.leftclickoverride = nil
    inst.components.playeractionpicker.rightclickoverride = nil

    --inst.components.health.redirect = nil 

    --inst.Light:Enable(false)
    --GetWorld().components.colourcubemanager:SetOverrideColourCube(nil)
    --inst.components.temperature:SetTemp(nil)
    inst:DoTaskInTime(0, function() SetHUDState(inst) end)

    inst.IsWolf = false

    inst:SetStateGraph("SGwilson")

end


local actionhandlers =
{
    ActionHandler(ACTIONS.PICK, 
    function(inst, action)
        if action.target.components.pickable then
            if action.target.components.pickable.quickpick then
                return "doshortaction"
            else
                return "dolongaction"
            end
        end
    end),
    ActionHandler(ACTIONS.DROP, "doshortaction"),
    ActionHandler(ACTIONS.PICKUP,
    function(inst, action)
        if action.target.components.inventoryitem then
            if action.target.components.inventoryitem.longpickup then
                return "dolongaction"
            end
        end
        return "doshortaction"
    end),
    ActionHandler(ACTIONS.STORE, "doshortaction"),
    ActionHandler(ACTIONS.COMBINESTACK, "doshortaction"),

    ActionHandler(ACTIONS.DEPLOY, "doshortaction"),
    --ActionHandler(ACTIONS.DRY, "doshortaction"),

    ActionHandler(ACTIONS.ACTIVATE, 
        function(inst, action)
            if action.target.components.activatable
            and action.target.prefab ~= "cave_entrance" and action.target.prefab ~= "cave_exit" 
            and action.target.prefab ~= "shipwrecked_entrance" and action.target.prefab ~= "shipwrecked_exit"
            and action.target.prefab ~= "porkland_entrance" and action.target.prefab ~= "porkland_exit"
            and action.target.prefab ~= "teleportato_base" and action.target.prefab ~= "teleportato_checkmate" 
            and action.target.prefab ~= "teleportato_sw_base" and action.target.prefab ~= "teleportato_hamlet_base" 
            and action.target.prefab ~= "volcano"  and action.target.prefab ~= "volcano_exit"
            and action.target.prefab ~= "adventure_portal" then
                if action.target.components.activatable.standingaction or action.target.components.activatable.quickaction then
                    return "doshortaction"
                else
                    return "dolongaction"
                end
            end
        end),

    ActionHandler(ACTIONS.MURDER, "dolongaction"),

    ActionHandler(ACTIONS.JUMPIN, "jumpin"),

	ActionHandler(ACTIONS.EAT, "eat"),
}

local events =
{
    CommonHandlers.OnSleep(),
    
    CommonHandlers.OnDeath(),
    CommonHandlers.OnAttack(),

	CommonHandlers.OnLocomote(true, false),

    EventHandler("attacked", function(inst, data)
        if not inst.components.health:IsDead() then
            if (data.attacker and (data.attacker:HasTag("insect") or data.attacker:HasTag("twister"))) or inst.sg:HasStateTag("not_hit_stunned") then
                local is_idle = inst.sg:HasStateTag("idle")
                if not is_idle then
                    -- avoid stunlock when attacked by bees/mosquitos.
                    -- don't go to full hit state.
                    return
                end
            end
                    if not inst:HasTag("not_hit_stunned") then
                        if data.stimuli and data.stimuli == "electric" and not inst.components.inventory:IsInsulated() then
                            inst.sg:GoToState("electrocute")
                        return
                        end
                    end
                    if not inst.sg:HasStateTag("busy") then
                        inst.sg:GoToState("hit")
                    end
        end
    end),

    EventHandler("death", function(inst, data)
        if data.cause == "drowning" then
            inst.sg:GoToState("wolf_death_boat")
        else
            inst.sg:GoToState("death")
        end
    end),

    EventHandler("wakeup",
        function(inst)
            inst.sg:GoToState("wakeup")
        end),     

	EventHandler("freeze", 
        function(inst)
            if inst.components.health and inst.components.health:GetPercent() > 0 then
                inst.sg:GoToState("frozen")
            end
        end),

    EventHandler("sneeze", function(inst, data)
        if not inst.components.health:IsDead() and not inst.components.health.invincible then
            if inst.sg:HasStateTag("busy") then
                inst.wantstosneeze = true
            else
                inst.sg:GoToState("sneeze")
            end
        end
    end),    
}


local statue_symbols = 
{
    "ww_head",
    "ww_limb",
    "ww_meathand",
    "ww_shadow",
    "ww_torso",
    "frame",
    "rope_joints",
    "swap_grown"
}


local states =
{

    State{
        name = "transform",
        tags = {"busy"},

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.components.playercontroller:Enable(true)
            inst.components.hunger:Resume()
            inst.AnimState:PlayAnimation("transform")
        end,

        timeline =
        {
            TimeEvent(4*FRAMES, function(inst)
                --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/howl")
            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    },

    State{
        name = "revert",
        tags = {"busy"},

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.AnimState:PlayAnimation("revert")
        end,

        timeline =
        {
            TimeEvent(4*FRAMES, function(inst)
                --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/death")
            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    },

    State{
        name = "wakeup",
        tags = {"busy"},

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            inst.AnimState:SetBuild("wolf")
            inst.AnimState:SetBank("wolf")
            inst.AnimState:PlayAnimation("wakeup")
            inst.components.playercontroller:Enable(false)
            inst.components.health:SetInvincible(true)
        end,

        onupdate = function(inst)
            inst.AnimState:SetBuild("wolf")
            inst.AnimState:SetBank("wolf")
        end,
        
        onexit = function(inst)
            inst.components.playercontroller:Enable(true)
            inst.components.health:SetInvincible(false)
        end,

        timeline =
        {
            TimeEvent(30*FRAMES, function(inst)
                --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/howl")
            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    },

    State{
        name = "wolf_death_boat",
        tags = {"busy"},

        onenter = function(inst)
            inst.components.health:StopRegen()
            --inst.components.driver:SplitFromVehicle()
            --inst.components.driver:CombineWithVehicle()
            inst.components.locomotor:Stop()
            inst.last_death_position = inst:GetPosition()
            inst.AnimState:SetBuild("wolf")
            inst.AnimState:SetBank("wolf_drowning")
            inst.AnimState:PlayAnimation("boat_death")
            inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/death")
        end,

        onupdate = function(inst)
            inst.AnimState:SetBuild("wolf")
            inst.AnimState:SetBank("wolf_drowning")
        end,

        onexit= function(inst) 
            inst.DynamicShadow:Enable(true) 
        end,

        timeline=
        {
            TimeEvent(70*FRAMES, function(inst)
                inst.DynamicShadow:Enable(false)
            end),
        },
    },

    State{
        name = "idle",
        tags = {"idle", "canrotate"},

        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("idle")
            
            if IsDLCEnabled(PORKLAND_DLC) then
                if inst.wantstosneeze then
                    inst.sg:GoToState("sneeze")
                end
            end
            --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/idle")
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end)
        },
    },


    State{
        name = "doshortaction",
        tags = {"doing", "busy"},
        
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("pickup")
            inst.sg:SetTimeout(6*FRAMES)
        end,
        
        
        timeline=
        {
            TimeEvent(4*FRAMES, function( inst )
                inst.sg:RemoveStateTag("busy")
            end),
            TimeEvent(10*FRAMES, function( inst )
            inst.sg:RemoveStateTag("doing")
            inst.sg:AddStateTag("idle")
            end),
        },
        
        ontimeout = function(inst)
            inst:PerformBufferedAction()
            
        end,
        
        events=
        {
            EventHandler("animover", function(inst) if inst.AnimState:AnimDone() then inst.sg:GoToState("idle") end end ),
        },
    },
    
    
    State{
        name = "dolongaction",
        tags = {"doing", "busy"},
        
        timeline=
        {
            TimeEvent(4*FRAMES, function( inst )
                inst.sg:RemoveStateTag("busy")
            end),
        },
        
        onenter = function(inst, timeout)
            inst.sg:SetTimeout(timeout or 1)
            inst.components.locomotor:Stop()
            inst.SoundEmitter:PlaySound("dontstarve/wilson/make_trap", "make")
            
            inst.AnimState:PlayAnimation("build_pre")
            inst.AnimState:PushAnimation("build_loop", true)
        end,
        
        ontimeout= function(inst)
            inst.AnimState:PlayAnimation("build_pst")
            inst.sg:GoToState("idle", false)
            inst:PerformBufferedAction()
        end,
        
        onexit= function(inst)
            inst.SoundEmitter:KillSound("make")
        end,
        
    },


    State{
        name = "jumpin",
        tags = {"doing", "canrotate"},
        
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("jump")

            inst:DoTaskInTime(4.7, function(inst) inst.SoundEmitter:PlaySound("dontstarve/movement/bodyfall_dirt", "bodyfall") end )
        end,
        
        timeline =
        {
            -- this is just hacked in here to make the sound play BEFORE the player hits the wormhole
            TimeEvent(19*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/common/teleportworm/travel", "wormhole_travel") end),
        },

        events=
        {
            EventHandler("animover", function(inst)
                inst:PerformBufferedAction()
                inst.sg:GoToState("idle") 
            end ),
        },
    },


    State{
    	name = "eat",
    	tags = {"busy", "canrotate"},

    	onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("eat")
    	end,

        timeline =
        {
            TimeEvent(10*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/bite")
                inst:PerformBufferedAction()
            end)
        },

    	events =
    	{
            EventHandler("animqueueover", function(inst)
                inst.sg:GoToState("idle")
            end)
    	},
	},

    State{
        name = "attack",
        tags = {"busy", "attack"},

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            --inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("attack")
        end,

        timeline =
        {
            TimeEvent(4*FRAMES, function(inst)
                --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_attack_rear")
            end),
            TimeEvent(13*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
                inst.components.combat:DoAttack()
            end),
            TimeEvent(14*FRAMES, function(inst)
                --inst.components.combat:ResetCooldown()
            end),
            TimeEvent(21*FRAMES, function(inst)
                inst.sg:AddStateTag("secondattack")
            end),
            TimeEvent(23*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
                --inst.components.combat:StartAttack()
                inst.components.combat:DoAttack()
                inst.components.combat:DoAttack()
            end),
            TimeEvent(25*FRAMES, function(inst)
                inst.sg:RemoveStateTag("busy")
            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end),
        },
    },

    State{
        name = "hit",
        tags = {"busy", "hit", "canrotate"},

        onenter = function(inst, cb)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("hit")
        end,

        timeline =
        {
            TimeEvent(1*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/hurt")
            end),
        },

        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },

    State{
        name = "electrocute",
        tags = {"busy"},
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("shock")
            inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
            inst.fx = SpawnPrefab("shock_fx")

            inst.fx.Transform:SetRotation(inst.Transform:GetRotation())

            local pos = inst:GetPosition()
            inst.fx.Transform:SetPosition(pos.x, pos.y, pos.z)
            inst.Light:Enable(true)

            inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/hurt")
        end,

        onexit = function(inst)
            inst.Light:Enable(false)
            inst.AnimState:ClearBloomEffectHandle()
            inst.fx:Remove()
        end,
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("electrocute_pst")
            end),
        },
    },
    State{
        name = "electrocute_pst",
        tags = {"busy"},
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("run_pst")
        end,
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle") 
            end),
        },
    },

    State{
        name = "frozen",
        tags = {"busy", "frozen"},
        
        onenter = function(inst)
            inst.components.playercontroller:Enable(false)

            if inst.components.locomotor then
                inst.components.locomotor:StopMoving()
            end
            inst.AnimState:PlayAnimation("frozen")
            inst.SoundEmitter:PlaySound("dontstarve/common/freezecreature")
            --inst.AnimState:OverrideSymbol("swap_frozen", "frozen", "frozen")
        end,
        
        onexit = function(inst)
            inst.components.playercontroller:Enable(true)

            --inst.AnimState:ClearOverrideSymbol("swap_frozen")
        end,
        
        events=
        {   
            EventHandler("onthaw", function(inst) inst.sg:GoToState("thaw") end ),        
        },
    },

    State{
        name = "thaw",
        tags = {"busy", "thawing"},
        
        onenter = function(inst) 
            inst.components.playercontroller:Enable(false)

            if inst.components.locomotor then
                inst.components.locomotor:StopMoving()
            end
            inst.AnimState:PlayAnimation("frozen_loop_pst", true)
            inst.SoundEmitter:PlaySound("dontstarve/common/freezethaw", "thawing")
            --inst.AnimState:OverrideSymbol("swap_frozen", "frozen", "frozen")
        end,
        
        onexit = function(inst)
            inst.components.playercontroller:Enable(true)

            inst.SoundEmitter:KillSound("thawing")
            --inst.AnimState:ClearOverrideSymbol("swap_frozen")
        end,

        events =
        {   
            EventHandler("unfreeze", function(inst)
                if inst.sg.sg.states.hit then
                    inst.sg:GoToState("hit")
                else
                    inst.sg:GoToState("idle")
                end
            end),
        },
    },

    State{
        name = "death",
        tags = {"busy"},

        onenter = function(inst)
            inst.components.health:StopRegen()
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            --RemovePhysicsColliders(inst)
            inst.components.inventory:DropEverything()
        end,

        onupdate = function(inst)
            inst.AnimState:SetBuild("wolf")
        end,

        timeline =
        {
            TimeEvent(12*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/death")
                inst.AnimState:SetBuild("wolf")
            end),
            TimeEvent(33*FRAMES, function(inst)
                inst.AnimState:SetBuild("wolf")
                if GetSeasonManager():GetSnowPercent() > 0.02 then
                    inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/bodyfall_snow")
                else
                    inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/bodyfall_dirt")
                end    
            end),
        },

    },


    State{
        name = "rebirth",
        
        onenter = function(inst)
            inst.components.playercontroller:Enable(false)
            inst.AnimState:SetBank("wilson")
            inst.AnimState:SetBuild("princess")
            inst.AnimState:PlayAnimation("rebirth")
            
            inst.components.hunger:Pause()
            for k,v in pairs(statue_symbols) do
                inst.AnimState:OverrideSymbol(v, "wilsonstatue", v)
            end
        end,
        
        timeline=
        {
            TimeEvent(16*FRAMES, function(inst) 
                inst.SoundEmitter:PlaySound("dontstarve/common/dropwood")
            end),
            TimeEvent(45*FRAMES, function(inst) 
                inst.SoundEmitter:PlaySound("dontstarve/common/dropwood")
            end),
            TimeEvent(92*FRAMES, function(inst) 
                inst.SoundEmitter:PlaySound("dontstarve/common/rebirth")
            end),
        },
        
        onexit = function(inst)
            inst.components.hunger:Resume()
            for k,v in pairs(statue_symbols) do
                inst.AnimState:ClearOverrideSymbol(v)
            end
        
            inst.components.playercontroller:Enable(true)
        end,
        
        
        events=
        {
            EventHandler("animover", function(inst)

                BecomePrincess(inst)

            end),
        },

    },    


    State{
    	name = "taunt",
    	tags = {"busy"},

    	onenter = function(inst)
    		inst.Physics:Stop()
    		inst.AnimState:PlayAnimation("taunt")
    	end,

        timeline =
        {
            TimeEvent(10*FRAMES, function(inst)
                
            end),
        },

    	events =
    	{
    		EventHandler("animover", function(inst) inst.sg:GoToState("idle") end)
    	},
	},

    State{
        name = "sneeze",
        tags = {"busy","sneeze"},
        
        onenter = function(inst)
            inst.wantstosneeze = false
            --inst.SoundEmitter:PlaySound("dontstarve/wilson/hit",nil,.02)
            inst.AnimState:PlayAnimation("hit")
            inst.SoundEmitter:PlaySound("dontstarve_DLC003/characters/sneeze")
            inst:ClearBufferedAction()
            
            inst.components.locomotor:Stop()  

            --inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_SNEEZE"))        
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        }, 
        
        timeline =
        {
            TimeEvent(10*FRAMES, function(inst)
                if inst.components.hayfever then
                    inst.components.hayfever:DoSneezeEffects()
                end
                inst.sg:RemoveStateTag("busy")
            end),
        },        
               
    },

}

CommonStates.AddSleepStates(states,
{
    sleeptimeline = {TimeEvent(0*FRAMES, function(inst)  end)},
})
CommonStates.AddWalkStates(states,
{
    starttimeline =
    {
        TimeEvent(0, function(inst)

        end),
    },
    walktimeline =
    {
        TimeEvent(0, function(inst)

        end),
        TimeEvent(10*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
        TimeEvent(20*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
    },
    endtimeline =
    {
        TimeEvent(5, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)

        end),
    },
})
CommonStates.AddWalkStates(states,
{
    starttimeline =
    {
        TimeEvent(0*FRAMES, function(inst)

        end),
    },
    walktimeline =
    {
        TimeEvent(0*FRAMES, function(inst)

        end),
        TimeEvent(10*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
        TimeEvent(20*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
    },
    endtimeline =
    {
        TimeEvent(5, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)

        end),
    },
})
CommonStates.AddRunStates(states,
{
    starttimeline =
    {
        TimeEvent(0*FRAMES, function(inst)
        end),
    },
    runtimeline =
    {
        TimeEvent(0*FRAMES, function(inst)
        end),
        TimeEvent(6*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
        TimeEvent(24*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
    },
    endtimeline =
    {
        TimeEvent(4*FRAMES, function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/step")
            PlayFootstep(inst)
        end),
    },
},
{
    run = "run",
})

return StateGraph("wolfie", states, events, "idle", actionhandlers)
